/*!
$Id: debugcamera.h 515 2009-11-17 03:20:33Z horino $
*/
#ifndef DEBUGCAMERA_H
#define DEBUGCAMERA_H

#ifdef _DEBUG
#include <iostream>
using namespace std;
#endif

#include "indi.h"
#include "vector2.h"
#include "vector3.h"
#include "input/input.h"
#include "camera/camera.h"

namespace indi
{
	class DebugCamera : public Camera
	{
	public:
		DebugCamera() : Camera() {}
		DebugCamera(const Vector3 &p, const Vector3 &t, const Vector3 &u, const Matrix44 &prj) : Camera(p, t, u, prj) {}
		virtual ~DebugCamera() {}

		void Control(const indi::Input::State &inpStat) {
			f32 speed = 0.5f;

			//< XeBbNŒ_ړ
			Target() += (Right() * inpStat.LeftStickXf() + Up() * inpStat.LeftStickYf()) * speed;
			//< EXeBbNŃJړ
			Position() += (Right() * inpStat.RightStickXf() + Up() * inpStat.RightStickYf()) * speed;

			//< LgKŒ_ړ(O)
			Target() += Forward() * inpStat.LeftTriggerf() * speed;
			//< RgKŃJړ(O)
			f32 diff = (Position() - Target()).LengthSquared();
			if(diff > 3.0f)
				Position() += Forward() * inpStat.RightTriggerf() * speed;

			//< LV_[{^Œ_ړ()
			if (inpStat.LeftShoulder() && diff > 3.0f)
				Target() -= Forward() * speed;
			//< RV_[{^ŃJړ()
			if (inpStat.RightShoulder() )
				Position() -= Forward() * speed;
		}
	};
};

#endif // DEBUGCAMERA_H