/*!
$Id: defines.h 630 2009-12-21 07:52:59Z horino $
*/
#ifndef DEFINES_H
#define DEFINES_H

//< ASSERT
#ifndef ASSERT
#ifdef _DEBUG
#include <cassert>
#define ASSERT(b) assert(b)
#else
#define ASSERT(b) (b)
#endif
#endif

//< z̗vf
#define NELEMS(a) (sizeof(a) / sizeof(a[0]))

//< ~bg
#include <limits>
#define LIM_MIN(T) (std::numeric_limits<T>::min)()
#define LIM_MAX(T) (std::numeric_limits<T>::max)()
#define LIM_EPSILON(T) std::numeric_limits<T>().epsilon()

#ifdef PS3
#ifndef TRUE
#define TRUE true
#endif
#ifndef FALSE
#define FALSE false
#endif
#ifndef INDI_PI
#define INDI_PI M_PI
#endif
#else
#ifndef INDI_PI
#define INDI_PI D3DX_PI
#endif
#endif

#define Malloc malloc
#define Free free

#ifndef CONST
#define CONST	const
#endif

#ifndef INLINE
#define INLINE	inline
#endif

#ifndef SAFE_RELEASE
#define SAFE_RELEASE(p) 	 { if (p) { (p)->Release(); (p)=NULL; } }
#endif

#ifndef BUFFER_SIZE
#define BUFFER_SIZE 512
#endif

#ifndef SEPARATOR
#ifdef PS3
#define SEPARATOR "/"
#else 
#define SEPARATOR "\\"
#endif
#endif

//< VF[_gq
#ifndef SH_EXT
#ifdef PS3
#define SH_EXT ".cgelf"
#else
#define SH_EXT ".fxelf"
#endif
#endif

#ifndef ATTR_USED
#ifdef PS3
#define ATTR_USED __attribute__((__used__))
#else
#define ATTR_USED 
#endif
#endif

#ifndef PS3
#ifndef D3DCOMPILE_USEVOIDS
#define D3DCOMPILE_USEVOIDS
#endif
#endif

#ifdef PS3
#ifndef GL_ERROR_CHECK
#define GL_ERROR_CHECK ASSERT(glGetError() == GL_NO_ERROR)
#endif
#endif

#ifndef NAN_CHECK
#ifdef _DEBUG
#define NAN_CHECK(v) { ASSERT(v != std::numeric_limits<f32>::quiet_NaN()); ASSERT(v != std::numeric_limits<f32>::signaling_NaN()); }
#else
#define NAN_CHECK(v) 
#endif
#endif

#endif // DEFINES_H
