/*!
$Id: draw_manager.h 317 2009-08-25 03:17:28Z horino $
*/
#ifndef DRAW_MANAGER_H
#define DRAW_MANAGER_H

#include "itl/vector.h"
#include "itl/functional.h"
#include "itl/algorithm.h"
#include "utilities.h"

/*!
DrawManager ... `sGtFNgiVF[_j̎ނ̕EffectEntityi`̏Łj
   EffectEntity0 ... ̃GtFNgiVF[_jpĕ`悷DrawableEntityi`̏Łj
      DrawableEntity0 ... eX̕`揈s
      DrawableEntity1
      DrawableEntity2
      ...
   EffectEntity1
   EffectEntity2
   ...
*/
namespace indi
{
	/*!
	\brief GtFNgGeBeBx[XNX
	\note păGtFNgNX쐬܂
	*/
	template<typename indi::u32 ND>
	class EffectEntity
	{
	public:
		EffectEntity(){}
		virtual ~EffectEntity(){}

		/*!
		\brief `GeBeBx[XNX
		\note pĕ`NX쐬܂
		*/
		class DrawableEntity
		{
		public:
			friend class EffectEntity;

			DrawableEntity() : _effect(0) {}
			virtual ~DrawableEntity() {}

			virtual void Draw(){}

			EffectEntity *GetEffect() { return _effect; }

		private:
			void SetEffect(EffectEntity *e) { _effect = e; }
			EffectEntity *_effect;
		};

		void Draw() { itl::For_each(_drawables.begin(), _drawables.end(), Mem_fun(&DrawableEntity::Draw)); }

		/*!
		\brief ANV}l[W֓o^܂AXg̍Ōɒǉ܂
		\note ǉANṼCfbNXԂ܂
		*/
		u32 Regist(DrawableEntity *d) { u32 n(_drawables.size()); d->SetEffect(this); _drawables.push_back(d); return n; }
		void Clear() { _drawables.clear(); }

		/*!
		\brief CfbNXɂANZX
		*/
		DrawableEntity *operator[](u32 i) const { ASSERT(i < _drawables.size()); return _drawables[i]; }

	private:
		itl::Vector<DrawableEntity *, ND> _drawables;
	};

	/*!
	\brief `}l[W
	*/
	template<typename indi::u32 NE, typename indi::u32 ND>
	class DrawManager
	{
	public:
		DrawManager(){}
		~DrawManager(){ itl::For_each(_effects.begin(), _effects.end(), Delete()); }

		void Draw() { itl::For_each(_effects.begin(), _effects.end(), Mem_fun(&EffectEntity<ND>::Draw)); }
		void ClearEffects() { itl::For_each(_effects.begin(), _effects.end(), Mem_fun(&EffectEntity<ND>::Clear)); }

		/*!
		\brief ANV}l[W֓o^܂AXg̍Ōɒǉ܂
		\note ǉANṼCfbNXԂ܂
		*/
		u32 PushBack(EffectEntity<ND> *e) { u32 n(_effects.size()); _effects.push_back(e); return n; }

		/*!
		\brief CfbNXɂANZX
		*/
		EffectEntity<ND> *operator[](u32 i) const { ASSERT(i < _effects.size()); return _effects[i]; }

	private:
		itl::Vector<EffectEntity<ND> *, NE> _effects;
	};
};

#endif //< DRAW_MANAGER_H