/*!
$Id: font.h 588 2009-12-02 06:36:38Z horino $
*/
#ifndef FONT_H
#define FONT_H

#ifdef _DEBUG
#include <iostream>
using namespace std;
#endif

#include "indi.h"
#include "sprite/sprite.h"
#include "vector2.h"

namespace indi
{
	class Font : public Sprite
	{
	public:
		Font(const char *path) : Sprite(path), _prev_x(0) {}
		virtual ~Font(){}

		void Locate(u32 x, u32 y) { SetPosition(x, y); _prev_x = x; }
		void LocateRatio(f32 x, f32 y) { SetPositionRatio(x, y); _prev_x = static_cast<u32>(x * graphics::System::GetScreenWidth()); }

		virtual f32 GetLineSpace() const = 0;
		virtual f32 Draw(const char *s) = 0;

		virtual void Begin() {}
		void Puts(const char *s);
		void Printf(const char *fmt, ...);
		virtual void End() {}

		class AutoBegin
		{
		public:
			AutoBegin(Font &f) : _font(f) { _font.Begin(); }
			~AutoBegin(){ _font.End(); }
		private:
			Font &_font;
		};

		/*!
		\brief pǂ
		\retval p : TRUE
		\retval 񔼊p : FALSE
		*/
		static BOOL Is8BitChar(const char c){ return ((c & 0xff) <= 0x80) ? TRUE : FALSE; }

		static const char *Split(const char *buf, const char delim, char *dst);

		/*!
		\brief obt@Pso܂
		\param obt@
		\param PsofXeBl[V
		\return fXeBl[V
		*/
		static const char *GetLine(const char *buf, char *dst) { return Split(buf, '\n', dst); }

	protected:
		u32 _prev_x;
	};
}

#endif //< FONT_H
