/*!
  $Id: vector.h 531 2009-11-19 03:33:59Z horino $
*/
#ifndef VECTOR_H
#define VECTOR_H

#include "utilities.h"
#include "defines.h"
#include "typedefs.h"
using namespace indi;

/*!
  \brief iSTLjŒ蒷xN^

  \note TCYiŒ蒷jw肵ĎgĂ
  Vector<HOGE, 100> hoges;
*/
namespace indi
{
	namespace itl
	{
		template<typename T, u32 N>
		class Vector
		{
		public:
			typedef T value_type;
			typedef value_type *pointer;
			typedef const value_type *const_pointer;
			typedef value_type *iterator;
			typedef const value_type *const_iterator;
			typedef value_type &reference;
			typedef const value_type &const_reference;
			typedef u32 size_type;
			//typedef ptrdiff_t difference_type;
			//typedef reverse_iterator<const_iterator> const_reverse_iterator;
			//typedef reverse_iterator<iterator> reverse_iterator;
	
			iterator begin(){ return _start; }
			const_iterator begin() const { return _start; }
	
			iterator end() { return _finish; }
			const_iterator end() const { return _finish; }

			//reverse_iterator rbegin(){ return reverse_iterator(end()); }
			//const_reverse_iterator rbegin() const { return const_reverse_iterator(end()); }
	
			//reverse_iterator rend() { return reverse_iterator(begin()); }
			//const_reverse_iterator rend() const { return const_reverse_iterator(begin()); }

			size_type size() const { return size_type(end() - begin()); }
			size_type capacity() const { return N; }
			BOOL empty() const { return begin() == end(); }

			reference operator[](size_type n){ return *(begin() + n); }
			const_reference operator[](size_type n) const { return *(begin() + n); }

			reference at(size_type n){ ASSERT(n < N); return (*this)[n]; }
			const_reference at(size_type n) const { ASSERT(n < N); return (*this)[n]; }

			void operator=(const Vector &rhs){
				Memcpy(_storage, rhs._storage, sizeof(T) * rhs.size());
				_start = &_storage[0];
				_finish = &_storage[rhs.size()];
			}

			explicit Vector() : _start(&_storage[0]), _finish(&_storage[0]) {}
			Vector(const Vector &rhs) : _start(&_storage[0]), _finish(&_storage[rhs.size()]) { 
				Memcpy(_storage, rhs._storage, sizeof(T) * rhs.size()); 
			}
			~Vector(){}

			reference front() { return *begin(); }
			const_reference front() const { return *begin(); }

			reference back() { return *(end() - 1); }
			const_reference back() const { return *(end() - 1); }

			void push_back(const T &v) {
#ifdef _DEBUG
				ASSERT(_finish < &_storage[N]);
#endif
				*_finish++ = v; 
			}
			void pop_back() { --_finish; }

			void clear() { _start = _finish = _storage; }
	
		private:
			T *_start;
			T *_finish;
			T _storage[N];
		};
	};
};

#endif
