/*!
$Id: dds_header.h 444 2009-10-23 09:53:28Z horino $
*/
#ifndef DDS_HEADER_H
#define DDS_HEADER_H

#include "indi.h"

namespace indi
{
	namespace mesh
	{
		/*!
		\brief DDSt@Cwb_
		*/
		class DDSHeader
		{
		public:
			u32 _size;
			u32 _flags;
			u32 _height;
			u32 _width;
			u32 _pitch_or_linear_size;
			u32 _depth;
			u32 _mipmapcount; 
			u32 _reserved1[11];

			class PixelFormat
			{
			public:
				u32 _size;
				u32 _flags;    //< sNZtH[}bg\DDPF_*̑gݍ킹
				u32 _fourCC;   //< fourCCtH[}bg̏ꍇ̂
				u32 _bitcount; //< PsNZbit(byteᖳ̂ŒӁI)
				u32 _maskR;    //< RGBtH[}bgmask
				u32 _maskG;    //< RGBtH[}bgmask
				u32 _maskB;    //< RGBtH[}bgmask
				u32 _maskA;    //< RGBtH[}bgmask

				BOOL IsCompressed();
				BOOL IsAlpha();
			};
			PixelFormat _pixel_format;

			u32 _caps1;        //< mipmap̃tOwp
			u32 _caps2;        //< cube / volume eNX`̃tOwp
			u32 _reserved2[3];

			BOOL IsCapsEnabled();
			BOOL IsVolumeTexture();
			BOOL IsCompressed();
			BOOL IsAlpha();
			BOOL IsCubemap();
#ifdef _DEBUG
			void Checker();
#endif
		};
	}
}

#endif // DDS_HEADER_H