/*!
$Id: scenes_texture.h 516 2009-11-17 08:16:13Z horino $
*/
#ifndef SCENES_TEXTURE_H
#define SCENES_TEXTURE_H

#ifdef _DEBUG
#include <iostream>
using namespace std;
#endif

#include "graphics/texture.h"
#include "file/file.h"

namespace indi
{
	namespace mesh
	{
		/*!
		\brief V[eNX`NX
		*/
		class ScenesTexture
		{
		public:
			ScenesTexture() : _texture_num(0), _textures(0) {}
			virtual ~ScenesTexture() { 
				if(_textures) {
					for(u32 i=0;i<_texture_num;++i)
						if(_textures[i])
							delete _textures[i];
					delete [] _textures;
				}
			}

			virtual u32 Read(const u8 *data);

			u32 GetTextureNum() const { return _texture_num; }
			const indi::graphics::TextureBase *GetTexture(u32 i) const { ASSERT(i < _texture_num); return _textures[i]; }
			indi::graphics::TextureBase *GetTexture(u32 i) { return const_cast<indi::graphics::TextureBase *>(static_cast<const ScenesTexture *>(this)->GetTexture(i)); }

		protected:
			u32 _texture_num;
			indi::graphics::TextureBase **_textures;
		};

		/*!
		\brief V[eNX`NX(񓯊ǂݍݔ)
		*/
		class ScenesTextureFile : public ScenesTexture, public file::File
		{
		public:
			ScenesTextureFile() : ScenesTexture(), file::File() {}
			ScenesTextureFile(const char *path) : ScenesTexture(), file::File(path) {}
			virtual ~ScenesTextureFile() {}

			virtual void OnLoaded() { ASSERT(Read(GetData()) == GetSize()); }
		};
	}
}

#endif // SCENES_TEXTURE_H