/*!
$Id: triangle.h 629 2009-12-21 04:06:49Z horino $
*/
#ifndef TRIANGLE_H
#define TRIANGLE_H

#ifdef _DEBUG
#include <iostream>
using namespace std;
#endif

#include "graphics/vertexbuffer.h"
#include "aabb.h"

namespace indi
{
	namespace mesh
	{
		class graphics::shader::Program;

		/*!
		\brief gCAONX
		\note o[ebNXobt@܂
		*/
		class Triangle 
		{
		public:
			Triangle() : _material_index(0xffffffff), _primitive_type(0), _vertex_num(0), _vertex_buffer(0), _vertices(0) {}
			virtual ~Triangle();

			virtual u32 Read(const u8 *data);

			template<typename T> u32 CreateVertices(const u8 *data);
			template<typename T> void ReleaseVertices();

			virtual void Draw() const {
				if(_vertex_buffer) {
					_vertex_buffer->Begin();
					_vertex_buffer->Draw();
					_vertex_buffer->End();
				}
			}

			u32 GetMaterialIndex() const { return _material_index; }
			u32 GetPrimitiveType() const { return _primitive_type; }
			u32 GetVertexNum() const { return _vertex_num; }
			indi::graphics::VertexBufferBase *GetVertexBuffer() { return _vertex_buffer; }

			virtual void SetIndexWeight(graphics::shader::Program *prog, const char *index_name, const char *weight_name) { _vertex_buffer->SetIndexWeight(prog, index_name, weight_name); }

		protected:
			u32 _material_index;
			u32 _primitive_type;
			u32 _vertex_num;
			indi::graphics::VertexBufferBase *_vertex_buffer;
			void *_vertices;
		};

		class TriangleAABB : public Triangle, public AABB
		{
		public:
			TriangleAABB() : Triangle(), AABB() {}
			virtual ~TriangleAABB() {}

			virtual u32 Read(const u8 *data);
		};
	};
};

#endif // TRIANGLE_H