/*!
$Id: entity.h 642 2009-12-28 05:16:12Z horino $
*/
#ifndef ENTITY_H
#define ENTITY_H

#include "itl/bitset.h"
#include "vector3.h"

namespace indi
{
	namespace physics
	{
		class Entity 
		{
		public:
			enum {
				Static,
				Deactive,
			};
			Entity() : _flags(0) {}
			virtual ~Entity() {}

			BOOL IsStatic() const { return _flags.Test(Static); }
			void SetStatic(BOOL b) { b ? _flags.Set(Static) : _flags.Reset(Static); }

			BOOL IsActive() const { return !_flags.Test(Deactive); }
			void SetActivate(BOOL b) { b ? _flags.Reset(Deactive) : _flags.Set(Deactive); }

			virtual BOOL IsParticle() const = 0;
			virtual BOOL IsRigidbody() const = 0;
			virtual BOOL IsSpring() const = 0;

			virtual void Update(f32 dt) {}

		protected:
			itl::Bitset _flags;
		};
	}
}

#endif //< ENTITY_H