/*!
$Id: sprite.h 587 2009-12-02 02:23:49Z horino $
*/
#ifndef SPRITE_H
#define SPRITE_H

#ifdef _DEBUG
#include <iostream>
using namespace std;
#endif

#include "indi.h"
#include "graphics/texture_file.h"
#include "vector2.h"
#include "vector3.h"
#include "matrix44.h"

namespace indi
{
	class Sprite : public graphics::TextureFile
	{
	public:
		enum SpriteOrigin {
#define SPRITE_ORIGIN(id, v) id = (1 << v),
#include "sprite.h"
#undef SPRITE_ORIGIN
		};

		Sprite(const char *path) : TextureFile(path), _cut_lt(Vector2::Zero()), _cut_size(Vector2::Zero()), _position(Vector3::Zero()), _scale(Vector2::One()), _rotation(0.0f), _alpha(1.0f), _origin(static_cast<SpriteOrigin>(Center | Center)) {}
		Sprite(const char *path, const Vector2 &lt, const Vector2 &siz) : TextureFile(path), _cut_lt(lt), _cut_size(siz), _position(Vector3::Zero()), _scale(Vector2::One()), _rotation(0.0f), _alpha(1.0f), _origin(static_cast<SpriteOrigin>(Center | Center)) {}
		virtual ~Sprite() {}

		/*!
		\brief eNX`̐؂o̊JnʒuijwA擾܂
		\return ؂o̊Jnʒuij
		*/
		Vector2 &CutOrigin() { return _cut_lt; }

		/*!
		\brief eNX`̐؂õTCYwA擾܂
		\return ؂õTCY
		*/
		Vector2 &CutSize() { return _cut_size; }

		/*!
		\brief XvCg̕\ʒuwA擾܂
		\note pꍇ͉ʂ̒S(0, 0)ɂȂ܂(3D\)A2DIɎgꍇɂ́A֗֐SetPosition()ASetPositionRatio()g܂B
		\return \ʒu
		*/
		Vector3 &Position() { return _position; }

		f32 GetPositionRatioX() const { return (_position.X() * 0.5f + 0.5f); }
		f32 GetPositionRatioY() const { return (0.5f - _position.Y() * 0.5f); }
		u32 GetPositionX() const { return static_cast<u32>(GetPositionRatioX() * graphics::System::GetScreenWidth()); }
		u32 GetPositionY() const { return static_cast<u32>(GetPositionRatioY() * graphics::System::GetScreenHeight()); }

		void SetPositionRatioX(f32 x) { _position.SetX((x - 0.5f) * 2.0f); }
		void SetPositionRatioY(f32 y) { _position.SetY((0.5f - y) * 2.0f); }
		/*!
		\brief XN[W()ňʒuw肵܂
		\param x 0.0fAE1.0f
		\param y オ0.0fA1.0f
		*/
		void SetPositionRatio(f32 x, f32 y) { SetPositionRatioX(x); SetPositionRatioY(y); }

		void SetPositionX(u32 x) { SetPositionRatioX(static_cast<f32>(x) / graphics::System::GetScreenWidth()); }
		void SetPositionY(u32 y) { SetPositionRatioY(static_cast<f32>(y) / graphics::System::GetScreenHeight()); }
		/*!
		\brief XN[Wňʒuw肵܂
		\param x 0, Egraphics::System::GetScreenWidth()
		\param y オ0Agraphics::System::GetScreenHeight()
		*/
		void SetPosition(u32 x, u32 y) { SetPositionX(x); SetPositionY(y); }

		/*!
		\brief XN[W()ŃfvXw肵܂
		\param z O0.0f1.0f 
		*/
		void SetDepthRatio(f32 z) { _position.SetZ(z); }

		/*!
		\brief XvCgɂXP[wA擾܂
		\return XP[
		*/
		Vector2 &Scale() { return _scale; }

		/*!
		\brief XvCgɂ]piWAjwA擾܂
		\return ]piWAj
		*/
		f32 &Rotation() { return _rotation; }

		/*!
		\brief XvCg̓xwA擾܂
		\return x
		*/
		f32 &Alpha() { return _alpha; }

		/*!
		\brief XvCg̔zuA]AXP[Ȃǂ̊_wA擾܂
		\return_̎wiftHgl : Center | Center)
		*/
		SpriteOrigin &Origin() { return _origin; }

		Vector4 GetTexcoord() const;
		Matrix44 GetMatrix();

	protected:
		Vector2 _cut_lt;
		Vector2 _cut_size;
		Vector3 _position;
		Vector2 _scale;
		f32 _rotation;
		f32 _alpha;

		SpriteOrigin _origin;
	};
}

#endif // SPRITE_H

#ifdef SPRITE_ORIGIN
SPRITE_ORIGIN(Center, 0)
SPRITE_ORIGIN(Left, 1)
SPRITE_ORIGIN(Right, 2)
SPRITE_ORIGIN(Top, 3)
SPRITE_ORIGIN(Bottom, 4)
#endif