/*!
$Id: timer.h 641 2009-12-25 10:30:03Z horino $
*/
#ifndef TIMER_H
#define TIMER_H

#include "indi.h"

namespace indi
{
	class Timer
	{
	public:
		static f32 ToSecond(u32 t);
		static f32 GetElapsedSecond() { return ToSecond(1); }
	};

	/*!
	\brief Q[NĂ炸Ƒ^C}NX
	*/
	class PowerOnTimer
	{
	public:
		PowerOnTimer() : _limit(0xffffffff), _start(0xffffffff) {}
		~PowerOnTimer() {}

		/*!
		\brief ^C}Jn܂
		\param ^C}؂܂ł̎ԁit[Ŏwj
		*/
		void Start(u32 lim) { _limit = lim; _start = current; }

		/*!
		\brief ^C}~߂܂
		*/
		void Stop() { _limit = 0xffffffff; _start = 0xffffffff; }

		/*!
		\brief ^C}NĂ邩
		\return NĂTRUE
		*/
		BOOL IsValid() const { return _start !=0xffffffff; }

		/*!
		\brief ^C}؂Ă邩
		\return ؂ĂTRUE
		\note NĂȂƂTRUEԂ܂
		*/
		BOOL IsExpired() const { return (!IsValid() || current - _start > _limit); }

		/*!
		\brief c莞(t[jԂ܂
		\return c莞(t[j
		\note NĂȂƂ0Ԃ܂
		*/
		u32 Rest() const { if(IsExpired()) return 0; return _limit - (current - _start); }

		/*!
		\brief c莞Ԃ䗦ŕԂ܂
		\return c莞(䗦)
		\note NĂȂƂ0Ԃ܂
		\note N 1.0f  0.0f Ԑ؂꒼O
		*/
		f32 Ratio() const { if(IsExpired()) return 0.0f; return static_cast<f32>(Rest()) / static_cast<f32>(_limit); }

		u32 _limit;
		u32 _start;

		static u32 current;
	};

	/*!
	\brief fobOXgbvȂǂɂ̓CNg~܂^C}NX
	*/
	class AnimationTimer
	{
	public:
		AnimationTimer() : _limit(0xffffffff), _start(0xffffffff)  {}
		~AnimationTimer() {}

		/*!
		\brief ^C}Jn܂
		\param ^C}؂܂ł̎ԁit[Ŏwj
		*/
		void Start(u32 lim) { _limit = lim; _start = current; }

		/*!
		\brief ^C}~߂܂
		*/
		void Stop() { _limit = 0xffffffff; _start = 0xffffffff; }

		/*!
		\brief ^C}NĂ邩
		\return NĂTRUE
		*/
		BOOL IsValid() const { return _start !=0xffffffff; }

		/*!
		\brief ^C}؂Ă邩
		\return ؂ĂTRUE
		\note NĂȂƂTRUEԂ܂
		*/
		BOOL IsExpired() const { return (!IsValid() || current - _start > _limit); }

		/*!
		\brief c莞(t[jԂ܂
		\return c莞(t[j
		\note NĂȂƂ0Ԃ܂
		*/
		u32 Rest() const { if(IsExpired()) return 0; return _limit - (current - _start); }

		/*!
		\brief c莞Ԃ䗦ŕԂ܂
		\return c莞(䗦)
		\note NĂȂƂ0Ԃ܂
		\note N 1.0f  0.0f Ԑ؂꒼O
		*/
		f32 Ratio() const { if(IsExpired()) return 0.0f; return static_cast<f32>(Rest()) / static_cast<f32>(_limit); }

		u32 _limit;
		u32 _start;

		static u32 current;
	};
};

#endif //< TIMER_H