/*!
$Id: distance.cpp 652 2010-01-08 09:54:38Z horino $
*/
#include "stdafx.h"

#define DISTANCE_CPP

#include "collision/collision.h"
using namespace indi;

/*!
\brief ʂƓ_̋(삵Ă)
\param ʂ̖@(vK)
\param ʂ̌_̋
\param _
\return 
*/
f32 Collision::Distance::PlanePoint(const Vector3 &nPl, f32 dPl,
									const Vector3 p)
{
	return nPl * p - dPl;
}

/*!
\brief AABBƓ_Ƃ̋̓(삵Ă)
\param AABB̒S
\param AABB̔a
\param _
\return ̓
*/
f32 Collision::Distance::Squared::AABBPoint(const Vector3 &cAB, const Vector3 &rAB, 
											const Vector3 &p)
{
	Vector3 mn(cAB - rAB);
	Vector3 mx(cAB + rAB);
	return Vector3(math::Max(math::Max(mn.X() - p.X(), 0.0f), math::Max(p.X() - mx.X(), 0.0f)),
		math::Max(math::Max(mn.Y() - p.Y(), 0.0f), math::Max(p.Y() - mx.Y(), 0.0f)),
		math::Max(math::Max(mn.Z() - p.Z(), 0.0f), math::Max(p.Z() - mx.Z(), 0.0f))).LengthSquared();
}

/*!
\brief OBBƓ_̋̓()
\param OBB̒S
\param OBB̔a
\param OBBX
\param OBBY
\param OBBZ
\param _
\return ̓
*/
f32 Collision::Distance::Squared::OBBPoint(const Vector3 &cOB, const Vector3 &rOB, const Vector3 &xOB, const Vector3 &yOB, const Vector3 &zOB, 
										   const Vector3 &p)
{
	Vector3 v(p - cOB);
	f32 l(0.0f);

	f32 d(v *xOB);
	f32 e(0.0f);
	if(d < -rOB.X()) {
		e = d + rOB.X();
		l += math::Pow(e);
	} else if(d > rOB.X()) {
		e = d - rOB.X();
		l += math::Pow(e);
	}

	d = v * yOB;
	e = 0.0f;
	if(d < -rOB.Y()) {
		e = d + rOB.Y();
		l += math::Pow(e);
	} else if (d > rOB.Y()) {
		e = d - rOB.Y();
		l += math::Pow(e);
	}

	d = v * zOB;
	e = 0.0f;
	if(d < -rOB.Z()) {
		e = d + rOB.Z();
		l += math::Pow(e);
	} else if(d > rOB.Z()) {
		e = d - rOB.Z();
		l += math::Pow(e);
	}
	return l;
}
				
/*!
\brief _Ɛ̋̓(삵Ă)
\param _
\param ̒[_
\param ̒[_
\return ̓
*/
f32 Collision::Distance::Squared::PointSegment(const Vector3 &p,
											   const Vector3 &seg0, const Vector3 &seg1)
{
	Vector3 d(seg1 - seg0);
	Vector3 s0p(p - seg0);
	f32 t(s0p * d);
	if(t <= 0.0f) return s0p.LengthSquared();
	f32 l(d.LengthSquared());
	if (l <= t) return (p - seg1).LengthSquared();
	return s0p.LengthSquared() - math::Pow(t) / l;
}

/*!
\brief ƐƂ̋̓(삵Ă)
\param 0̒[_
\param 0̒[_
\param 1̒[_
\param 1̒[_
\param 0̍ŋߐړ_̃p[^Ԃ܂
\param 1̍ŋߐړ_̃p[^Ԃ܂
\return ̓
*/
f32 Collision::Distance::Squared::SegmentSegment(const Vector3 &segA0, const Vector3 &segA1,
												 const Vector3 &segB0, const Vector3 &segB1,
												 f32 &t0, f32 &t1)
{
	Collision::ClosestPoint::SegmentSegment(segA0, segA1, segB0, segB1, t0, t1);
	return ((segA0 + (segA1 - segA0) * t0) - (segB0 + (segB1 - segB0) * t1)).LengthSquared();
}
