/*!
$Id: frustum.cpp 640 2009-12-24 07:03:53Z horino $
*/
#include "stdafx.h"

#define FRUSTUM_CPP

#include "collision/collision.h"
#include "graphics/graphics.h"
using namespace indi;

/*!
\brief 쐬܂
\param r[|[g̍
\param r[|[g̏
\param r[|[g̕
\param r[|[g̍
\param r[|[g̓A
\param r[|[g̃t@[
*/
void Collision::Frustum::Create(u32 x, u32 y, u32 w, u32 h, f32 n, f32 f)
{
	_vertices[0] = Vector3(static_cast<f32>(x), static_cast<f32>(y), n);      
	_vertices[1] = Vector3(static_cast<f32>(x + w), static_cast<f32>(y), n);  
	_vertices[2] = Vector3(static_cast<f32>(x), static_cast<f32>(y + h), n);  
	_vertices[3] = Vector3(static_cast<f32>(x + w), static_cast<f32>(y + h), n);
	_vertices[4] = Vector3(_vertices[0].X(), _vertices[0].Y(), f); 
	_vertices[5] = Vector3(_vertices[1].X(), _vertices[1].Y(), f); 
	_vertices[6] = Vector3(_vertices[2].X(), _vertices[2].Y(), f); 
	_vertices[7] = Vector3(_vertices[3].X(), _vertices[3].Y(), f); 
}

/*!
\brief 䕽ʂXVi쐬)܂
\param [h}gNX
\param r[}gNX
\param vWFNV}gNX
*/
void Collision::Frustum::Update(const Matrix44 &world, const Matrix44 &view, const Matrix44 &projection)
{
	Vector3 v[NELEMS(_vertices)];
	graphics::System::UnProject(_vertices, NELEMS(_vertices), v, world, view, projection);

	_top = Util::Plane(v[0], v[1], v[5]); 
	_bottom = Util::Plane(v[3], v[2], v[6]);
	_left = Util::Plane(v[2], v[0], v[4]);
	_right = Util::Plane(v[1], v[3], v[7]);
	_near = Util::Plane(v[1], v[0], v[2]);
	_far = Util::Plane(v[4], v[5], v[7]);
}

