/*!
$Id: animation.cpp 624 2009-12-17 07:37:52Z horino $
*/
#include "stdafx.h"

#define ANIMATION_CPP

#include "utilities.h"
#include "mesh/animation.h"
using namespace indi;

/*!
\brief oCif[^쐬܂
*/
u32 mesh::AnimationControllerHeader::Read(const u8 *data)
{
	const u8 *p(data);

	//< x[Xxl̎擾
	_base_y = *reinterpret_cast<const u32 *>(p); p += sizeof(_base_y);
#ifdef _DEBUG
	cout << "\t\tController Base Y : " << _base_y << endl;
#endif

	//< ̎擾
	_time_num = *reinterpret_cast<const u32 *>(p); p += sizeof(_time_num);
#ifdef _DEBUG
	cout << "\t\t\tTime Num : " << _time_num << endl;
#endif

	//< ̎擾
	if(_time_num){
		_times = new f32 [_time_num];
		for(u32 i=0;i<_time_num;++i) {
			_times[i] = ToF32(*reinterpret_cast<const u32 *>(p)); p += sizeof(u32);
#ifdef _DEBUG
			//cout << "[" << i << "]" << _times[i] << ", ";
#endif
		}
#ifdef _DEBUG
		cout << endl;
#endif
	}

	return p - data;
}

/*!
\brief oCif[^쐬܂
*/
u32 mesh::AnimationMapHeader::Read(const u8 *data)
{
	const u8 *p(data);

	//< Aj[V̎擾
	p += string::AllocStrcpy(&_id, reinterpret_cast<const char *>(p));
#ifdef _DEBUG
	cout << "\tAnimatin Clip Name : \"" << _id << "\"" << endl;
#endif

	//< x[Xxl̎擾
	_base_y = *reinterpret_cast<const u32 *>(p); p += sizeof(_base_y);
#ifdef _DEBUG
	cout << "\tAnimation Base Y : " << _base_y << endl;
#endif

	//< Rg[̌
	_controller_num = *reinterpret_cast<const u32 *>(p); p += sizeof(_controller_num);
#ifdef _DEBUG
	cout << "\tController Num : " << _controller_num << endl;
#endif

	//< Rg[̎擾
	if(_controller_num){
		_controllers = new AnimationControllerHeader * [_controller_num];
		for(u32 i=0;i<_controller_num;++i) {
			_controllers[i] = AnimationControllerHeaderCreator();
			p += _controllers[i]->Read(p);
		}
	}

	return p - data;
}

/*!
\brief oCif[^쐬܂
*/
u32 mesh::AnimationMap::Read(const u8 *data)
{
	const u8 *p(data);

	//< wb_̌
	_header_num = *reinterpret_cast<const u32 *>(p); p += sizeof(_header_num);
#ifdef _DEBUG
	cout << "AnimationMap Header Num : " << _header_num << endl;
#endif

	//< wb_̎擾
	if(_header_num){
		_headers = new AnimationMapHeader * [_header_num];
		for(u32 i=0;i<_header_num;++i) {
			_headers[i] = AnimationMapHeaderCreator();
			p += _headers[i]->Read(p);
		}
	}

	//< Aj[VeNX`̍쐬Ɠǂݍ
	_texture = AnimationTextureCreator();

	p += _texture->Read((_texture_data_top = p));

	return p - data;
}
