/*!
$Id: controller.cpp 629 2009-12-21 04:06:49Z horino $
*/
#include "stdafx.h"

#define CONTROLLER_CPP

#include "utilities.h"
#include "mesh/controller.h"
using namespace indi;

/*!
\brief oCif[^쐬܂
*/
u32 mesh::Joint::Read(const u8 *data)
{
	const u8 *p(data);

	//< WCg̎擾
	p += string::AllocStrcpy(&_id, reinterpret_cast<const char *>(p));

	//< ts̎擾
	p += _inverse.Read(p);

	_transform = Matrix44(_inverse).Inverse();

	return p - data;
}

/*!
\brief oCif[^쐬܂
*/
u32 mesh::Controller::Read(const u8 *data)
{
	const u8 *p(data);

	//< NXGeometryƂĎ擾
	//p += static_cast<Geometry *>(this)->Read(p);
	p += Geometry::Read(p);

	//< p}gNX擾
	p += _shape.Read(p);

	//< XPǧ
	_skeleton_num = *reinterpret_cast<const u32 *>(p); p += sizeof(_skeleton_num);
	if(_skeleton_num){
		//< XPg
		_skeletons = new char * [_skeleton_num];
		for(u32 i=0;i<_skeleton_num;++i) {
			p += string::AllocStrcpy(&_skeletons[i], reinterpret_cast<const char *>(p));
		}
	}

	//< WCǧ
	_joint_num = *reinterpret_cast<const u32 *>(p); p += sizeof(_joint_num);
	if(_joint_num){
		_joints = new Joint * [_joint_num];
		for(u32 i=0;i<_joint_num;++i) {
			_joints[i] = JointCreator();
			p += _joints[i]->Read(p);
		}
	}

	return p - data;
}

/*!
\brief oCif[^쐬܂
*/
u32 mesh::ControllerAABB::Read(const u8 *data)
{
	u32 ret(mesh::Controller::Read(data));

	if(_mesh)
		(*this) += *static_cast<mesh::MeshAABB *>(_mesh);

	return ret;
}