/*!
$Id: dds_header.cpp 464 2009-10-29 03:51:10Z horino $
*/
#include "stdafx.h"

#define DDS_HEADER_CPP

#include "utilities.h"
#include "mesh/dds_header.h"
using namespace indi;

BOOL mesh::DDSHeader::IsCapsEnabled() { return (_flags & 0x00000001); }

BOOL mesh::DDSHeader::IsVolumeTexture() { return IsCapsEnabled() && (_caps2 & 0x00200000); }
BOOL mesh::DDSHeader::IsCompressed() { return _pixel_format.IsCompressed(); }
BOOL mesh::DDSHeader::IsAlpha() { return _pixel_format.IsAlpha(); }
BOOL mesh::DDSHeader::IsCubemap() { return IsCapsEnabled() && (_caps2 & 0x00000200); }

BOOL mesh::DDSHeader::PixelFormat::IsCompressed() { return (_flags & 0x00000004); }
BOOL mesh::DDSHeader::PixelFormat::IsAlpha() { return (_flags & 0x00000001); }

#ifdef _DEBUG
/*!
\brief f[^`FbJ
*/
void mesh::DDSHeader::Checker()
{
	ASSERT(_size == sizeof(*this)); //< wb_TCY`FbN
	ASSERT(!IsVolumeTexture()); //< {[eNX`͖Ή
	ASSERT(!IsCompressed()); //< k`͖Ή
	//ASSERT(_mipmapcount); //< ~bv}bvs
	ASSERT(_pixel_format._size == sizeof(_pixel_format)); //< sNZtH[}bgTCY`FbN
	ASSERT(!_pixel_format._fourCC);
	ASSERT(_pixel_format._flags == 0x00000041 /*|| _pixel_format._flags == 0x00000040*/); // RGBA || RGB
	//< BGRA`
	ASSERT(_pixel_format._maskR == 0x00ff0000);
	ASSERT(_pixel_format._maskG == 0x0000ff00);
	ASSERT(_pixel_format._maskB == 0x000000ff);
	ASSERT(_pixel_format._maskA == 0xff000000 || _pixel_format._maskA == 0x00000000);
	//< f[^tH[}bg
	switch(_pixel_format._bitcount){
		default: ASSERT(0); break;
//		case 24: break;
		case 32: break;
	}
}

#endif


