/*!
$Id: geometry.cpp 629 2009-12-21 04:06:49Z horino $
*/
#include "stdafx.h"

#define GEOMETRY_CPP

#include "utilities.h"
#include "mesh/geometry.h"
using namespace indi;

/*!
\brief oCif[^쐬܂
*/
u32 mesh::Geometry::Read(const u8 *data)
{
	const u8 *p(data);

	//< }eǍ
	_material_num = *reinterpret_cast<const u32 *>(p); p += sizeof(_material_num);
	if(_material_num){
		//< }eA
		_materials = new Material *[_material_num];
		for(u32 i=0;i<_material_num;++i){
			_materials[i] = MaterialCreator();
			p += _materials[i]->Read(p);
		}
	}

	//< bV̗L
	u32 have_mesh(*reinterpret_cast<const u32 *>(p)); p += sizeof(have_mesh);
	if(have_mesh) {
		_mesh = MeshCreator();
		p += _mesh->Read(p);
	}

	return p - data;
}

/*!
\brief oCif[^쐬܂
*/
u32 mesh::GeometryAABB::Read(const u8 *data)
{
	u32 ret(mesh::Geometry::Read(data));

	if(_mesh)
		(*this) += *static_cast<mesh::MeshAABB *>(_mesh);

	return ret;
}
