/*!
$Id: mesh.cpp 629 2009-12-21 04:06:49Z horino $
*/
#include "stdafx.h"

#define MESH_CPP

#include "utilities.h"
#include "mesh/mesh.h"
using namespace indi;

/*!
\brief oCif[^쐬܂
*/
u32 mesh::Mesh::Read(const u8 *data)
{
	const u8 *p(data);

	//< bV
	p += string::AllocStrcpy(&_name, reinterpret_cast<const char *>(p));

	//< gCAO
	_triangle_num = *reinterpret_cast<const u32 *>(p); p += sizeof(_triangle_num);
	//< gCAO
	_triangles = new Triangle *[_triangle_num];
	for(u32 i=0;i<_triangle_num;++i){
		_triangles[i] = TriangleCreator();
		p += _triangles[i]->Read(p);
	}

	return p - data;
}

/*!
\brief oCif[^쐬܂
*/
u32 mesh::MeshAABB::Read(const u8 *data)
{
	u32 ret(mesh::Mesh::Read(data));

	for(u32 i=0;i<_triangle_num;++i)
		(*this) += *static_cast<mesh::TriangleAABB *>(_triangles[i]);

	return ret;
}