/*!
$Id: node.cpp 629 2009-12-21 04:06:49Z horino $
*/
#include "stdafx.h"

#define NODE_CPP

#include "utilities.h"
#include "mesh/node.h"
using namespace indi;

/*!
\brief oCif[^쐬܂
*/
u32 mesh::Node::Read(const u8 *data)
{
	const u8 *p(data);

	//< m[h
	p += string::AllocStrcpy(&_name, reinterpret_cast<const char *>(p));

	//< gXtH[
	p += _transform.Read(p);

	//< WIg
	_geometry_num = *reinterpret_cast<const u32 *>(p); p += sizeof(_geometry_num);
	//< WIg
	if(_geometry_num){
		_geometries = new Geometry *[_geometry_num];
		for(u32 i=0;i<_geometry_num;++i){
			_geometries[i] = GeometryCreator(this);
			p += _geometries[i]->Read(p);
		}
	}

	//< Rg[
	_controller_num = *reinterpret_cast<const u32 *>(p); p += sizeof(_controller_num);
	if(_controller_num){
		//< Rg[
		_controllers = new Controller *[_controller_num];
		for(u32 i=0;i<_controller_num;++i){
			_controllers[i] = ControllerCreator(this);
			p += _controllers[i]->Read(p);
		}
	}

	//< m[h
	_node_num = *reinterpret_cast<const u32 *>(p); p += sizeof(_node_num);
	if(_node_num){
		//< m[h
		_nodes = new Node *[_node_num];
		for(u32 i=0;i<_node_num;++i){
			_nodes[i] = NodeCreator(this);
			p += _nodes[i]->Read(p);

			_nodes[i]->AccumulateTransform(); //< em[h̃gXtH[~
		}
	}

	return p - data;
}

/*!
\brief oCif[^쐬܂
\note TODO Accumulatel
*/
u32 mesh::NodeAABB::Read(const u8 *data)
{
	u32 ret(mesh::Node::Read(data));

	for(u32 i=0;i<_geometry_num;++i)
		(*this) += *static_cast<mesh::GeometryAABB *>(_geometries[i]);

	for(u32 i=0;i<_controller_num;++i)
		(*this) += *static_cast<mesh::ControllerAABB *>(_controllers[i]);

	for(u32 i=0;i<_node_num;++i)
		(*this) += *static_cast<mesh::NodeAABB *>(_nodes[i]);

	return ret;
}
