/*!
$Id: particle.cpp 642 2009-12-28 05:16:12Z horino $
*/
#include "stdafx.h"

#define PARTICLE_CPP

#include "physics/particle.h"
#include "physics/world.h"
using namespace indi;

/*!
%\brief p[eBN̍XV
\param 
*/
void physics::Particle::Update(f32 dt) 
{
	if(!IsStatic() && IsActive()) {
		_force += _mass * World::Get()->GetGravity();
		_force -= _velocity * _drag_coefficent;
		_acceleration = _force * _inv_mass;
		Integrate(dt);
		_force = Vector3::Zero();
	}
}

/*!
\brief ϕ
*/
void physics::Particle::Integrate(f32 dt) 
{
#if 0
	//< x
	Vector3 new_pos((2.0f - _drag_coefficent) * _position - (1.0f - _drag_coefficent) * _prev_position + _acceleration * math::Pow(dt, 2.0f));
	_prev_position = _position;
	_position = new_pos;
	_velocity = _position - _prev_position;
#else
	//< IC[
	_prev_position = _position;
	_position += _velocity * dt;
	_velocity += _acceleration * dt;
#endif
}
