/*!
$Id: spring.cpp 641 2009-12-25 10:30:03Z horino $
*/
#include "stdafx.h"

#define SPRING_CPP

#include "physics/spring.h"
#include "physics/particle.h"
#include "physics/rigidbody.h"
using namespace indi;

/*!
\brief ΂˂̗͂ڑĂGeBeB։܂
*/
void physics::Spring::ApplyForce() 
{
	if(_a && _b) {
		Vector3 dir(_a->GetPosition() - _b->GetPosition());
		f32 len(dir.Length());
		if(len > LIM_MIN(f32)) {
			dir /= len;
			Vector3 dif_dir((len - _length) * dir);
			Vector3 force(-_stiffness * dif_dir);
			force += -_dumping * ((_a->GetVelocity() - _b->GetVelocity()) * dir) * dir;
			if(_a->IsActive() && !_a->IsStatic()) {
				if(_a->IsParticle()) 
					_a->SetForce(_a->GetForce() + force);
			}
			if(_b->IsActive() && !_b->IsStatic()) {
				if(_b->IsParticle()) 
					_b->SetForce(_b->GetForce() - force);
			}
		}
	}
}

/*!
\brief ΂˂̒̃RXgCgl܂
*/
void physics::Spring::Constraint() 
{
	if(_a && _b) {
		Vector3 dir(_a->GetPosition() - _b->GetPosition());
		f32 len(dir.Length());
		if(len > LIM_MIN(f32)) {
			dir /= len;
			Vector3 dif_dir((len - _length) * dir);
			Vector3 move(0.5f * dif_dir);
			if(_a->IsActive() && !_a->IsStatic()) 
				_a->SetPosition(_a->GetPosition() - move);
			if(_b->IsActive() && !_b->IsStatic()) 
				_b->SetPosition(_b->GetPosition() + move);
		}
	}            
}
