/*!
$Id: world.cpp 642 2009-12-28 05:16:12Z horino $
*/
#include "stdafx.h"

#define WORLD_CPP

#include "physics/world.h"
#include "physics/particle.h"
#include "physics/spring.h"
#include "physics/rigidbody.h"
#include "physics/cloth.h"
using namespace indi;

physics::World *physics::World::_world = 0;

/*!
\brief [h̃fXgN^
*/
physics::World::~World() 
{
	if(_particles) { delete [] _particles; _particles = 0; }
	if(_rigidbodies) { delete [] _rigidbodies; _rigidbodies = 0; }
	if(_springs) { delete [] _springs; _springs = 0; }
}

/*!
\brief [h̎s
\param 
*/
void physics::World::Update(f32 dt)
{
	//< ΂˂ɂ
	for(u32 i=0;i<_nspring;++i) 
		if(_springs[i])
			_springs[i]->ApplyForce();

	//< p[eBN̐ϕ
	for(u32 i=0;i<_nparticle;++i) 
		if(_particles[i])
			_particles[i]->Update(dt);

	//< ̂̐ϕ
	for(u32 i=0;i<_nrigidbody;++i) 
		if(_rigidbodies[i])
			_rigidbodies[i]->Update(dt);

	//< ΂˂̒
	for(u32 j=0; j<constrain_iterate; ++j) {
		for(u32 i=0;i<_nspring;++i) 
			if(_springs[i])
				_springs[i]->Constraint();
	}
}

/*!
\brief GeBeBip[eBNÁA΂ˁA...j̃[hւ̒ǉ
\param GeBeB
*/
void physics::World::Add(Entity *e) 
{
	if(e->IsParticle()) {
		for(u32 i=0;i<_nparticle;++i)
			if(!_particles[i]) {
				_particles[i] = static_cast<Particle *>(e);
				break;
			}
	} else if(e->IsRigidbody()) {
		for(u32 i=0;i<_nrigidbody;++i)
			if(!_rigidbodies[i]) {
				_rigidbodies[i] = static_cast<Rigidbody *>(e);
				break;
			}
	} else if(e->IsSpring()) {
		for(u32 i=0;i<_nspring;++i)
			if(!_springs[i]) {
				_springs[i] = static_cast<Spring *>(e);
				break;
			}
	}
}

/*!
\brief NX̃[hւ̒ǉ
\param NX
*/
void physics::World::Add(Cloth *c)
{
	for(u32 i=0;i<c->GetParticleNum();++i) {
		Particle *p(c->GetParticle(i));
		if(p)
			Add(p);
	}
	for(u32 i=0;i<c->GetSpringNum();++i) {
		Spring *s(c->GetSpring(i));
		if(s)
			Add(s);
	}
}

