/*!
$Id: primitive.cpp 647 2010-01-06 10:03:24Z horino $
*/
#include "stdafx.h"

#ifdef _DEBUG
#include <iostream>
using namespace std;
#include "vector3.h"
#endif

#define PRIMITIVE_CPP

#include "primitive/primitive.h"
using namespace indi;

primitive::SegmentX::SegmentX() : SegmentBase()
{
	graphics::VertexPosition segment_x_v[] = { { {0.0f, 0.0f, 0.0f}, }, { {1.0f, 0.0f, 0.0f}, }, };
	vertex = new graphics::VertexBuffer<graphics::VertexPosition>(graphics::LINES, segment_x_v, NELEMS(segment_x_v));
}
primitive::SegmentY::SegmentY() : SegmentBase()
{
	graphics::VertexPosition segment_y_v[] = { { {0.0f, 0.0f, 0.0f}, }, { {0.0f, 1.0f, 0.0f}, }, };
	vertex = new graphics::VertexBuffer<graphics::VertexPosition>(graphics::LINES, segment_y_v, NELEMS(segment_y_v));
}
primitive::SegmentZ::SegmentZ() : SegmentBase()
{
	graphics::VertexPosition segment_z_v[] = { { {0.0f, 0.0f, 0.0f}, }, { {0.0f, 0.0f, 1.0f}, }, };
	vertex = new graphics::VertexBuffer<graphics::VertexPosition>(graphics::LINES, segment_z_v, NELEMS(segment_z_v));
}	

#ifndef _UMBRELLA
#define _UMBRELLA 0.1f //< ̎P̒
#endif
primitive::ArrowX::ArrowX() : ArrowBase()
{
	graphics::VertexPosition arrow_x_v[] = {
		{ {0.0f, 0.0f, 0.0f}, }, { {1.0f,             0.0f,             0.0f},             },
		{ {1.0f, 0.0f, 0.0f}, }, { {1.0f - _UMBRELLA, 0.0f,             0.0f + _UMBRELLA}, },
		{ {1.0f, 0.0f, 0.0f}, }, { {1.0f - _UMBRELLA, 0.0f,             0.0f - _UMBRELLA}, },
		{ {1.0f, 0.0f, 0.0f}, }, { {1.0f - _UMBRELLA, 0.0f + _UMBRELLA, 0.0f},             },
		{ {1.0f, 0.0f, 0.0f}, }, { {1.0f - _UMBRELLA, 0.0f - _UMBRELLA, 0.0f},             },
	};
	vertex = new graphics::VertexBuffer<graphics::VertexPosition>(graphics::LINES, arrow_x_v, NELEMS(arrow_x_v));
}
primitive::ArrowY::ArrowY() : ArrowBase()
{
	graphics::VertexPosition arrow_y_v[] = {
		{ {0.0f, 0.0f, 0.0f}, }, { {0.0f,             1.0f,             0.0f},             },
		{ {0.0f, 1.0f, 0.0f}, }, { {0.0f + _UMBRELLA, 1.0f - _UMBRELLA, 0.0f},             },
		{ {0.0f, 1.0f, 0.0f}, }, { {0.0f - _UMBRELLA, 1.0f - _UMBRELLA, 0.0f},             },
		{ {0.0f, 1.0f, 0.0f}, }, { {0.0f,             1.0f - _UMBRELLA, 0.0f + _UMBRELLA}, },
		{ {0.0f, 1.0f, 0.0f}, }, { {0.0f ,            1.0f - _UMBRELLA, 0.0f - _UMBRELLA}, },
	};
	vertex = new graphics::VertexBuffer<graphics::VertexPosition>(graphics::LINES, arrow_y_v, NELEMS(arrow_y_v));
}
primitive::ArrowZ::ArrowZ() : ArrowBase()
{
	graphics::VertexPosition arrow_z_v[] = {
		{ {0.0f, 0.0f, 0.0f}, }, { {0.0f,             0.0f,             1.0f},             },
		{ {0.0f, 0.0f, 1.0f}, }, { {0.0f + _UMBRELLA, 0.0f,             1.0f - _UMBRELLA}, },
		{ {0.0f, 0.0f, 1.0f}, }, { {0.0f - _UMBRELLA, 0.0f,             1.0f - _UMBRELLA}, },
		{ {0.0f, 0.0f, 1.0f}, }, { {0.0f,             0.0f + _UMBRELLA, 1.0f - _UMBRELLA}, },
		{ {0.0f, 0.0f, 1.0f}, }, { {0.0f ,            0.0f - _UMBRELLA, 1.0f - _UMBRELLA}, },
	};
	vertex = new graphics::VertexBuffer<graphics::VertexPosition>(graphics::LINES, arrow_z_v, NELEMS(arrow_z_v));
}
primitive::ArrowXYZ::ArrowXYZ() : ArrowBase()
{
	graphics::VertexPosition arrow_xyz_v[] = {
		{ {0.0f, 0.0f, 0.0f}, }, { {1.0f,             0.0f,             0.0f},             },
		{ {1.0f, 0.0f, 0.0f}, }, { {1.0f - _UMBRELLA, 0.0f,             0.0f + _UMBRELLA}, },
		{ {1.0f, 0.0f, 0.0f}, }, { {1.0f - _UMBRELLA, 0.0f,             0.0f - _UMBRELLA}, },
		{ {1.0f, 0.0f, 0.0f}, }, { {1.0f - _UMBRELLA, 0.0f + _UMBRELLA, 0.0f},             },
		{ {1.0f, 0.0f, 0.0f}, }, { {1.0f - _UMBRELLA, 0.0f - _UMBRELLA, 0.0f},             },
		{ {0.0f, 0.0f, 0.0f}, }, { {0.0f,             1.0f,             0.0f},             },
		{ {0.0f, 1.0f, 0.0f}, }, { {0.0f + _UMBRELLA, 1.0f - _UMBRELLA, 0.0f},             },
		{ {0.0f, 1.0f, 0.0f}, }, { {0.0f - _UMBRELLA, 1.0f - _UMBRELLA, 0.0f},             },
		{ {0.0f, 1.0f, 0.0f}, }, { {0.0f,             1.0f - _UMBRELLA, 0.0f + _UMBRELLA}, },
		{ {0.0f, 1.0f, 0.0f}, }, { {0.0f ,            1.0f - _UMBRELLA, 0.0f - _UMBRELLA}, },
		{ {0.0f, 0.0f, 0.0f}, }, { {0.0f,             0.0f,             1.0f},             },
		{ {0.0f, 0.0f, 1.0f}, }, { {0.0f + _UMBRELLA, 0.0f,             1.0f - _UMBRELLA}, },
		{ {0.0f, 0.0f, 1.0f}, }, { {0.0f - _UMBRELLA, 0.0f,             1.0f - _UMBRELLA}, },
		{ {0.0f, 0.0f, 1.0f}, }, { {0.0f,             0.0f + _UMBRELLA, 1.0f - _UMBRELLA}, },
		{ {0.0f, 0.0f, 1.0f}, }, { {0.0f ,            0.0f - _UMBRELLA, 1.0f - _UMBRELLA}, },
	};
	vertex = new graphics::VertexBuffer<graphics::VertexPosition>(graphics::LINES, arrow_xyz_v, NELEMS(arrow_xyz_v));
}
#undef _UMBRELLA

primitive::PlaneXY::PlaneXY() : PlaneBase()
{
	graphics::VertexPositionNormal plane_xy_v[] = {
		{{-1.0f,  1.0f, 0.0f }, {0.0f, 0.0f, 1.0f} },
		{{-1.0f, -1.0f, 0.0f }, {0.0f, 0.0f, 1.0f} },
		{{ 1.0f,  1.0f, 0.0f }, {0.0f, 0.0f, 1.0f} },
		{{ 1.0f, -1.0f, 0.0f }, {0.0f, 0.0f, 1.0f} },
	};
	vertex = new graphics::VertexBuffer<graphics::VertexPositionNormal>(graphics::TRIANGLE_STRIP, plane_xy_v, NELEMS(plane_xy_v));
}
primitive::PlaneYZ::PlaneYZ() : PlaneBase()
{
	graphics::VertexPositionNormal plane_yz_v[] = {
		{{0.0f, -1.0f, -1.0f }, {1.0f, 0.0f, 0.0f} },
		{{0.0f,  1.0f, -1.0f }, {1.0f, 0.0f, 0.0f} },
		{{0.0f, -1.0f,  1.0f }, {1.0f, 0.0f, 0.0f} },
		{{0.0f,  1.0f,  1.0f }, {1.0f, 0.0f, 0.0f} },
	};
	vertex = new graphics::VertexBuffer<graphics::VertexPositionNormal>(graphics::TRIANGLE_STRIP, plane_yz_v, NELEMS(plane_yz_v));
}
primitive::PlaneZX::PlaneZX() : PlaneBase()
{
	graphics::VertexPositionNormal plane_zx_v[] = {
		{{-1.0f, 0.0f, -1.0f }, {0.0f, 1.0f, 0.0f} },
		{{-1.0f, 0.0f,  1.0f }, {0.0f, 1.0f, 0.0f} },
		{{ 1.0f, 0.0f, -1.0f }, {0.0f, 1.0f, 0.0f} },
		{{ 1.0f, 0.0f,  1.0f }, {0.0f, 1.0f, 0.0f} },
	};
	vertex = new graphics::VertexBuffer<graphics::VertexPositionNormal>(graphics::TRIANGLE_STRIP, plane_zx_v, NELEMS(plane_zx_v));
}

primitive::WirePlaneXY::WirePlaneXY() : WirePlaneBase()
{
	graphics::VertexPosition plane_xy_v[] = {
		{{-1.0f,  1.0f, 0.0f }}, {{1.0f,  1.0f, 0.0f }},
		{{1.0f,  1.0f, 0.0f }}, {{1.0f,  -1.0f, 0.0f }},
		{{1.0f,  -1.0f, 0.0f }}, {{-1.0f,  -1.0f, 0.0f }},
		{{-1.0f,  -1.0f, 0.0f }}, {{-1.0f,  1.0f, 0.0f }},
	};
	vertex = new graphics::VertexBuffer<graphics::VertexPosition>(graphics::LINES, plane_xy_v, NELEMS(plane_xy_v));
}
primitive::WirePlaneYZ::WirePlaneYZ() : WirePlaneBase()
{
	graphics::VertexPosition plane_yz_v[] = {
		{{0.0f, -1.0f, -1.0f }}, {{0.0f, 1.0f, -1.0f }},
		{{0.0f, 1.0f, -1.0f }}, {{0.0f, 1.0f, 1.0f }},
		{{0.0f, 1.0f, 1.0f }}, {{0.0f, -1.0f, 1.0f }},
		{{0.0f, -1.0f, 1.0f }}, {{0.0f, -1.0f, -1.0f }},
	};
	vertex = new graphics::VertexBuffer<graphics::VertexPosition>(graphics::LINES, plane_yz_v, NELEMS(plane_yz_v));
}
primitive::WirePlaneZX::WirePlaneZX() : WirePlaneBase()
{
	graphics::VertexPosition plane_zx_v[] = {
		{{-1.0f, 0.0f, -1.0f }}, {{-1.0f, 0.0f,  1.0f }},
		{{-1.0f, 0.0f,  1.0f }}, {{ 1.0f, 0.0f,  1.0f }},
		{{ 1.0f, 0.0f,  1.0f }}, {{ 1.0f, 0.0f, -1.0f }}, 
		{{ 1.0f, 0.0f, -1.0f }}, {{-1.0f, 0.0f, -1.0f }}
	};
	vertex = new graphics::VertexBuffer<graphics::VertexPosition>(graphics::LINES, plane_zx_v, NELEMS(plane_zx_v));
}

primitive::ScreenPlane::ScreenPlane() : vertex(0) 
{
	graphics::VertexPositionTexture screen_plane_v[] = {
		{{  1.0f,  1.0f, 0.0f }, { 1.0f, 1.0f },},
		{{ -1.0f,  1.0f, 0.0f }, { 0.0f, 1.0f },},
		{{ -1.0f, -1.0f, 0.0f }, { 0.0f, 0.0f },},
		{{ -1.0f, -1.0f, 0.0f }, { 0.0f, 0.0f },},
		{{  1.0f, -1.0f, 0.0f }, { 1.0f, 0.0f },},
		{{  1.0f,  1.0f, 0.0f }, { 1.0f, 1.0f },},
	};
	vertex = new graphics::VertexBuffer<graphics::VertexPositionTexture>(graphics::TRIANGLES, screen_plane_v, NELEMS(screen_plane_v));
}

primitive::BillboardPlane::BillboardPlane() : vertex(0) 
{
	graphics::VertexPositionTexture screen_plane_v[] = {
		{{  0.0f,  0.0f, 0.0f }, { 1.0f, 1.0f },},
		{{  0.0f,  0.0f, 0.0f }, { 0.0f, 1.0f },},
		{{  0.0f,  0.0f, 0.0f }, { 0.0f, 0.0f },},
		{{  0.0f,  0.0f, 0.0f }, { 0.0f, 0.0f },},
		{{  0.0f,  0.0f, 0.0f }, { 1.0f, 0.0f },},
		{{  0.0f,  0.0f, 0.0f }, { 1.0f, 1.0f },},
	};
	vertex = new graphics::VertexBuffer<graphics::VertexPositionTexture>(graphics::TRIANGLES, screen_plane_v, NELEMS(screen_plane_v));
}

#ifndef _VSTEPS
#define _VSTEPS 8
#endif
#ifndef _HSTEPS
#define _HSTEPS 8
#endif
/*!
\brief ̃RXgN^
*/
primitive::Sphere::Sphere() : vertex(0) 
{
#if 0
#ifdef _DEBUG
	Vector3 pos[500];
	Vector3 nrm[500];
	u32 n(0);
	f32 r(0.5f);
	pos[n] = -Vector3::UnitY() * r;
	nrm[n++] = -Vector3::UnitY();
	for(u32 i=1;i<_VSTEPS - 1;++i){
		f32 l((static_cast<f32>(i) * INDI_PI / static_cast<f32>(_VSTEPS - 1)) - INDI_PI * 0.5f);
		f32 y(math::Sin(l));
		f32 xz(math::Cos(l));
		for(u32 j=0;j<_HSTEPS;++j){
			f32 ll(static_cast<f32>(j) * INDI_PI * 2.0f / static_cast<f32>(_HSTEPS));
			f32 x(math::Sin(ll) * xz);
			f32 z(math::Cos(ll) * xz);
			pos[n] = Vector3(x, y, z) * r;
			nrm[n++] = Vector3(x, y, z);
		}
	}
	pos[n] = Vector3::UnitY() * r;
	nrm[n++] = Vector3::UnitY();

	for(u32 i=0;i<_HSTEPS;++i){
		u32 idx(0);
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
		idx = ((i + 1) % _HSTEPS) + 1;
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
		idx = i + 1;
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
	}
	cout << "\t\t/////////////////////////" << endl;

	for(u32 i=0;i<_VSTEPS - 3;++i){
		for(u32 j=0;j<_HSTEPS;++j){
			u32 ni(i + 1);
			u32 nj((j + 1) % _HSTEPS);

			u32 idx(1 + i * _HSTEPS + j);
			cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
			idx = 1 + i * _HSTEPS + nj;
			cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
			idx = 1 + ni * _HSTEPS + j;
			cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;

			idx = 1 + i * _HSTEPS + nj;
			cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
			idx = 1 + ni * _HSTEPS + nj;
			cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
			idx = 1 + ni * _HSTEPS + j;
			cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
		}
	}
	cout << "\t\t/////////////////////////" << endl;

	for(u32 i=0;i<_HSTEPS;++i){
		u32 idx(n - 1);
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
		idx = n - 2 - ((i + 1) % _HSTEPS);
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
		idx = n - 2 - i;
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
	}
	cout << "\t\t/////////////////////////" << endl;
#endif
#endif

	graphics::VertexPositionNormal v[] = {
		{{0.00000f, -0.500000f, 0.00000f }, {-0.00000f, -1.00000f, -0.00000f},},
		{{0.153401f, -0.450484f, 0.153401f }, {0.306802f, -0.900969f, 0.306802f},},
		{{0.00000f, -0.450484f, 0.216942f }, {0.00000f, -0.900969f, 0.433884f},},
		{{0.00000f, -0.500000f, 0.00000f }, {-0.00000f, -1.00000f, -0.00000f},},
		{{0.216942f, -0.450484f, -9.48283e-09f }, {0.433884f, -0.900969f, -1.89657e-08f},},
		{{0.153401f, -0.450484f, 0.153401f }, {0.306802f, -0.900969f, 0.306802f},},
		{{0.00000f, -0.500000f, 0.00000f }, {-0.00000f, -1.00000f, -0.00000f},},
		{{0.153401f, -0.450484f, -0.153401f }, {0.306802f, -0.900969f, -0.306802f},},
		{{0.216942f, -0.450484f, -9.48283e-09f }, {0.433884f, -0.900969f, -1.89657e-08f},},
		{{0.00000f, -0.500000f, 0.00000f }, {-0.00000f, -1.00000f, -0.00000f},},
		{{-1.89657e-08f, -0.450484f, -0.216942f }, {-3.79313e-08f, -0.900969f, -0.433884f},},
		{{0.153401f, -0.450484f, -0.153401f }, {0.306802f, -0.900969f, -0.306802f},},
		{{0.00000f, -0.500000f, 0.00000f }, {-0.00000f, -1.00000f, -0.00000f},},
		{{-0.153401f, -0.450484f, -0.153401f }, {-0.306802f, -0.900969f, -0.306802f},},
		{{-1.89657e-08f, -0.450484f, -0.216942f }, {-3.79313e-08f, -0.900969f, -0.433884f},},
		{{0.00000f, -0.500000f, 0.00000f }, {-0.00000f, -1.00000f, -0.00000f},},
		{{-0.216942f, -0.450484f, 2.58700e-09f }, {-0.433884f, -0.900969f, 5.17401e-09f},},
		{{-0.153401f, -0.450484f, -0.153401f }, {-0.306802f, -0.900969f, -0.306802f},},
		{{0.00000f, -0.500000f, 0.00000f }, {-0.00000f, -1.00000f, -0.00000f},},
		{{-0.153401f, -0.450484f, 0.153401f }, {-0.306802f, -0.900969f, 0.306802f},},
		{{-0.216942f, -0.450484f, 2.58700e-09f }, {-0.433884f, -0.900969f, 5.17401e-09f},},
		{{0.00000f, -0.500000f, 0.00000f }, {-0.00000f, -1.00000f, -0.00000f},},
		{{0.00000f, -0.450484f, 0.216942f }, {0.00000f, -0.900969f, 0.433884f},},
		{{-0.153401f, -0.450484f, 0.153401f }, {-0.306802f, -0.900969f, 0.306802f},},
		/////////////////////////
		{{0.00000f, -0.450484f, 0.216942f }, {0.00000f, -0.900969f, 0.433884f},},
		{{0.153401f, -0.450484f, 0.153401f }, {0.306802f, -0.900969f, 0.306802f},},
		{{0.00000f, -0.311745f, 0.390916f }, {0.00000f, -0.623490f, 0.781832f},},
		{{0.153401f, -0.450484f, 0.153401f }, {0.306802f, -0.900969f, 0.306802f},},
		{{0.276419f, -0.311745f, 0.276419f }, {0.552838f, -0.623490f, 0.552838f},},
		{{0.00000f, -0.311745f, 0.390916f }, {0.00000f, -0.623490f, 0.781832f},},
		{{0.153401f, -0.450484f, 0.153401f }, {0.306802f, -0.900969f, 0.306802f},},
		{{0.216942f, -0.450484f, -9.48283e-09f }, {0.433884f, -0.900969f, -1.89657e-08f},},
		{{0.276419f, -0.311745f, 0.276419f }, {0.552838f, -0.623490f, 0.552838f},},
		{{0.216942f, -0.450484f, -9.48283e-09f }, {0.433884f, -0.900969f, -1.89657e-08f},},
		{{0.390916f, -0.311745f, -1.70875e-08f }, {0.781832f, -0.623490f, -3.41749e-08f},},
		{{0.276419f, -0.311745f, 0.276419f }, {0.552838f, -0.623490f, 0.552838f},},
		{{0.216942f, -0.450484f, -9.48283e-09f }, {0.433884f, -0.900969f, -1.89657e-08f},},
		{{0.153401f, -0.450484f, -0.153401f }, {0.306802f, -0.900969f, -0.306802f},},
		{{0.390916f, -0.311745f, -1.70875e-08f }, {0.781832f, -0.623490f, -3.41749e-08f},},
		{{0.153401f, -0.450484f, -0.153401f }, {0.306802f, -0.900969f, -0.306802f},},
		{{0.276419f, -0.311745f, -0.276419f }, {0.552838f, -0.623490f, -0.552838f},},
		{{0.390916f, -0.311745f, -1.70875e-08f }, {0.781832f, -0.623490f, -3.41749e-08f},},
		{{0.153401f, -0.450484f, -0.153401f }, {0.306802f, -0.900969f, -0.306802f},},
		{{-1.89657e-08f, -0.450484f, -0.216942f }, {-3.79313e-08f, -0.900969f, -0.433884f},},
		{{0.276419f, -0.311745f, -0.276419f }, {0.552838f, -0.623490f, -0.552838f},},
		{{-1.89657e-08f, -0.450484f, -0.216942f }, {-3.79313e-08f, -0.900969f, -0.433884f},},
		{{-3.41749e-08f, -0.311745f, -0.390916f }, {-6.83499e-08f, -0.623490f, -0.781832f},},
		{{0.276419f, -0.311745f, -0.276419f }, {0.552838f, -0.623490f, -0.552838f},},
		{{-1.89657e-08f, -0.450484f, -0.216942f }, {-3.79313e-08f, -0.900969f, -0.433884f},},
		{{-0.153401f, -0.450484f, -0.153401f }, {-0.306802f, -0.900969f, -0.306802f},},
		{{-3.41749e-08f, -0.311745f, -0.390916f }, {-6.83499e-08f, -0.623490f, -0.781832f},},
		{{-0.153401f, -0.450484f, -0.153401f }, {-0.306802f, -0.900969f, -0.306802f},},
		{{-0.276419f, -0.311745f, -0.276419f }, {-0.552838f, -0.623490f, -0.552838f},},
		{{-3.41749e-08f, -0.311745f, -0.390916f }, {-6.83499e-08f, -0.623490f, -0.781832f},},
		{{-0.153401f, -0.450484f, -0.153401f }, {-0.306802f, -0.900969f, -0.306802f},},
		{{-0.216942f, -0.450484f, 2.58700e-09f }, {-0.433884f, -0.900969f, 5.17401e-09f},},
		{{-0.276419f, -0.311745f, -0.276419f }, {-0.552838f, -0.623490f, -0.552838f},},
		{{-0.216942f, -0.450484f, 2.58700e-09f }, {-0.433884f, -0.900969f, 5.17401e-09f},},
		{{-0.390916f, -0.311745f, 4.66162e-09f }, {-0.781832f, -0.623490f, 9.32324e-09f},},
		{{-0.276419f, -0.311745f, -0.276419f }, {-0.552838f, -0.623490f, -0.552838f},},
		{{-0.216942f, -0.450484f, 2.58700e-09f }, {-0.433884f, -0.900969f, 5.17401e-09f},},
		{{-0.153401f, -0.450484f, 0.153401f }, {-0.306802f, -0.900969f, 0.306802f},},
		{{-0.390916f, -0.311745f, 4.66162e-09f }, {-0.781832f, -0.623490f, 9.32324e-09f},},
		{{-0.153401f, -0.450484f, 0.153401f }, {-0.306802f, -0.900969f, 0.306802f},},
		{{-0.276419f, -0.311745f, 0.276419f }, {-0.552838f, -0.623490f, 0.552839f},},
		{{-0.390916f, -0.311745f, 4.66162e-09f }, {-0.781832f, -0.623490f, 9.32324e-09f},},
		{{-0.153401f, -0.450484f, 0.153401f }, {-0.306802f, -0.900969f, 0.306802f},},
		{{0.00000f, -0.450484f, 0.216942f }, {0.00000f, -0.900969f, 0.433884f},},
		{{-0.276419f, -0.311745f, 0.276419f }, {-0.552838f, -0.623490f, 0.552839f},},
		{{0.00000f, -0.450484f, 0.216942f }, {0.00000f, -0.900969f, 0.433884f},},
		{{0.00000f, -0.311745f, 0.390916f }, {0.00000f, -0.623490f, 0.781832f},},
		{{-0.276419f, -0.311745f, 0.276419f }, {-0.552838f, -0.623490f, 0.552839f},},
		{{0.00000f, -0.311745f, 0.390916f }, {0.00000f, -0.623490f, 0.781832f},},
		{{0.276419f, -0.311745f, 0.276419f }, {0.552838f, -0.623490f, 0.552838f},},
		{{0.00000f, -0.111261f, 0.487464f }, {0.00000f, -0.222521f, 0.974928f},},
		{{0.276419f, -0.311745f, 0.276419f }, {0.552838f, -0.623490f, 0.552838f},},
		{{0.344689f, -0.111261f, 0.344689f }, {0.689378f, -0.222521f, 0.689378f},},
		{{0.00000f, -0.111261f, 0.487464f }, {0.00000f, -0.222521f, 0.974928f},},
		{{0.276419f, -0.311745f, 0.276419f }, {0.552838f, -0.623490f, 0.552838f},},
		{{0.390916f, -0.311745f, -1.70875e-08f }, {0.781832f, -0.623490f, -3.41749e-08f},},
		{{0.344689f, -0.111261f, 0.344689f }, {0.689378f, -0.222521f, 0.689378f},},
		{{0.390916f, -0.311745f, -1.70875e-08f }, {0.781832f, -0.623490f, -3.41749e-08f},},
		{{0.487464f, -0.111261f, -2.13077e-08f }, {0.974928f, -0.222521f, -4.26155e-08f},},
		{{0.344689f, -0.111261f, 0.344689f }, {0.689378f, -0.222521f, 0.689378f},},
		{{0.390916f, -0.311745f, -1.70875e-08f }, {0.781832f, -0.623490f, -3.41749e-08f},},
		{{0.276419f, -0.311745f, -0.276419f }, {0.552838f, -0.623490f, -0.552838f},},
		{{0.487464f, -0.111261f, -2.13077e-08f }, {0.974928f, -0.222521f, -4.26155e-08f},},
		{{0.276419f, -0.311745f, -0.276419f }, {0.552838f, -0.623490f, -0.552838f},},
		{{0.344689f, -0.111261f, -0.344689f }, {0.689378f, -0.222521f, -0.689378f},},
		{{0.487464f, -0.111261f, -2.13077e-08f }, {0.974928f, -0.222521f, -4.26155e-08f},},
		{{0.276419f, -0.311745f, -0.276419f }, {0.552838f, -0.623490f, -0.552838f},},
		{{-3.41749e-08f, -0.311745f, -0.390916f }, {-6.83499e-08f, -0.623490f, -0.781832f},},
		{{0.344689f, -0.111261f, -0.344689f }, {0.689378f, -0.222521f, -0.689378f},},
		{{-3.41749e-08f, -0.311745f, -0.390916f }, {-6.83499e-08f, -0.623490f, -0.781832f},},
		{{-4.26155e-08f, -0.111261f, -0.487464f }, {-8.52309e-08f, -0.222521f, -0.974928f},},
		{{0.344689f, -0.111261f, -0.344689f }, {0.689378f, -0.222521f, -0.689378f},},
		{{-3.41749e-08f, -0.311745f, -0.390916f }, {-6.83499e-08f, -0.623490f, -0.781832f},},
		{{-0.276419f, -0.311745f, -0.276419f }, {-0.552838f, -0.623490f, -0.552838f},},
		{{-4.26155e-08f, -0.111261f, -0.487464f }, {-8.52309e-08f, -0.222521f, -0.974928f},},
		{{-0.276419f, -0.311745f, -0.276419f }, {-0.552838f, -0.623490f, -0.552838f},},
		{{-0.344689f, -0.111261f, -0.344689f }, {-0.689378f, -0.222521f, -0.689378f},},
		{{-4.26155e-08f, -0.111261f, -0.487464f }, {-8.52309e-08f, -0.222521f, -0.974928f},},
		{{-0.276419f, -0.311745f, -0.276419f }, {-0.552838f, -0.623490f, -0.552838f},},
		{{-0.390916f, -0.311745f, 4.66162e-09f }, {-0.781832f, -0.623490f, 9.32324e-09f},},
		{{-0.344689f, -0.111261f, -0.344689f }, {-0.689378f, -0.222521f, -0.689378f},},
		{{-0.390916f, -0.311745f, 4.66162e-09f }, {-0.781832f, -0.623490f, 9.32324e-09f},},
		{{-0.487464f, -0.111261f, 5.81295e-09f }, {-0.974928f, -0.222521f, 1.16259e-08f},},
		{{-0.344689f, -0.111261f, -0.344689f }, {-0.689378f, -0.222521f, -0.689378f},},
		{{-0.390916f, -0.311745f, 4.66162e-09f }, {-0.781832f, -0.623490f, 9.32324e-09f},},
		{{-0.276419f, -0.311745f, 0.276419f }, {-0.552838f, -0.623490f, 0.552839f},},
		{{-0.487464f, -0.111261f, 5.81295e-09f }, {-0.974928f, -0.222521f, 1.16259e-08f},},
		{{-0.276419f, -0.311745f, 0.276419f }, {-0.552838f, -0.623490f, 0.552839f},},
		{{-0.344689f, -0.111261f, 0.344689f }, {-0.689378f, -0.222521f, 0.689378f},},
		{{-0.487464f, -0.111261f, 5.81295e-09f }, {-0.974928f, -0.222521f, 1.16259e-08f},},
		{{-0.276419f, -0.311745f, 0.276419f }, {-0.552838f, -0.623490f, 0.552839f},},
		{{0.00000f, -0.311745f, 0.390916f }, {0.00000f, -0.623490f, 0.781832f},},
		{{-0.344689f, -0.111261f, 0.344689f }, {-0.689378f, -0.222521f, 0.689378f},},
		{{0.00000f, -0.311745f, 0.390916f }, {0.00000f, -0.623490f, 0.781832f},},
		{{0.00000f, -0.111261f, 0.487464f }, {0.00000f, -0.222521f, 0.974928f},},
		{{-0.344689f, -0.111261f, 0.344689f }, {-0.689378f, -0.222521f, 0.689378f},},
		{{0.00000f, -0.111261f, 0.487464f }, {0.00000f, -0.222521f, 0.974928f},},
		{{0.344689f, -0.111261f, 0.344689f }, {0.689378f, -0.222521f, 0.689378f},},
		{{0.00000f, 0.111260f, 0.487464f }, {0.00000f, 0.222521f, 0.974928f},},
		{{0.344689f, -0.111261f, 0.344689f }, {0.689378f, -0.222521f, 0.689378f},},
		{{0.344689f, 0.111260f, 0.344689f }, {0.689378f, 0.222521f, 0.689378f},},
		{{0.00000f, 0.111260f, 0.487464f }, {0.00000f, 0.222521f, 0.974928f},},
		{{0.344689f, -0.111261f, 0.344689f }, {0.689378f, -0.222521f, 0.689378f},},
		{{0.487464f, -0.111261f, -2.13077e-08f }, {0.974928f, -0.222521f, -4.26155e-08f},},
		{{0.344689f, 0.111260f, 0.344689f }, {0.689378f, 0.222521f, 0.689378f},},
		{{0.487464f, -0.111261f, -2.13077e-08f }, {0.974928f, -0.222521f, -4.26155e-08f},},
		{{0.487464f, 0.111260f, -2.13077e-08f }, {0.974928f, 0.222521f, -4.26155e-08f},},
		{{0.344689f, 0.111260f, 0.344689f }, {0.689378f, 0.222521f, 0.689378f},},
		{{0.487464f, -0.111261f, -2.13077e-08f }, {0.974928f, -0.222521f, -4.26155e-08f},},
		{{0.344689f, -0.111261f, -0.344689f }, {0.689378f, -0.222521f, -0.689378f},},
		{{0.487464f, 0.111260f, -2.13077e-08f }, {0.974928f, 0.222521f, -4.26155e-08f},},
		{{0.344689f, -0.111261f, -0.344689f }, {0.689378f, -0.222521f, -0.689378f},},
		{{0.344689f, 0.111260f, -0.344689f }, {0.689378f, 0.222521f, -0.689378f},},
		{{0.487464f, 0.111260f, -2.13077e-08f }, {0.974928f, 0.222521f, -4.26155e-08f},},
		{{0.344689f, -0.111261f, -0.344689f }, {0.689378f, -0.222521f, -0.689378f},},
		{{-4.26155e-08f, -0.111261f, -0.487464f }, {-8.52309e-08f, -0.222521f, -0.974928f},},
		{{0.344689f, 0.111260f, -0.344689f }, {0.689378f, 0.222521f, -0.689378f},},
		{{-4.26155e-08f, -0.111261f, -0.487464f }, {-8.52309e-08f, -0.222521f, -0.974928f},},
		{{-4.26155e-08f, 0.111260f, -0.487464f }, {-8.52309e-08f, 0.222521f, -0.974928f},},
		{{0.344689f, 0.111260f, -0.344689f }, {0.689378f, 0.222521f, -0.689378f},},
		{{-4.26155e-08f, -0.111261f, -0.487464f }, {-8.52309e-08f, -0.222521f, -0.974928f},},
		{{-0.344689f, -0.111261f, -0.344689f }, {-0.689378f, -0.222521f, -0.689378f},},
		{{-4.26155e-08f, 0.111260f, -0.487464f }, {-8.52309e-08f, 0.222521f, -0.974928f},},
		{{-0.344689f, -0.111261f, -0.344689f }, {-0.689378f, -0.222521f, -0.689378f},},
		{{-0.344689f, 0.111260f, -0.344689f }, {-0.689378f, 0.222521f, -0.689378f},},
		{{-4.26155e-08f, 0.111260f, -0.487464f }, {-8.52309e-08f, 0.222521f, -0.974928f},},
		{{-0.344689f, -0.111261f, -0.344689f }, {-0.689378f, -0.222521f, -0.689378f},},
		{{-0.487464f, -0.111261f, 5.81295e-09f }, {-0.974928f, -0.222521f, 1.16259e-08f},},
		{{-0.344689f, 0.111260f, -0.344689f }, {-0.689378f, 0.222521f, -0.689378f},},
		{{-0.487464f, -0.111261f, 5.81295e-09f }, {-0.974928f, -0.222521f, 1.16259e-08f},},
		{{-0.487464f, 0.111260f, 5.81295e-09f }, {-0.974928f, 0.222521f, 1.16259e-08f},},
		{{-0.344689f, 0.111260f, -0.344689f }, {-0.689378f, 0.222521f, -0.689378f},},
		{{-0.487464f, -0.111261f, 5.81295e-09f }, {-0.974928f, -0.222521f, 1.16259e-08f},},
		{{-0.344689f, -0.111261f, 0.344689f }, {-0.689378f, -0.222521f, 0.689378f},},
		{{-0.487464f, 0.111260f, 5.81295e-09f }, {-0.974928f, 0.222521f, 1.16259e-08f},},
		{{-0.344689f, -0.111261f, 0.344689f }, {-0.689378f, -0.222521f, 0.689378f},},
		{{-0.344689f, 0.111260f, 0.344689f }, {-0.689378f, 0.222521f, 0.689378f},},
		{{-0.487464f, 0.111260f, 5.81295e-09f }, {-0.974928f, 0.222521f, 1.16259e-08f},},
		{{-0.344689f, -0.111261f, 0.344689f }, {-0.689378f, -0.222521f, 0.689378f},},
		{{0.00000f, -0.111261f, 0.487464f }, {0.00000f, -0.222521f, 0.974928f},},
		{{-0.344689f, 0.111260f, 0.344689f }, {-0.689378f, 0.222521f, 0.689378f},},
		{{0.00000f, -0.111261f, 0.487464f }, {0.00000f, -0.222521f, 0.974928f},},
		{{0.00000f, 0.111260f, 0.487464f }, {0.00000f, 0.222521f, 0.974928f},},
		{{-0.344689f, 0.111260f, 0.344689f }, {-0.689378f, 0.222521f, 0.689378f},},
		{{0.00000f, 0.111260f, 0.487464f }, {0.00000f, 0.222521f, 0.974928f},},
		{{0.344689f, 0.111260f, 0.344689f }, {0.689378f, 0.222521f, 0.689378f},},
		{{0.00000f, 0.311745f, 0.390916f }, {0.00000f, 0.623490f, 0.781831f},},
		{{0.344689f, 0.111260f, 0.344689f }, {0.689378f, 0.222521f, 0.689378f},},
		{{0.276419f, 0.311745f, 0.276419f }, {0.552838f, 0.623490f, 0.552838f},},
		{{0.00000f, 0.311745f, 0.390916f }, {0.00000f, 0.623490f, 0.781831f},},
		{{0.344689f, 0.111260f, 0.344689f }, {0.689378f, 0.222521f, 0.689378f},},
		{{0.487464f, 0.111260f, -2.13077e-08f }, {0.974928f, 0.222521f, -4.26155e-08f},},
		{{0.276419f, 0.311745f, 0.276419f }, {0.552838f, 0.623490f, 0.552838f},},
		{{0.487464f, 0.111260f, -2.13077e-08f }, {0.974928f, 0.222521f, -4.26155e-08f},},
		{{0.390916f, 0.311745f, -1.70875e-08f }, {0.781831f, 0.623490f, -3.41749e-08f},},
		{{0.276419f, 0.311745f, 0.276419f }, {0.552838f, 0.623490f, 0.552838f},},
		{{0.487464f, 0.111260f, -2.13077e-08f }, {0.974928f, 0.222521f, -4.26155e-08f},},
		{{0.344689f, 0.111260f, -0.344689f }, {0.689378f, 0.222521f, -0.689378f},},
		{{0.390916f, 0.311745f, -1.70875e-08f }, {0.781831f, 0.623490f, -3.41749e-08f},},
		{{0.344689f, 0.111260f, -0.344689f }, {0.689378f, 0.222521f, -0.689378f},},
		{{0.276419f, 0.311745f, -0.276419f }, {0.552838f, 0.623490f, -0.552838f},},
		{{0.390916f, 0.311745f, -1.70875e-08f }, {0.781831f, 0.623490f, -3.41749e-08f},},
		{{0.344689f, 0.111260f, -0.344689f }, {0.689378f, 0.222521f, -0.689378f},},
		{{-4.26155e-08f, 0.111260f, -0.487464f }, {-8.52309e-08f, 0.222521f, -0.974928f},},
		{{0.276419f, 0.311745f, -0.276419f }, {0.552838f, 0.623490f, -0.552838f},},
		{{-4.26155e-08f, 0.111260f, -0.487464f }, {-8.52309e-08f, 0.222521f, -0.974928f},},
		{{-3.41749e-08f, 0.311745f, -0.390916f }, {-6.83499e-08f, 0.623490f, -0.781831f},},
		{{0.276419f, 0.311745f, -0.276419f }, {0.552838f, 0.623490f, -0.552838f},},
		{{-4.26155e-08f, 0.111260f, -0.487464f }, {-8.52309e-08f, 0.222521f, -0.974928f},},
		{{-0.344689f, 0.111260f, -0.344689f }, {-0.689378f, 0.222521f, -0.689378f},},
		{{-3.41749e-08f, 0.311745f, -0.390916f }, {-6.83499e-08f, 0.623490f, -0.781831f},},
		{{-0.344689f, 0.111260f, -0.344689f }, {-0.689378f, 0.222521f, -0.689378f},},
		{{-0.276419f, 0.311745f, -0.276419f }, {-0.552838f, 0.623490f, -0.552838f},},
		{{-3.41749e-08f, 0.311745f, -0.390916f }, {-6.83499e-08f, 0.623490f, -0.781831f},},
		{{-0.344689f, 0.111260f, -0.344689f }, {-0.689378f, 0.222521f, -0.689378f},},
		{{-0.487464f, 0.111260f, 5.81295e-09f }, {-0.974928f, 0.222521f, 1.16259e-08f},},
		{{-0.276419f, 0.311745f, -0.276419f }, {-0.552838f, 0.623490f, -0.552838f},},
		{{-0.487464f, 0.111260f, 5.81295e-09f }, {-0.974928f, 0.222521f, 1.16259e-08f},},
		{{-0.390916f, 0.311745f, 4.66162e-09f }, {-0.781831f, 0.623490f, 9.32324e-09f},},
		{{-0.276419f, 0.311745f, -0.276419f }, {-0.552838f, 0.623490f, -0.552838f},},
		{{-0.487464f, 0.111260f, 5.81295e-09f }, {-0.974928f, 0.222521f, 1.16259e-08f},},
		{{-0.344689f, 0.111260f, 0.344689f }, {-0.689378f, 0.222521f, 0.689378f},},
		{{-0.390916f, 0.311745f, 4.66162e-09f }, {-0.781831f, 0.623490f, 9.32324e-09f},},
		{{-0.344689f, 0.111260f, 0.344689f }, {-0.689378f, 0.222521f, 0.689378f},},
		{{-0.276419f, 0.311745f, 0.276419f }, {-0.552838f, 0.623490f, 0.552839f},},
		{{-0.390916f, 0.311745f, 4.66162e-09f }, {-0.781831f, 0.623490f, 9.32324e-09f},},
		{{-0.344689f, 0.111260f, 0.344689f }, {-0.689378f, 0.222521f, 0.689378f},},
		{{0.00000f, 0.111260f, 0.487464f }, {0.00000f, 0.222521f, 0.974928f},},
		{{-0.276419f, 0.311745f, 0.276419f }, {-0.552838f, 0.623490f, 0.552839f},},
		{{0.00000f, 0.111260f, 0.487464f }, {0.00000f, 0.222521f, 0.974928f},},
		{{0.00000f, 0.311745f, 0.390916f }, {0.00000f, 0.623490f, 0.781831f},},
		{{-0.276419f, 0.311745f, 0.276419f }, {-0.552838f, 0.623490f, 0.552839f},},
		{{0.00000f, 0.311745f, 0.390916f }, {0.00000f, 0.623490f, 0.781831f},},
		{{0.276419f, 0.311745f, 0.276419f }, {0.552838f, 0.623490f, 0.552838f},},
		{{0.00000f, 0.450484f, 0.216942f }, {0.00000f, 0.900969f, 0.433884f},},
		{{0.276419f, 0.311745f, 0.276419f }, {0.552838f, 0.623490f, 0.552838f},},
		{{0.153401f, 0.450484f, 0.153401f }, {0.306802f, 0.900969f, 0.306802f},},
		{{0.00000f, 0.450484f, 0.216942f }, {0.00000f, 0.900969f, 0.433884f},},
		{{0.276419f, 0.311745f, 0.276419f }, {0.552838f, 0.623490f, 0.552838f},},
		{{0.390916f, 0.311745f, -1.70875e-08f }, {0.781831f, 0.623490f, -3.41749e-08f},},
		{{0.153401f, 0.450484f, 0.153401f }, {0.306802f, 0.900969f, 0.306802f},},
		{{0.390916f, 0.311745f, -1.70875e-08f }, {0.781831f, 0.623490f, -3.41749e-08f},},
		{{0.216942f, 0.450484f, -9.48283e-09f }, {0.433884f, 0.900969f, -1.89657e-08f},},
		{{0.153401f, 0.450484f, 0.153401f }, {0.306802f, 0.900969f, 0.306802f},},
		{{0.390916f, 0.311745f, -1.70875e-08f }, {0.781831f, 0.623490f, -3.41749e-08f},},
		{{0.276419f, 0.311745f, -0.276419f }, {0.552838f, 0.623490f, -0.552838f},},
		{{0.216942f, 0.450484f, -9.48283e-09f }, {0.433884f, 0.900969f, -1.89657e-08f},},
		{{0.276419f, 0.311745f, -0.276419f }, {0.552838f, 0.623490f, -0.552838f},},
		{{0.153401f, 0.450484f, -0.153401f }, {0.306802f, 0.900969f, -0.306802f},},
		{{0.216942f, 0.450484f, -9.48283e-09f }, {0.433884f, 0.900969f, -1.89657e-08f},},
		{{0.276419f, 0.311745f, -0.276419f }, {0.552838f, 0.623490f, -0.552838f},},
		{{-3.41749e-08f, 0.311745f, -0.390916f }, {-6.83499e-08f, 0.623490f, -0.781831f},},
		{{0.153401f, 0.450484f, -0.153401f }, {0.306802f, 0.900969f, -0.306802f},},
		{{-3.41749e-08f, 0.311745f, -0.390916f }, {-6.83499e-08f, 0.623490f, -0.781831f},},
		{{-1.89657e-08f, 0.450484f, -0.216942f }, {-3.79313e-08f, 0.900969f, -0.433884f},},
		{{0.153401f, 0.450484f, -0.153401f }, {0.306802f, 0.900969f, -0.306802f},},
		{{-3.41749e-08f, 0.311745f, -0.390916f }, {-6.83499e-08f, 0.623490f, -0.781831f},},
		{{-0.276419f, 0.311745f, -0.276419f }, {-0.552838f, 0.623490f, -0.552838f},},
		{{-1.89657e-08f, 0.450484f, -0.216942f }, {-3.79313e-08f, 0.900969f, -0.433884f},},
		{{-0.276419f, 0.311745f, -0.276419f }, {-0.552838f, 0.623490f, -0.552838f},},
		{{-0.153401f, 0.450484f, -0.153401f }, {-0.306802f, 0.900969f, -0.306802f},},
		{{-1.89657e-08f, 0.450484f, -0.216942f }, {-3.79313e-08f, 0.900969f, -0.433884f},},
		{{-0.276419f, 0.311745f, -0.276419f }, {-0.552838f, 0.623490f, -0.552838f},},
		{{-0.390916f, 0.311745f, 4.66162e-09f }, {-0.781831f, 0.623490f, 9.32324e-09f},},
		{{-0.153401f, 0.450484f, -0.153401f }, {-0.306802f, 0.900969f, -0.306802f},},
		{{-0.390916f, 0.311745f, 4.66162e-09f }, {-0.781831f, 0.623490f, 9.32324e-09f},},
		{{-0.216942f, 0.450484f, 2.58701e-09f }, {-0.433884f, 0.900969f, 5.17401e-09f},},
		{{-0.153401f, 0.450484f, -0.153401f }, {-0.306802f, 0.900969f, -0.306802f},},
		{{-0.390916f, 0.311745f, 4.66162e-09f }, {-0.781831f, 0.623490f, 9.32324e-09f},},
		{{-0.276419f, 0.311745f, 0.276419f }, {-0.552838f, 0.623490f, 0.552839f},},
		{{-0.216942f, 0.450484f, 2.58701e-09f }, {-0.433884f, 0.900969f, 5.17401e-09f},},
		{{-0.276419f, 0.311745f, 0.276419f }, {-0.552838f, 0.623490f, 0.552839f},},
		{{-0.153401f, 0.450484f, 0.153401f }, {-0.306802f, 0.900969f, 0.306802f},},
		{{-0.216942f, 0.450484f, 2.58701e-09f }, {-0.433884f, 0.900969f, 5.17401e-09f},},
		{{-0.276419f, 0.311745f, 0.276419f }, {-0.552838f, 0.623490f, 0.552839f},},
		{{0.00000f, 0.311745f, 0.390916f }, {0.00000f, 0.623490f, 0.781831f},},
		{{-0.153401f, 0.450484f, 0.153401f }, {-0.306802f, 0.900969f, 0.306802f},},
		{{0.00000f, 0.311745f, 0.390916f }, {0.00000f, 0.623490f, 0.781831f},},
		{{0.00000f, 0.450484f, 0.216942f }, {0.00000f, 0.900969f, 0.433884f},},
		{{-0.153401f, 0.450484f, 0.153401f }, {-0.306802f, 0.900969f, 0.306802f},},
		/////////////////////////
		{{0.00000f, 0.500000f, 0.00000f }, {0.00000f, 1.00000f, 0.00000f},},
		{{-0.216942f, 0.450484f, 2.58701e-09f }, {-0.433884f, 0.900969f, 5.17401e-09f},},
		{{-0.153401f, 0.450484f, 0.153401f }, {-0.306802f, 0.900969f, 0.306802f},},
		{{0.00000f, 0.500000f, 0.00000f }, {0.00000f, 1.00000f, 0.00000f},},
		{{-0.153401f, 0.450484f, -0.153401f }, {-0.306802f, 0.900969f, -0.306802f},},
		{{-0.216942f, 0.450484f, 2.58701e-09f }, {-0.433884f, 0.900969f, 5.17401e-09f},},
		{{0.00000f, 0.500000f, 0.00000f }, {0.00000f, 1.00000f, 0.00000f},},
		{{-1.89657e-08f, 0.450484f, -0.216942f }, {-3.79313e-08f, 0.900969f, -0.433884f},},
		{{-0.153401f, 0.450484f, -0.153401f }, {-0.306802f, 0.900969f, -0.306802f},},
		{{0.00000f, 0.500000f, 0.00000f }, {0.00000f, 1.00000f, 0.00000f},},
		{{0.153401f, 0.450484f, -0.153401f }, {0.306802f, 0.900969f, -0.306802f},},
		{{-1.89657e-08f, 0.450484f, -0.216942f }, {-3.79313e-08f, 0.900969f, -0.433884f},},
		{{0.00000f, 0.500000f, 0.00000f }, {0.00000f, 1.00000f, 0.00000f},},
		{{0.216942f, 0.450484f, -9.48283e-09f }, {0.433884f, 0.900969f, -1.89657e-08f},},
		{{0.153401f, 0.450484f, -0.153401f }, {0.306802f, 0.900969f, -0.306802f},},
		{{0.00000f, 0.500000f, 0.00000f }, {0.00000f, 1.00000f, 0.00000f},},
		{{0.153401f, 0.450484f, 0.153401f }, {0.306802f, 0.900969f, 0.306802f},},
		{{0.216942f, 0.450484f, -9.48283e-09f }, {0.433884f, 0.900969f, -1.89657e-08f},},
		{{0.00000f, 0.500000f, 0.00000f }, {0.00000f, 1.00000f, 0.00000f},},
		{{0.00000f, 0.450484f, 0.216942f }, {0.00000f, 0.900969f, 0.433884f},},
		{{0.153401f, 0.450484f, 0.153401f }, {0.306802f, 0.900969f, 0.306802f},},
		{{0.00000f, 0.500000f, 0.00000f }, {0.00000f, 1.00000f, 0.00000f},},
		{{-0.153401f, 0.450484f, 0.153401f }, {-0.306802f, 0.900969f, 0.306802f},},
		{{0.00000f, 0.450484f, 0.216942f }, {0.00000f, 0.900969f, 0.433884f},},
		/////////////////////////
	};
	vertex = new graphics::VertexBuffer<graphics::VertexPositionNormal>(graphics::TRIANGLES, v, NELEMS(v));
}
/*!
\brief C[t[̃RXgN^
*/
primitive::WireSphere::WireSphere() : vertex(0) 
{
#if 0
#ifdef _DEBUG
	Vector3 pos[500];
	u32 n(0);
	f32 r(0.5f);
	pos[n++] = -Vector3::UnitY() * r;
	for(u32 i=1;i<_VSTEPS - 1;++i){
		f32 l((static_cast<f32>(i) * INDI_PI / static_cast<f32>(_VSTEPS - 1)) - INDI_PI * 0.5f);
		f32 y(math::Sin(l));
		f32 xz(math::Cos(l));
		for(u32 j=0;j<_HSTEPS;++j){
			f32 ll(static_cast<f32>(j) * INDI_PI * 2.0f / static_cast<f32>(_HSTEPS));
			f32 x(math::Sin(ll) * xz);
			f32 z(math::Cos(ll) * xz);
			pos[n++] = Vector3(x, y, z) * r;
		}
	}
	pos[n++] = Vector3::UnitY() * r;

	for(u32 i=0;i<_HSTEPS;++i){
		u32 idx(0);
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f},}," << endl;
		idx = i + 1;
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f},}," << endl;
	}
	cout << "\t\t/////////////////////////" << endl;

	for(u32 i=0;i<_VSTEPS - 2;++i){
		for(u32 j=0;j<_HSTEPS;++j){
			u32 nj((j + 1) % _HSTEPS);

			u32 idx(1 + i * _HSTEPS + j);
			cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f},}," << endl;
			idx = 1 + i * _HSTEPS + nj;
			cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f},}," << endl;

			if(i > 0){
				idx = 1 + (i - 1) * _HSTEPS + j;
				cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f},}," << endl;
				idx = 1 + i * _HSTEPS + j;
				cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f},}," << endl;
			}
		}
	}
	cout << "\t\t/////////////////////////" << endl;

	for(u32 i=0;i<_HSTEPS;++i){
		u32 idx(n - 1);
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f},}," << endl;
		idx = n - 2 - i;
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f},}," << endl;
	}
	cout << "\t\t/////////////////////////" << endl;
#endif
#endif
	graphics::VertexPosition v[] = {
		{{0.00000f, -0.500000f, 0.00000f},},
		{{0.00000f, -0.450484f, 0.216942f},},
		{{0.00000f, -0.500000f, 0.00000f},},
		{{0.153401f, -0.450484f, 0.153401f},},
		{{0.00000f, -0.500000f, 0.00000f},},
		{{0.216942f, -0.450484f, -9.48283e-09f},},
		{{0.00000f, -0.500000f, 0.00000f},},
		{{0.153401f, -0.450484f, -0.153401f},},
		{{0.00000f, -0.500000f, 0.00000f},},
		{{-1.89657e-08f, -0.450484f, -0.216942f},},
		{{0.00000f, -0.500000f, 0.00000f},},
		{{-0.153401f, -0.450484f, -0.153401f},},
		{{0.00000f, -0.500000f, 0.00000f},},
		{{-0.216942f, -0.450484f, 2.58700e-09f},},
		{{0.00000f, -0.500000f, 0.00000f},},
		{{-0.153401f, -0.450484f, 0.153401f},},
		/////////////////////////
		{{0.00000f, -0.450484f, 0.216942f},},
		{{0.153401f, -0.450484f, 0.153401f},},
		{{0.153401f, -0.450484f, 0.153401f},},
		{{0.216942f, -0.450484f, -9.48283e-09f},},
		{{0.216942f, -0.450484f, -9.48283e-09f},},
		{{0.153401f, -0.450484f, -0.153401f},},
		{{0.153401f, -0.450484f, -0.153401f},},
		{{-1.89657e-08f, -0.450484f, -0.216942f},},
		{{-1.89657e-08f, -0.450484f, -0.216942f},},
		{{-0.153401f, -0.450484f, -0.153401f},},
		{{-0.153401f, -0.450484f, -0.153401f},},
		{{-0.216942f, -0.450484f, 2.58700e-09f},},
		{{-0.216942f, -0.450484f, 2.58700e-09f},},
		{{-0.153401f, -0.450484f, 0.153401f},},
		{{-0.153401f, -0.450484f, 0.153401f},},
		{{0.00000f, -0.450484f, 0.216942f},},
		{{0.00000f, -0.311745f, 0.390916f},},
		{{0.276419f, -0.311745f, 0.276419f},},
		{{0.00000f, -0.450484f, 0.216942f},},
		{{0.00000f, -0.311745f, 0.390916f},},
		{{0.276419f, -0.311745f, 0.276419f},},
		{{0.390916f, -0.311745f, -1.70875e-08f},},
		{{0.153401f, -0.450484f, 0.153401f},},
		{{0.276419f, -0.311745f, 0.276419f},},
		{{0.390916f, -0.311745f, -1.70875e-08f},},
		{{0.276419f, -0.311745f, -0.276419f},},
		{{0.216942f, -0.450484f, -9.48283e-09f},},
		{{0.390916f, -0.311745f, -1.70875e-08f},},
		{{0.276419f, -0.311745f, -0.276419f},},
		{{-3.41749e-08f, -0.311745f, -0.390916f},},
		{{0.153401f, -0.450484f, -0.153401f},},
		{{0.276419f, -0.311745f, -0.276419f},},
		{{-3.41749e-08f, -0.311745f, -0.390916f},},
		{{-0.276419f, -0.311745f, -0.276419f},},
		{{-1.89657e-08f, -0.450484f, -0.216942f},},
		{{-3.41749e-08f, -0.311745f, -0.390916f},},
		{{-0.276419f, -0.311745f, -0.276419f},},
		{{-0.390916f, -0.311745f, 4.66162e-09f},},
		{{-0.153401f, -0.450484f, -0.153401f},},
		{{-0.276419f, -0.311745f, -0.276419f},},
		{{-0.390916f, -0.311745f, 4.66162e-09f},},
		{{-0.276419f, -0.311745f, 0.276419f},},
		{{-0.216942f, -0.450484f, 2.58700e-09f},},
		{{-0.390916f, -0.311745f, 4.66162e-09f},},
		{{-0.276419f, -0.311745f, 0.276419f},},
		{{0.00000f, -0.311745f, 0.390916f},},
		{{-0.153401f, -0.450484f, 0.153401f},},
		{{-0.276419f, -0.311745f, 0.276419f},},
		{{0.00000f, -0.111261f, 0.487464f},},
		{{0.344689f, -0.111261f, 0.344689f},},
		{{0.00000f, -0.311745f, 0.390916f},},
		{{0.00000f, -0.111261f, 0.487464f},},
		{{0.344689f, -0.111261f, 0.344689f},},
		{{0.487464f, -0.111261f, -2.13077e-08f},},
		{{0.276419f, -0.311745f, 0.276419f},},
		{{0.344689f, -0.111261f, 0.344689f},},
		{{0.487464f, -0.111261f, -2.13077e-08f},},
		{{0.344689f, -0.111261f, -0.344689f},},
		{{0.390916f, -0.311745f, -1.70875e-08f},},
		{{0.487464f, -0.111261f, -2.13077e-08f},},
		{{0.344689f, -0.111261f, -0.344689f},},
		{{-4.26155e-08f, -0.111261f, -0.487464f},},
		{{0.276419f, -0.311745f, -0.276419f},},
		{{0.344689f, -0.111261f, -0.344689f},},
		{{-4.26155e-08f, -0.111261f, -0.487464f},},
		{{-0.344689f, -0.111261f, -0.344689f},},
		{{-3.41749e-08f, -0.311745f, -0.390916f},},
		{{-4.26155e-08f, -0.111261f, -0.487464f},},
		{{-0.344689f, -0.111261f, -0.344689f},},
		{{-0.487464f, -0.111261f, 5.81295e-09f},},
		{{-0.276419f, -0.311745f, -0.276419f},},
		{{-0.344689f, -0.111261f, -0.344689f},},
		{{-0.487464f, -0.111261f, 5.81295e-09f},},
		{{-0.344689f, -0.111261f, 0.344689f},},
		{{-0.390916f, -0.311745f, 4.66162e-09f},},
		{{-0.487464f, -0.111261f, 5.81295e-09f},},
		{{-0.344689f, -0.111261f, 0.344689f},},
		{{0.00000f, -0.111261f, 0.487464f},},
		{{-0.276419f, -0.311745f, 0.276419f},},
		{{-0.344689f, -0.111261f, 0.344689f},},
		{{0.00000f, 0.111260f, 0.487464f},},
		{{0.344689f, 0.111260f, 0.344689f},},
		{{0.00000f, -0.111261f, 0.487464f},},
		{{0.00000f, 0.111260f, 0.487464f},},
		{{0.344689f, 0.111260f, 0.344689f},},
		{{0.487464f, 0.111260f, -2.13077e-08f},},
		{{0.344689f, -0.111261f, 0.344689f},},
		{{0.344689f, 0.111260f, 0.344689f},},
		{{0.487464f, 0.111260f, -2.13077e-08f},},
		{{0.344689f, 0.111260f, -0.344689f},},
		{{0.487464f, -0.111261f, -2.13077e-08f},},
		{{0.487464f, 0.111260f, -2.13077e-08f},},
		{{0.344689f, 0.111260f, -0.344689f},},
		{{-4.26155e-08f, 0.111260f, -0.487464f},},
		{{0.344689f, -0.111261f, -0.344689f},},
		{{0.344689f, 0.111260f, -0.344689f},},
		{{-4.26155e-08f, 0.111260f, -0.487464f},},
		{{-0.344689f, 0.111260f, -0.344689f},},
		{{-4.26155e-08f, -0.111261f, -0.487464f},},
		{{-4.26155e-08f, 0.111260f, -0.487464f},},
		{{-0.344689f, 0.111260f, -0.344689f},},
		{{-0.487464f, 0.111260f, 5.81295e-09f},},
		{{-0.344689f, -0.111261f, -0.344689f},},
		{{-0.344689f, 0.111260f, -0.344689f},},
		{{-0.487464f, 0.111260f, 5.81295e-09f},},
		{{-0.344689f, 0.111260f, 0.344689f},},
		{{-0.487464f, -0.111261f, 5.81295e-09f},},
		{{-0.487464f, 0.111260f, 5.81295e-09f},},
		{{-0.344689f, 0.111260f, 0.344689f},},
		{{0.00000f, 0.111260f, 0.487464f},},
		{{-0.344689f, -0.111261f, 0.344689f},},
		{{-0.344689f, 0.111260f, 0.344689f},},
		{{0.00000f, 0.311745f, 0.390916f},},
		{{0.276419f, 0.311745f, 0.276419f},},
		{{0.00000f, 0.111260f, 0.487464f},},
		{{0.00000f, 0.311745f, 0.390916f},},
		{{0.276419f, 0.311745f, 0.276419f},},
		{{0.390916f, 0.311745f, -1.70875e-08f},},
		{{0.344689f, 0.111260f, 0.344689f},},
		{{0.276419f, 0.311745f, 0.276419f},},
		{{0.390916f, 0.311745f, -1.70875e-08f},},
		{{0.276419f, 0.311745f, -0.276419f},},
		{{0.487464f, 0.111260f, -2.13077e-08f},},
		{{0.390916f, 0.311745f, -1.70875e-08f},},
		{{0.276419f, 0.311745f, -0.276419f},},
		{{-3.41749e-08f, 0.311745f, -0.390916f},},
		{{0.344689f, 0.111260f, -0.344689f},},
		{{0.276419f, 0.311745f, -0.276419f},},
		{{-3.41749e-08f, 0.311745f, -0.390916f},},
		{{-0.276419f, 0.311745f, -0.276419f},},
		{{-4.26155e-08f, 0.111260f, -0.487464f},},
		{{-3.41749e-08f, 0.311745f, -0.390916f},},
		{{-0.276419f, 0.311745f, -0.276419f},},
		{{-0.390916f, 0.311745f, 4.66162e-09f},},
		{{-0.344689f, 0.111260f, -0.344689f},},
		{{-0.276419f, 0.311745f, -0.276419f},},
		{{-0.390916f, 0.311745f, 4.66162e-09f},},
		{{-0.276419f, 0.311745f, 0.276419f},},
		{{-0.487464f, 0.111260f, 5.81295e-09f},},
		{{-0.390916f, 0.311745f, 4.66162e-09f},},
		{{-0.276419f, 0.311745f, 0.276419f},},
		{{0.00000f, 0.311745f, 0.390916f},},
		{{-0.344689f, 0.111260f, 0.344689f},},
		{{-0.276419f, 0.311745f, 0.276419f},},
		{{0.00000f, 0.450484f, 0.216942f},},
		{{0.153401f, 0.450484f, 0.153401f},},
		{{0.00000f, 0.311745f, 0.390916f},},
		{{0.00000f, 0.450484f, 0.216942f},},
		{{0.153401f, 0.450484f, 0.153401f},},
		{{0.216942f, 0.450484f, -9.48283e-09f},},
		{{0.276419f, 0.311745f, 0.276419f},},
		{{0.153401f, 0.450484f, 0.153401f},},
		{{0.216942f, 0.450484f, -9.48283e-09f},},
		{{0.153401f, 0.450484f, -0.153401f},},
		{{0.390916f, 0.311745f, -1.70875e-08f},},
		{{0.216942f, 0.450484f, -9.48283e-09f},},
		{{0.153401f, 0.450484f, -0.153401f},},
		{{-1.89657e-08f, 0.450484f, -0.216942f},},
		{{0.276419f, 0.311745f, -0.276419f},},
		{{0.153401f, 0.450484f, -0.153401f},},
		{{-1.89657e-08f, 0.450484f, -0.216942f},},
		{{-0.153401f, 0.450484f, -0.153401f},},
		{{-3.41749e-08f, 0.311745f, -0.390916f},},
		{{-1.89657e-08f, 0.450484f, -0.216942f},},
		{{-0.153401f, 0.450484f, -0.153401f},},
		{{-0.216942f, 0.450484f, 2.58701e-09f},},
		{{-0.276419f, 0.311745f, -0.276419f},},
		{{-0.153401f, 0.450484f, -0.153401f},},
		{{-0.216942f, 0.450484f, 2.58701e-09f},},
		{{-0.153401f, 0.450484f, 0.153401f},},
		{{-0.390916f, 0.311745f, 4.66162e-09f},},
		{{-0.216942f, 0.450484f, 2.58701e-09f},},
		{{-0.153401f, 0.450484f, 0.153401f},},
		{{0.00000f, 0.450484f, 0.216942f},},
		{{-0.276419f, 0.311745f, 0.276419f},},
		{{-0.153401f, 0.450484f, 0.153401f},},
		/////////////////////////
		{{0.00000f, 0.500000f, 0.00000f},},
		{{-0.153401f, 0.450484f, 0.153401f},},
		{{0.00000f, 0.500000f, 0.00000f},},
		{{-0.216942f, 0.450484f, 2.58701e-09f},},
		{{0.00000f, 0.500000f, 0.00000f},},
		{{-0.153401f, 0.450484f, -0.153401f},},
		{{0.00000f, 0.500000f, 0.00000f},},
		{{-1.89657e-08f, 0.450484f, -0.216942f},},
		{{0.00000f, 0.500000f, 0.00000f},},
		{{0.153401f, 0.450484f, -0.153401f},},
		{{0.00000f, 0.500000f, 0.00000f},},
		{{0.216942f, 0.450484f, -9.48283e-09f},},
		{{0.00000f, 0.500000f, 0.00000f},},
		{{0.153401f, 0.450484f, 0.153401f},},
		{{0.00000f, 0.500000f, 0.00000f},},
		{{0.00000f, 0.450484f, 0.216942f},},
		/////////////////////////
	};
	vertex = new graphics::VertexBuffer<graphics::VertexPosition>(graphics::LINES, v, NELEMS(v));
}

/*!
\brief JvZ̃RXgN^
*/
primitive::Capsule::Capsule() : vertex(0) 
{
#if 0
#ifdef _DEBUG
	Vector3 pos[500];
	Vector3 nrm[500];
	u32 n(0);
	f32 r(0.5f);
	f32 hh(0.5f); //< half height
	pos[n] = -Vector3::UnitY() * r - Vector3::UnitY() * hh;
	nrm[n++] = -Vector3::UnitY();
	for(u32 i=1;i<_VSTEPS / 2;++i){
		f32 l((static_cast<f32>(i) * INDI_PI / static_cast<f32>(_VSTEPS - 1)) - INDI_PI * 0.5f);
		f32 y(math::Sin(l) * r - hh);
		f32 xz(math::Cos(l) * r);
		for(u32 j=0;j<_HSTEPS;++j){
			f32 ll(static_cast<f32>(j) * INDI_PI * 2.0f / static_cast<f32>(_HSTEPS));
			f32 x(math::Sin(ll) * xz);
			f32 z(math::Cos(ll) * xz);
			pos[n] = Vector3(x, y, z);
			nrm[n++] = Vector3(x, y, z);
		}
	}
	for(u32 i=_VSTEPS / 2;i<_VSTEPS -1;++i){
		f32 l((static_cast<f32>(i) * INDI_PI / static_cast<f32>(_VSTEPS - 1)) - INDI_PI * 0.5f);
		f32 y(math::Sin(l) * r + hh);
		f32 xz(math::Cos(l) * r);
		for(u32 j=0;j<_HSTEPS;++j){
			f32 ll(static_cast<f32>(j) * INDI_PI * 2.0f / static_cast<f32>(_HSTEPS));
			f32 x(math::Sin(ll) * xz);
			f32 z(math::Cos(ll) * xz);
			pos[n] = Vector3(x, y, z);
			nrm[n++] = Vector3(x, y, z);
		}
	}
	pos[n] = Vector3::UnitY() * r + Vector3::UnitY() * hh;
	nrm[n++] = Vector3::UnitY();

	for(u32 i=0;i<_HSTEPS;++i){
		u32 idx(0);
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
		idx = ((i + 1) % _HSTEPS) + 1;
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
		idx = i + 1;
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
	}
	cout << "\t\t/////////////////////////" << endl;

	for(u32 i=0;i<_VSTEPS - 3;++i){
		for(u32 j=0;j<_HSTEPS;++j){
			u32 ni(i + 1);
			u32 nj((j + 1) % _HSTEPS);

			u32 idx(1 + i * _HSTEPS + j);
			cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
			idx = 1 + i * _HSTEPS + nj;
			cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
			idx = 1 + ni * _HSTEPS + j;
			cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;

			idx = 1 + i * _HSTEPS + nj;
			cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
			idx = 1 + ni * _HSTEPS + nj;
			cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
			idx = 1 + ni * _HSTEPS + j;
			cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
		}
	}
	cout << "\t\t/////////////////////////" << endl;

	for(u32 i=0;i<_HSTEPS;++i){
		u32 idx(n - 1);
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
		idx = n - 2 - ((i + 1) % _HSTEPS);
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
		idx = n - 2 - i;
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
	}
	cout << "\t\t/////////////////////////" << endl;
#endif
#endif
	graphics::VertexPositionNormal v[] = {
		{{0.00000f, -1.00000f, 0.00000f }, {-0.00000f, -1.00000f, -0.00000f},},
		{{0.153401f, -0.950484f, 0.153401f }, {0.153401f, -0.950484f, 0.153401f},},
		{{0.00000f, -0.950484f, 0.216942f }, {0.00000f, -0.950484f, 0.216942f},},
		{{0.00000f, -1.00000f, 0.00000f }, {-0.00000f, -1.00000f, -0.00000f},},
		{{0.216942f, -0.950484f, -9.48283e-09f }, {0.216942f, -0.950484f, -9.48283e-09f},},
		{{0.153401f, -0.950484f, 0.153401f }, {0.153401f, -0.950484f, 0.153401f},},
		{{0.00000f, -1.00000f, 0.00000f }, {-0.00000f, -1.00000f, -0.00000f},},
		{{0.153401f, -0.950484f, -0.153401f }, {0.153401f, -0.950484f, -0.153401f},},
		{{0.216942f, -0.950484f, -9.48283e-09f }, {0.216942f, -0.950484f, -9.48283e-09f},},
		{{0.00000f, -1.00000f, 0.00000f }, {-0.00000f, -1.00000f, -0.00000f},},
		{{-1.89657e-08f, -0.950484f, -0.216942f }, {-1.89657e-08f, -0.950484f, -0.216942f},},
		{{0.153401f, -0.950484f, -0.153401f }, {0.153401f, -0.950484f, -0.153401f},},
		{{0.00000f, -1.00000f, 0.00000f }, {-0.00000f, -1.00000f, -0.00000f},},
		{{-0.153401f, -0.950484f, -0.153401f }, {-0.153401f, -0.950484f, -0.153401f},},
		{{-1.89657e-08f, -0.950484f, -0.216942f }, {-1.89657e-08f, -0.950484f, -0.216942f},},
		{{0.00000f, -1.00000f, 0.00000f }, {-0.00000f, -1.00000f, -0.00000f},},
		{{-0.216942f, -0.950484f, 2.58700e-09f }, {-0.216942f, -0.950484f, 2.58700e-09f},},
		{{-0.153401f, -0.950484f, -0.153401f }, {-0.153401f, -0.950484f, -0.153401f},},
		{{0.00000f, -1.00000f, 0.00000f }, {-0.00000f, -1.00000f, -0.00000f},},
		{{-0.153401f, -0.950484f, 0.153401f }, {-0.153401f, -0.950484f, 0.153401f},},
		{{-0.216942f, -0.950484f, 2.58700e-09f }, {-0.216942f, -0.950484f, 2.58700e-09f},},
		{{0.00000f, -1.00000f, 0.00000f }, {-0.00000f, -1.00000f, -0.00000f},},
		{{0.00000f, -0.950484f, 0.216942f }, {0.00000f, -0.950484f, 0.216942f},},
		{{-0.153401f, -0.950484f, 0.153401f }, {-0.153401f, -0.950484f, 0.153401f},},
		/////////////////////////
		{{0.00000f, -0.950484f, 0.216942f }, {0.00000f, -0.950484f, 0.216942f},},
		{{0.153401f, -0.950484f, 0.153401f }, {0.153401f, -0.950484f, 0.153401f},},
		{{0.00000f, -0.811745f, 0.390916f }, {0.00000f, -0.811745f, 0.390916f},},
		{{0.153401f, -0.950484f, 0.153401f }, {0.153401f, -0.950484f, 0.153401f},},
		{{0.276419f, -0.811745f, 0.276419f }, {0.276419f, -0.811745f, 0.276419f},},
		{{0.00000f, -0.811745f, 0.390916f }, {0.00000f, -0.811745f, 0.390916f},},
		{{0.153401f, -0.950484f, 0.153401f }, {0.153401f, -0.950484f, 0.153401f},},
		{{0.216942f, -0.950484f, -9.48283e-09f }, {0.216942f, -0.950484f, -9.48283e-09f},},
		{{0.276419f, -0.811745f, 0.276419f }, {0.276419f, -0.811745f, 0.276419f},},
		{{0.216942f, -0.950484f, -9.48283e-09f }, {0.216942f, -0.950484f, -9.48283e-09f},},
		{{0.390916f, -0.811745f, -1.70875e-08f }, {0.390916f, -0.811745f, -1.70875e-08f},},
		{{0.276419f, -0.811745f, 0.276419f }, {0.276419f, -0.811745f, 0.276419f},},
		{{0.216942f, -0.950484f, -9.48283e-09f }, {0.216942f, -0.950484f, -9.48283e-09f},},
		{{0.153401f, -0.950484f, -0.153401f }, {0.153401f, -0.950484f, -0.153401f},},
		{{0.390916f, -0.811745f, -1.70875e-08f }, {0.390916f, -0.811745f, -1.70875e-08f},},
		{{0.153401f, -0.950484f, -0.153401f }, {0.153401f, -0.950484f, -0.153401f},},
		{{0.276419f, -0.811745f, -0.276419f }, {0.276419f, -0.811745f, -0.276419f},},
		{{0.390916f, -0.811745f, -1.70875e-08f }, {0.390916f, -0.811745f, -1.70875e-08f},},
		{{0.153401f, -0.950484f, -0.153401f }, {0.153401f, -0.950484f, -0.153401f},},
		{{-1.89657e-08f, -0.950484f, -0.216942f }, {-1.89657e-08f, -0.950484f, -0.216942f},},
		{{0.276419f, -0.811745f, -0.276419f }, {0.276419f, -0.811745f, -0.276419f},},
		{{-1.89657e-08f, -0.950484f, -0.216942f }, {-1.89657e-08f, -0.950484f, -0.216942f},},
		{{-3.41749e-08f, -0.811745f, -0.390916f }, {-3.41749e-08f, -0.811745f, -0.390916f},},
		{{0.276419f, -0.811745f, -0.276419f }, {0.276419f, -0.811745f, -0.276419f},},
		{{-1.89657e-08f, -0.950484f, -0.216942f }, {-1.89657e-08f, -0.950484f, -0.216942f},},
		{{-0.153401f, -0.950484f, -0.153401f }, {-0.153401f, -0.950484f, -0.153401f},},
		{{-3.41749e-08f, -0.811745f, -0.390916f }, {-3.41749e-08f, -0.811745f, -0.390916f},},
		{{-0.153401f, -0.950484f, -0.153401f }, {-0.153401f, -0.950484f, -0.153401f},},
		{{-0.276419f, -0.811745f, -0.276419f }, {-0.276419f, -0.811745f, -0.276419f},},
		{{-3.41749e-08f, -0.811745f, -0.390916f }, {-3.41749e-08f, -0.811745f, -0.390916f},},
		{{-0.153401f, -0.950484f, -0.153401f }, {-0.153401f, -0.950484f, -0.153401f},},
		{{-0.216942f, -0.950484f, 2.58700e-09f }, {-0.216942f, -0.950484f, 2.58700e-09f},},
		{{-0.276419f, -0.811745f, -0.276419f }, {-0.276419f, -0.811745f, -0.276419f},},
		{{-0.216942f, -0.950484f, 2.58700e-09f }, {-0.216942f, -0.950484f, 2.58700e-09f},},
		{{-0.390916f, -0.811745f, 4.66162e-09f }, {-0.390916f, -0.811745f, 4.66162e-09f},},
		{{-0.276419f, -0.811745f, -0.276419f }, {-0.276419f, -0.811745f, -0.276419f},},
		{{-0.216942f, -0.950484f, 2.58700e-09f }, {-0.216942f, -0.950484f, 2.58700e-09f},},
		{{-0.153401f, -0.950484f, 0.153401f }, {-0.153401f, -0.950484f, 0.153401f},},
		{{-0.390916f, -0.811745f, 4.66162e-09f }, {-0.390916f, -0.811745f, 4.66162e-09f},},
		{{-0.153401f, -0.950484f, 0.153401f }, {-0.153401f, -0.950484f, 0.153401f},},
		{{-0.276419f, -0.811745f, 0.276419f }, {-0.276419f, -0.811745f, 0.276419f},},
		{{-0.390916f, -0.811745f, 4.66162e-09f }, {-0.390916f, -0.811745f, 4.66162e-09f},},
		{{-0.153401f, -0.950484f, 0.153401f }, {-0.153401f, -0.950484f, 0.153401f},},
		{{0.00000f, -0.950484f, 0.216942f }, {0.00000f, -0.950484f, 0.216942f},},
		{{-0.276419f, -0.811745f, 0.276419f }, {-0.276419f, -0.811745f, 0.276419f},},
		{{0.00000f, -0.950484f, 0.216942f }, {0.00000f, -0.950484f, 0.216942f},},
		{{0.00000f, -0.811745f, 0.390916f }, {0.00000f, -0.811745f, 0.390916f},},
		{{-0.276419f, -0.811745f, 0.276419f }, {-0.276419f, -0.811745f, 0.276419f},},
		{{0.00000f, -0.811745f, 0.390916f }, {0.00000f, -0.811745f, 0.390916f},},
		{{0.276419f, -0.811745f, 0.276419f }, {0.276419f, -0.811745f, 0.276419f},},
		{{0.00000f, -0.611261f, 0.487464f }, {0.00000f, -0.611261f, 0.487464f},},
		{{0.276419f, -0.811745f, 0.276419f }, {0.276419f, -0.811745f, 0.276419f},},
		{{0.344689f, -0.611261f, 0.344689f }, {0.344689f, -0.611261f, 0.344689f},},
		{{0.00000f, -0.611261f, 0.487464f }, {0.00000f, -0.611261f, 0.487464f},},
		{{0.276419f, -0.811745f, 0.276419f }, {0.276419f, -0.811745f, 0.276419f},},
		{{0.390916f, -0.811745f, -1.70875e-08f }, {0.390916f, -0.811745f, -1.70875e-08f},},
		{{0.344689f, -0.611261f, 0.344689f }, {0.344689f, -0.611261f, 0.344689f},},
		{{0.390916f, -0.811745f, -1.70875e-08f }, {0.390916f, -0.811745f, -1.70875e-08f},},
		{{0.487464f, -0.611261f, -2.13077e-08f }, {0.487464f, -0.611261f, -2.13077e-08f},},
		{{0.344689f, -0.611261f, 0.344689f }, {0.344689f, -0.611261f, 0.344689f},},
		{{0.390916f, -0.811745f, -1.70875e-08f }, {0.390916f, -0.811745f, -1.70875e-08f},},
		{{0.276419f, -0.811745f, -0.276419f }, {0.276419f, -0.811745f, -0.276419f},},
		{{0.487464f, -0.611261f, -2.13077e-08f }, {0.487464f, -0.611261f, -2.13077e-08f},},
		{{0.276419f, -0.811745f, -0.276419f }, {0.276419f, -0.811745f, -0.276419f},},
		{{0.344689f, -0.611261f, -0.344689f }, {0.344689f, -0.611261f, -0.344689f},},
		{{0.487464f, -0.611261f, -2.13077e-08f }, {0.487464f, -0.611261f, -2.13077e-08f},},
		{{0.276419f, -0.811745f, -0.276419f }, {0.276419f, -0.811745f, -0.276419f},},
		{{-3.41749e-08f, -0.811745f, -0.390916f }, {-3.41749e-08f, -0.811745f, -0.390916f},},
		{{0.344689f, -0.611261f, -0.344689f }, {0.344689f, -0.611261f, -0.344689f},},
		{{-3.41749e-08f, -0.811745f, -0.390916f }, {-3.41749e-08f, -0.811745f, -0.390916f},},
		{{-4.26155e-08f, -0.611261f, -0.487464f }, {-4.26155e-08f, -0.611261f, -0.487464f},},
		{{0.344689f, -0.611261f, -0.344689f }, {0.344689f, -0.611261f, -0.344689f},},
		{{-3.41749e-08f, -0.811745f, -0.390916f }, {-3.41749e-08f, -0.811745f, -0.390916f},},
		{{-0.276419f, -0.811745f, -0.276419f }, {-0.276419f, -0.811745f, -0.276419f},},
		{{-4.26155e-08f, -0.611261f, -0.487464f }, {-4.26155e-08f, -0.611261f, -0.487464f},},
		{{-0.276419f, -0.811745f, -0.276419f }, {-0.276419f, -0.811745f, -0.276419f},},
		{{-0.344689f, -0.611261f, -0.344689f }, {-0.344689f, -0.611261f, -0.344689f},},
		{{-4.26155e-08f, -0.611261f, -0.487464f }, {-4.26155e-08f, -0.611261f, -0.487464f},},
		{{-0.276419f, -0.811745f, -0.276419f }, {-0.276419f, -0.811745f, -0.276419f},},
		{{-0.390916f, -0.811745f, 4.66162e-09f }, {-0.390916f, -0.811745f, 4.66162e-09f},},
		{{-0.344689f, -0.611261f, -0.344689f }, {-0.344689f, -0.611261f, -0.344689f},},
		{{-0.390916f, -0.811745f, 4.66162e-09f }, {-0.390916f, -0.811745f, 4.66162e-09f},},
		{{-0.487464f, -0.611261f, 5.81295e-09f }, {-0.487464f, -0.611261f, 5.81295e-09f},},
		{{-0.344689f, -0.611261f, -0.344689f }, {-0.344689f, -0.611261f, -0.344689f},},
		{{-0.390916f, -0.811745f, 4.66162e-09f }, {-0.390916f, -0.811745f, 4.66162e-09f},},
		{{-0.276419f, -0.811745f, 0.276419f }, {-0.276419f, -0.811745f, 0.276419f},},
		{{-0.487464f, -0.611261f, 5.81295e-09f }, {-0.487464f, -0.611261f, 5.81295e-09f},},
		{{-0.276419f, -0.811745f, 0.276419f }, {-0.276419f, -0.811745f, 0.276419f},},
		{{-0.344689f, -0.611261f, 0.344689f }, {-0.344689f, -0.611261f, 0.344689f},},
		{{-0.487464f, -0.611261f, 5.81295e-09f }, {-0.487464f, -0.611261f, 5.81295e-09f},},
		{{-0.276419f, -0.811745f, 0.276419f }, {-0.276419f, -0.811745f, 0.276419f},},
		{{0.00000f, -0.811745f, 0.390916f }, {0.00000f, -0.811745f, 0.390916f},},
		{{-0.344689f, -0.611261f, 0.344689f }, {-0.344689f, -0.611261f, 0.344689f},},
		{{0.00000f, -0.811745f, 0.390916f }, {0.00000f, -0.811745f, 0.390916f},},
		{{0.00000f, -0.611261f, 0.487464f }, {0.00000f, -0.611261f, 0.487464f},},
		{{-0.344689f, -0.611261f, 0.344689f }, {-0.344689f, -0.611261f, 0.344689f},},
		{{0.00000f, -0.611261f, 0.487464f }, {0.00000f, -0.611261f, 0.487464f},},
		{{0.344689f, -0.611261f, 0.344689f }, {0.344689f, -0.611261f, 0.344689f},},
		{{0.00000f, 0.611260f, 0.487464f }, {0.00000f, 0.611260f, 0.487464f},},
		{{0.344689f, -0.611261f, 0.344689f }, {0.344689f, -0.611261f, 0.344689f},},
		{{0.344689f, 0.611260f, 0.344689f }, {0.344689f, 0.611260f, 0.344689f},},
		{{0.00000f, 0.611260f, 0.487464f }, {0.00000f, 0.611260f, 0.487464f},},
		{{0.344689f, -0.611261f, 0.344689f }, {0.344689f, -0.611261f, 0.344689f},},
		{{0.487464f, -0.611261f, -2.13077e-08f }, {0.487464f, -0.611261f, -2.13077e-08f},},
		{{0.344689f, 0.611260f, 0.344689f }, {0.344689f, 0.611260f, 0.344689f},},
		{{0.487464f, -0.611261f, -2.13077e-08f }, {0.487464f, -0.611261f, -2.13077e-08f},},
		{{0.487464f, 0.611260f, -2.13077e-08f }, {0.487464f, 0.611260f, -2.13077e-08f},},
		{{0.344689f, 0.611260f, 0.344689f }, {0.344689f, 0.611260f, 0.344689f},},
		{{0.487464f, -0.611261f, -2.13077e-08f }, {0.487464f, -0.611261f, -2.13077e-08f},},
		{{0.344689f, -0.611261f, -0.344689f }, {0.344689f, -0.611261f, -0.344689f},},
		{{0.487464f, 0.611260f, -2.13077e-08f }, {0.487464f, 0.611260f, -2.13077e-08f},},
		{{0.344689f, -0.611261f, -0.344689f }, {0.344689f, -0.611261f, -0.344689f},},
		{{0.344689f, 0.611260f, -0.344689f }, {0.344689f, 0.611260f, -0.344689f},},
		{{0.487464f, 0.611260f, -2.13077e-08f }, {0.487464f, 0.611260f, -2.13077e-08f},},
		{{0.344689f, -0.611261f, -0.344689f }, {0.344689f, -0.611261f, -0.344689f},},
		{{-4.26155e-08f, -0.611261f, -0.487464f }, {-4.26155e-08f, -0.611261f, -0.487464f},},
		{{0.344689f, 0.611260f, -0.344689f }, {0.344689f, 0.611260f, -0.344689f},},
		{{-4.26155e-08f, -0.611261f, -0.487464f }, {-4.26155e-08f, -0.611261f, -0.487464f},},
		{{-4.26155e-08f, 0.611260f, -0.487464f }, {-4.26155e-08f, 0.611260f, -0.487464f},},
		{{0.344689f, 0.611260f, -0.344689f }, {0.344689f, 0.611260f, -0.344689f},},
		{{-4.26155e-08f, -0.611261f, -0.487464f }, {-4.26155e-08f, -0.611261f, -0.487464f},},
		{{-0.344689f, -0.611261f, -0.344689f }, {-0.344689f, -0.611261f, -0.344689f},},
		{{-4.26155e-08f, 0.611260f, -0.487464f }, {-4.26155e-08f, 0.611260f, -0.487464f},},
		{{-0.344689f, -0.611261f, -0.344689f }, {-0.344689f, -0.611261f, -0.344689f},},
		{{-0.344689f, 0.611260f, -0.344689f }, {-0.344689f, 0.611260f, -0.344689f},},
		{{-4.26155e-08f, 0.611260f, -0.487464f }, {-4.26155e-08f, 0.611260f, -0.487464f},},
		{{-0.344689f, -0.611261f, -0.344689f }, {-0.344689f, -0.611261f, -0.344689f},},
		{{-0.487464f, -0.611261f, 5.81295e-09f }, {-0.487464f, -0.611261f, 5.81295e-09f},},
		{{-0.344689f, 0.611260f, -0.344689f }, {-0.344689f, 0.611260f, -0.344689f},},
		{{-0.487464f, -0.611261f, 5.81295e-09f }, {-0.487464f, -0.611261f, 5.81295e-09f},},
		{{-0.487464f, 0.611260f, 5.81295e-09f }, {-0.487464f, 0.611260f, 5.81295e-09f},},
		{{-0.344689f, 0.611260f, -0.344689f }, {-0.344689f, 0.611260f, -0.344689f},},
		{{-0.487464f, -0.611261f, 5.81295e-09f }, {-0.487464f, -0.611261f, 5.81295e-09f},},
		{{-0.344689f, -0.611261f, 0.344689f }, {-0.344689f, -0.611261f, 0.344689f},},
		{{-0.487464f, 0.611260f, 5.81295e-09f }, {-0.487464f, 0.611260f, 5.81295e-09f},},
		{{-0.344689f, -0.611261f, 0.344689f }, {-0.344689f, -0.611261f, 0.344689f},},
		{{-0.344689f, 0.611260f, 0.344689f }, {-0.344689f, 0.611260f, 0.344689f},},
		{{-0.487464f, 0.611260f, 5.81295e-09f }, {-0.487464f, 0.611260f, 5.81295e-09f},},
		{{-0.344689f, -0.611261f, 0.344689f }, {-0.344689f, -0.611261f, 0.344689f},},
		{{0.00000f, -0.611261f, 0.487464f }, {0.00000f, -0.611261f, 0.487464f},},
		{{-0.344689f, 0.611260f, 0.344689f }, {-0.344689f, 0.611260f, 0.344689f},},
		{{0.00000f, -0.611261f, 0.487464f }, {0.00000f, -0.611261f, 0.487464f},},
		{{0.00000f, 0.611260f, 0.487464f }, {0.00000f, 0.611260f, 0.487464f},},
		{{-0.344689f, 0.611260f, 0.344689f }, {-0.344689f, 0.611260f, 0.344689f},},
		{{0.00000f, 0.611260f, 0.487464f }, {0.00000f, 0.611260f, 0.487464f},},
		{{0.344689f, 0.611260f, 0.344689f }, {0.344689f, 0.611260f, 0.344689f},},
		{{0.00000f, 0.811745f, 0.390916f }, {0.00000f, 0.811745f, 0.390916f},},
		{{0.344689f, 0.611260f, 0.344689f }, {0.344689f, 0.611260f, 0.344689f},},
		{{0.276419f, 0.811745f, 0.276419f }, {0.276419f, 0.811745f, 0.276419f},},
		{{0.00000f, 0.811745f, 0.390916f }, {0.00000f, 0.811745f, 0.390916f},},
		{{0.344689f, 0.611260f, 0.344689f }, {0.344689f, 0.611260f, 0.344689f},},
		{{0.487464f, 0.611260f, -2.13077e-08f }, {0.487464f, 0.611260f, -2.13077e-08f},},
		{{0.276419f, 0.811745f, 0.276419f }, {0.276419f, 0.811745f, 0.276419f},},
		{{0.487464f, 0.611260f, -2.13077e-08f }, {0.487464f, 0.611260f, -2.13077e-08f},},
		{{0.390916f, 0.811745f, -1.70875e-08f }, {0.390916f, 0.811745f, -1.70875e-08f},},
		{{0.276419f, 0.811745f, 0.276419f }, {0.276419f, 0.811745f, 0.276419f},},
		{{0.487464f, 0.611260f, -2.13077e-08f }, {0.487464f, 0.611260f, -2.13077e-08f},},
		{{0.344689f, 0.611260f, -0.344689f }, {0.344689f, 0.611260f, -0.344689f},},
		{{0.390916f, 0.811745f, -1.70875e-08f }, {0.390916f, 0.811745f, -1.70875e-08f},},
		{{0.344689f, 0.611260f, -0.344689f }, {0.344689f, 0.611260f, -0.344689f},},
		{{0.276419f, 0.811745f, -0.276419f }, {0.276419f, 0.811745f, -0.276419f},},
		{{0.390916f, 0.811745f, -1.70875e-08f }, {0.390916f, 0.811745f, -1.70875e-08f},},
		{{0.344689f, 0.611260f, -0.344689f }, {0.344689f, 0.611260f, -0.344689f},},
		{{-4.26155e-08f, 0.611260f, -0.487464f }, {-4.26155e-08f, 0.611260f, -0.487464f},},
		{{0.276419f, 0.811745f, -0.276419f }, {0.276419f, 0.811745f, -0.276419f},},
		{{-4.26155e-08f, 0.611260f, -0.487464f }, {-4.26155e-08f, 0.611260f, -0.487464f},},
		{{-3.41749e-08f, 0.811745f, -0.390916f }, {-3.41749e-08f, 0.811745f, -0.390916f},},
		{{0.276419f, 0.811745f, -0.276419f }, {0.276419f, 0.811745f, -0.276419f},},
		{{-4.26155e-08f, 0.611260f, -0.487464f }, {-4.26155e-08f, 0.611260f, -0.487464f},},
		{{-0.344689f, 0.611260f, -0.344689f }, {-0.344689f, 0.611260f, -0.344689f},},
		{{-3.41749e-08f, 0.811745f, -0.390916f }, {-3.41749e-08f, 0.811745f, -0.390916f},},
		{{-0.344689f, 0.611260f, -0.344689f }, {-0.344689f, 0.611260f, -0.344689f},},
		{{-0.276419f, 0.811745f, -0.276419f }, {-0.276419f, 0.811745f, -0.276419f},},
		{{-3.41749e-08f, 0.811745f, -0.390916f }, {-3.41749e-08f, 0.811745f, -0.390916f},},
		{{-0.344689f, 0.611260f, -0.344689f }, {-0.344689f, 0.611260f, -0.344689f},},
		{{-0.487464f, 0.611260f, 5.81295e-09f }, {-0.487464f, 0.611260f, 5.81295e-09f},},
		{{-0.276419f, 0.811745f, -0.276419f }, {-0.276419f, 0.811745f, -0.276419f},},
		{{-0.487464f, 0.611260f, 5.81295e-09f }, {-0.487464f, 0.611260f, 5.81295e-09f},},
		{{-0.390916f, 0.811745f, 4.66162e-09f }, {-0.390916f, 0.811745f, 4.66162e-09f},},
		{{-0.276419f, 0.811745f, -0.276419f }, {-0.276419f, 0.811745f, -0.276419f},},
		{{-0.487464f, 0.611260f, 5.81295e-09f }, {-0.487464f, 0.611260f, 5.81295e-09f},},
		{{-0.344689f, 0.611260f, 0.344689f }, {-0.344689f, 0.611260f, 0.344689f},},
		{{-0.390916f, 0.811745f, 4.66162e-09f }, {-0.390916f, 0.811745f, 4.66162e-09f},},
		{{-0.344689f, 0.611260f, 0.344689f }, {-0.344689f, 0.611260f, 0.344689f},},
		{{-0.276419f, 0.811745f, 0.276419f }, {-0.276419f, 0.811745f, 0.276419f},},
		{{-0.390916f, 0.811745f, 4.66162e-09f }, {-0.390916f, 0.811745f, 4.66162e-09f},},
		{{-0.344689f, 0.611260f, 0.344689f }, {-0.344689f, 0.611260f, 0.344689f},},
		{{0.00000f, 0.611260f, 0.487464f }, {0.00000f, 0.611260f, 0.487464f},},
		{{-0.276419f, 0.811745f, 0.276419f }, {-0.276419f, 0.811745f, 0.276419f},},
		{{0.00000f, 0.611260f, 0.487464f }, {0.00000f, 0.611260f, 0.487464f},},
		{{0.00000f, 0.811745f, 0.390916f }, {0.00000f, 0.811745f, 0.390916f},},
		{{-0.276419f, 0.811745f, 0.276419f }, {-0.276419f, 0.811745f, 0.276419f},},
		{{0.00000f, 0.811745f, 0.390916f }, {0.00000f, 0.811745f, 0.390916f},},
		{{0.276419f, 0.811745f, 0.276419f }, {0.276419f, 0.811745f, 0.276419f},},
		{{0.00000f, 0.950484f, 0.216942f }, {0.00000f, 0.950484f, 0.216942f},},
		{{0.276419f, 0.811745f, 0.276419f }, {0.276419f, 0.811745f, 0.276419f},},
		{{0.153401f, 0.950484f, 0.153401f }, {0.153401f, 0.950484f, 0.153401f},},
		{{0.00000f, 0.950484f, 0.216942f }, {0.00000f, 0.950484f, 0.216942f},},
		{{0.276419f, 0.811745f, 0.276419f }, {0.276419f, 0.811745f, 0.276419f},},
		{{0.390916f, 0.811745f, -1.70875e-08f }, {0.390916f, 0.811745f, -1.70875e-08f},},
		{{0.153401f, 0.950484f, 0.153401f }, {0.153401f, 0.950484f, 0.153401f},},
		{{0.390916f, 0.811745f, -1.70875e-08f }, {0.390916f, 0.811745f, -1.70875e-08f},},
		{{0.216942f, 0.950484f, -9.48283e-09f }, {0.216942f, 0.950484f, -9.48283e-09f},},
		{{0.153401f, 0.950484f, 0.153401f }, {0.153401f, 0.950484f, 0.153401f},},
		{{0.390916f, 0.811745f, -1.70875e-08f }, {0.390916f, 0.811745f, -1.70875e-08f},},
		{{0.276419f, 0.811745f, -0.276419f }, {0.276419f, 0.811745f, -0.276419f},},
		{{0.216942f, 0.950484f, -9.48283e-09f }, {0.216942f, 0.950484f, -9.48283e-09f},},
		{{0.276419f, 0.811745f, -0.276419f }, {0.276419f, 0.811745f, -0.276419f},},
		{{0.153401f, 0.950484f, -0.153401f }, {0.153401f, 0.950484f, -0.153401f},},
		{{0.216942f, 0.950484f, -9.48283e-09f }, {0.216942f, 0.950484f, -9.48283e-09f},},
		{{0.276419f, 0.811745f, -0.276419f }, {0.276419f, 0.811745f, -0.276419f},},
		{{-3.41749e-08f, 0.811745f, -0.390916f }, {-3.41749e-08f, 0.811745f, -0.390916f},},
		{{0.153401f, 0.950484f, -0.153401f }, {0.153401f, 0.950484f, -0.153401f},},
		{{-3.41749e-08f, 0.811745f, -0.390916f }, {-3.41749e-08f, 0.811745f, -0.390916f},},
		{{-1.89657e-08f, 0.950484f, -0.216942f }, {-1.89657e-08f, 0.950484f, -0.216942f},},
		{{0.153401f, 0.950484f, -0.153401f }, {0.153401f, 0.950484f, -0.153401f},},
		{{-3.41749e-08f, 0.811745f, -0.390916f }, {-3.41749e-08f, 0.811745f, -0.390916f},},
		{{-0.276419f, 0.811745f, -0.276419f }, {-0.276419f, 0.811745f, -0.276419f},},
		{{-1.89657e-08f, 0.950484f, -0.216942f }, {-1.89657e-08f, 0.950484f, -0.216942f},},
		{{-0.276419f, 0.811745f, -0.276419f }, {-0.276419f, 0.811745f, -0.276419f},},
		{{-0.153401f, 0.950484f, -0.153401f }, {-0.153401f, 0.950484f, -0.153401f},},
		{{-1.89657e-08f, 0.950484f, -0.216942f }, {-1.89657e-08f, 0.950484f, -0.216942f},},
		{{-0.276419f, 0.811745f, -0.276419f }, {-0.276419f, 0.811745f, -0.276419f},},
		{{-0.390916f, 0.811745f, 4.66162e-09f }, {-0.390916f, 0.811745f, 4.66162e-09f},},
		{{-0.153401f, 0.950484f, -0.153401f }, {-0.153401f, 0.950484f, -0.153401f},},
		{{-0.390916f, 0.811745f, 4.66162e-09f }, {-0.390916f, 0.811745f, 4.66162e-09f},},
		{{-0.216942f, 0.950484f, 2.58701e-09f }, {-0.216942f, 0.950484f, 2.58701e-09f},},
		{{-0.153401f, 0.950484f, -0.153401f }, {-0.153401f, 0.950484f, -0.153401f},},
		{{-0.390916f, 0.811745f, 4.66162e-09f }, {-0.390916f, 0.811745f, 4.66162e-09f},},
		{{-0.276419f, 0.811745f, 0.276419f }, {-0.276419f, 0.811745f, 0.276419f},},
		{{-0.216942f, 0.950484f, 2.58701e-09f }, {-0.216942f, 0.950484f, 2.58701e-09f},},
		{{-0.276419f, 0.811745f, 0.276419f }, {-0.276419f, 0.811745f, 0.276419f},},
		{{-0.153401f, 0.950484f, 0.153401f }, {-0.153401f, 0.950484f, 0.153401f},},
		{{-0.216942f, 0.950484f, 2.58701e-09f }, {-0.216942f, 0.950484f, 2.58701e-09f},},
		{{-0.276419f, 0.811745f, 0.276419f }, {-0.276419f, 0.811745f, 0.276419f},},
		{{0.00000f, 0.811745f, 0.390916f }, {0.00000f, 0.811745f, 0.390916f},},
		{{-0.153401f, 0.950484f, 0.153401f }, {-0.153401f, 0.950484f, 0.153401f},},
		{{0.00000f, 0.811745f, 0.390916f }, {0.00000f, 0.811745f, 0.390916f},},
		{{0.00000f, 0.950484f, 0.216942f }, {0.00000f, 0.950484f, 0.216942f},},
		{{-0.153401f, 0.950484f, 0.153401f }, {-0.153401f, 0.950484f, 0.153401f},},
		/////////////////////////
		{{0.00000f, 1.00000f, 0.00000f }, {0.00000f, 1.00000f, 0.00000f},},
		{{-0.216942f, 0.950484f, 2.58701e-09f }, {-0.216942f, 0.950484f, 2.58701e-09f},},
		{{-0.153401f, 0.950484f, 0.153401f }, {-0.153401f, 0.950484f, 0.153401f},},
		{{0.00000f, 1.00000f, 0.00000f }, {0.00000f, 1.00000f, 0.00000f},},
		{{-0.153401f, 0.950484f, -0.153401f }, {-0.153401f, 0.950484f, -0.153401f},},
		{{-0.216942f, 0.950484f, 2.58701e-09f }, {-0.216942f, 0.950484f, 2.58701e-09f},},
		{{0.00000f, 1.00000f, 0.00000f }, {0.00000f, 1.00000f, 0.00000f},},
		{{-1.89657e-08f, 0.950484f, -0.216942f }, {-1.89657e-08f, 0.950484f, -0.216942f},},
		{{-0.153401f, 0.950484f, -0.153401f }, {-0.153401f, 0.950484f, -0.153401f},},
		{{0.00000f, 1.00000f, 0.00000f }, {0.00000f, 1.00000f, 0.00000f},},
		{{0.153401f, 0.950484f, -0.153401f }, {0.153401f, 0.950484f, -0.153401f},},
		{{-1.89657e-08f, 0.950484f, -0.216942f }, {-1.89657e-08f, 0.950484f, -0.216942f},},
		{{0.00000f, 1.00000f, 0.00000f }, {0.00000f, 1.00000f, 0.00000f},},
		{{0.216942f, 0.950484f, -9.48283e-09f }, {0.216942f, 0.950484f, -9.48283e-09f},},
		{{0.153401f, 0.950484f, -0.153401f }, {0.153401f, 0.950484f, -0.153401f},},
		{{0.00000f, 1.00000f, 0.00000f }, {0.00000f, 1.00000f, 0.00000f},},
		{{0.153401f, 0.950484f, 0.153401f }, {0.153401f, 0.950484f, 0.153401f},},
		{{0.216942f, 0.950484f, -9.48283e-09f }, {0.216942f, 0.950484f, -9.48283e-09f},},
		{{0.00000f, 1.00000f, 0.00000f }, {0.00000f, 1.00000f, 0.00000f},},
		{{0.00000f, 0.950484f, 0.216942f }, {0.00000f, 0.950484f, 0.216942f},},
		{{0.153401f, 0.950484f, 0.153401f }, {0.153401f, 0.950484f, 0.153401f},},
		{{0.00000f, 1.00000f, 0.00000f }, {0.00000f, 1.00000f, 0.00000f},},
		{{-0.153401f, 0.950484f, 0.153401f }, {-0.153401f, 0.950484f, 0.153401f},},
		{{0.00000f, 0.950484f, 0.216942f }, {0.00000f, 0.950484f, 0.216942f},},
		/////////////////////////
	};
	vertex = new graphics::VertexBuffer<graphics::VertexPositionNormal>(graphics::TRIANGLES, v, NELEMS(v));
}
/*!
\brief C[t[JvZ̃RXgN^
*/
primitive::WireCapsule::WireCapsule() : vertex(0) 
{
#if 0
#ifdef _DEBUG
	Vector3 pos[500];
	u32 n(0);
	f32 r(0.5f);
	f32 hh(0.5f); //< half height
	pos[n++] = -Vector3::UnitY() * r - Vector3::UnitY() * hh;
	for(u32 i=1;i<_VSTEPS / 2;++i){
		f32 l((static_cast<f32>(i) * INDI_PI / static_cast<f32>(_VSTEPS - 1)) - INDI_PI * 0.5f);
		f32 y(math::Sin(l) * r - hh);
		f32 xz(math::Cos(l) * r);
		for(u32 j=0;j<_HSTEPS;++j){
			f32 ll(static_cast<f32>(j) * INDI_PI * 2.0f / static_cast<f32>(_HSTEPS));
			f32 x(math::Sin(ll) * xz);
			f32 z(math::Cos(ll) * xz);
			pos[n++] = Vector3(x, y, z);
		}
	}
	for(u32 i=_VSTEPS / 2;i<_VSTEPS - 1;++i){
		f32 l((static_cast<f32>(i) * INDI_PI / static_cast<f32>(_VSTEPS - 1)) - INDI_PI * 0.5f);
		f32 y(math::Sin(l) * r + hh);
		f32 xz(math::Cos(l) * r);
		for(u32 j=0;j<_HSTEPS;++j){
			f32 ll(static_cast<f32>(j) * INDI_PI * 2.0f / static_cast<f32>(_HSTEPS));
			f32 x(math::Sin(ll) * xz);
			f32 z(math::Cos(ll) * xz);
			pos[n++] = Vector3(x, y, z);
		}
	}
	pos[n++] = Vector3::UnitY() * r + Vector3::UnitY() * hh;

	for(u32 i=0;i<_HSTEPS;++i){
		u32 idx(0);
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f},}," << endl;
		idx = i + 1;
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f},}," << endl;
	}
	cout << "\t\t/////////////////////////" << endl;

	for(u32 i=0;i<_VSTEPS - 2;++i){
		for(u32 j=0;j<_HSTEPS;++j){
			u32 nj((j + 1) % _HSTEPS);

			u32 idx(1 + i * _HSTEPS + j);
			cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f},}," << endl;
			idx = 1 + i * _HSTEPS + nj;
			cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f},}," << endl;

			if(i > 0){
				idx = 1 + (i - 1) * _HSTEPS + j;
				cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f},}," << endl;
				idx = 1 + i * _HSTEPS + j;
				cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f},}," << endl;
			}
		}
	}
	cout << "\t\t/////////////////////////" << endl;

	for(u32 i=0;i<_HSTEPS;++i){
		u32 idx(n - 1);
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f},}," << endl;
		idx = n - 2 - i;
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f},}," << endl;
	}
	cout << "\t\t/////////////////////////" << endl;
#endif
#endif
	graphics::VertexPosition v[] = {
		{{0.00000f, -1.00000f, 0.00000f},},
		{{0.00000f, -0.950484f, 0.216942f},},
		{{0.00000f, -1.00000f, 0.00000f},},
		{{0.153401f, -0.950484f, 0.153401f},},
		{{0.00000f, -1.00000f, 0.00000f},},
		{{0.216942f, -0.950484f, -9.48283e-09f},},
		{{0.00000f, -1.00000f, 0.00000f},},
		{{0.153401f, -0.950484f, -0.153401f},},
		{{0.00000f, -1.00000f, 0.00000f},},
		{{-1.89657e-08f, -0.950484f, -0.216942f},},
		{{0.00000f, -1.00000f, 0.00000f},},
		{{-0.153401f, -0.950484f, -0.153401f},},
		{{0.00000f, -1.00000f, 0.00000f},},
		{{-0.216942f, -0.950484f, 2.58700e-09f},},
		{{0.00000f, -1.00000f, 0.00000f},},
		{{-0.153401f, -0.950484f, 0.153401f},},
		/////////////////////////
		{{0.00000f, -0.950484f, 0.216942f},},
		{{0.153401f, -0.950484f, 0.153401f},},
		{{0.153401f, -0.950484f, 0.153401f},},
		{{0.216942f, -0.950484f, -9.48283e-09f},},
		{{0.216942f, -0.950484f, -9.48283e-09f},},
		{{0.153401f, -0.950484f, -0.153401f},},
		{{0.153401f, -0.950484f, -0.153401f},},
		{{-1.89657e-08f, -0.950484f, -0.216942f},},
		{{-1.89657e-08f, -0.950484f, -0.216942f},},
		{{-0.153401f, -0.950484f, -0.153401f},},
		{{-0.153401f, -0.950484f, -0.153401f},},
		{{-0.216942f, -0.950484f, 2.58700e-09f},},
		{{-0.216942f, -0.950484f, 2.58700e-09f},},
		{{-0.153401f, -0.950484f, 0.153401f},},
		{{-0.153401f, -0.950484f, 0.153401f},},
		{{0.00000f, -0.950484f, 0.216942f},},
		{{0.00000f, -0.811745f, 0.390916f},},
		{{0.276419f, -0.811745f, 0.276419f},},
		{{0.00000f, -0.950484f, 0.216942f},},
		{{0.00000f, -0.811745f, 0.390916f},},
		{{0.276419f, -0.811745f, 0.276419f},},
		{{0.390916f, -0.811745f, -1.70875e-08f},},
		{{0.153401f, -0.950484f, 0.153401f},},
		{{0.276419f, -0.811745f, 0.276419f},},
		{{0.390916f, -0.811745f, -1.70875e-08f},},
		{{0.276419f, -0.811745f, -0.276419f},},
		{{0.216942f, -0.950484f, -9.48283e-09f},},
		{{0.390916f, -0.811745f, -1.70875e-08f},},
		{{0.276419f, -0.811745f, -0.276419f},},
		{{-3.41749e-08f, -0.811745f, -0.390916f},},
		{{0.153401f, -0.950484f, -0.153401f},},
		{{0.276419f, -0.811745f, -0.276419f},},
		{{-3.41749e-08f, -0.811745f, -0.390916f},},
		{{-0.276419f, -0.811745f, -0.276419f},},
		{{-1.89657e-08f, -0.950484f, -0.216942f},},
		{{-3.41749e-08f, -0.811745f, -0.390916f},},
		{{-0.276419f, -0.811745f, -0.276419f},},
		{{-0.390916f, -0.811745f, 4.66162e-09f},},
		{{-0.153401f, -0.950484f, -0.153401f},},
		{{-0.276419f, -0.811745f, -0.276419f},},
		{{-0.390916f, -0.811745f, 4.66162e-09f},},
		{{-0.276419f, -0.811745f, 0.276419f},},
		{{-0.216942f, -0.950484f, 2.58700e-09f},},
		{{-0.390916f, -0.811745f, 4.66162e-09f},},
		{{-0.276419f, -0.811745f, 0.276419f},},
		{{0.00000f, -0.811745f, 0.390916f},},
		{{-0.153401f, -0.950484f, 0.153401f},},
		{{-0.276419f, -0.811745f, 0.276419f},},
		{{0.00000f, -0.611261f, 0.487464f},},
		{{0.344689f, -0.611261f, 0.344689f},},
		{{0.00000f, -0.811745f, 0.390916f},},
		{{0.00000f, -0.611261f, 0.487464f},},
		{{0.344689f, -0.611261f, 0.344689f},},
		{{0.487464f, -0.611261f, -2.13077e-08f},},
		{{0.276419f, -0.811745f, 0.276419f},},
		{{0.344689f, -0.611261f, 0.344689f},},
		{{0.487464f, -0.611261f, -2.13077e-08f},},
		{{0.344689f, -0.611261f, -0.344689f},},
		{{0.390916f, -0.811745f, -1.70875e-08f},},
		{{0.487464f, -0.611261f, -2.13077e-08f},},
		{{0.344689f, -0.611261f, -0.344689f},},
		{{-4.26155e-08f, -0.611261f, -0.487464f},},
		{{0.276419f, -0.811745f, -0.276419f},},
		{{0.344689f, -0.611261f, -0.344689f},},
		{{-4.26155e-08f, -0.611261f, -0.487464f},},
		{{-0.344689f, -0.611261f, -0.344689f},},
		{{-3.41749e-08f, -0.811745f, -0.390916f},},
		{{-4.26155e-08f, -0.611261f, -0.487464f},},
		{{-0.344689f, -0.611261f, -0.344689f},},
		{{-0.487464f, -0.611261f, 5.81295e-09f},},
		{{-0.276419f, -0.811745f, -0.276419f},},
		{{-0.344689f, -0.611261f, -0.344689f},},
		{{-0.487464f, -0.611261f, 5.81295e-09f},},
		{{-0.344689f, -0.611261f, 0.344689f},},
		{{-0.390916f, -0.811745f, 4.66162e-09f},},
		{{-0.487464f, -0.611261f, 5.81295e-09f},},
		{{-0.344689f, -0.611261f, 0.344689f},},
		{{0.00000f, -0.611261f, 0.487464f},},
		{{-0.276419f, -0.811745f, 0.276419f},},
		{{-0.344689f, -0.611261f, 0.344689f},},
		{{0.00000f, 0.611260f, 0.487464f},},
		{{0.344689f, 0.611260f, 0.344689f},},
		{{0.00000f, -0.611261f, 0.487464f},},
		{{0.00000f, 0.611260f, 0.487464f},},
		{{0.344689f, 0.611260f, 0.344689f},},
		{{0.487464f, 0.611260f, -2.13077e-08f},},
		{{0.344689f, -0.611261f, 0.344689f},},
		{{0.344689f, 0.611260f, 0.344689f},},
		{{0.487464f, 0.611260f, -2.13077e-08f},},
		{{0.344689f, 0.611260f, -0.344689f},},
		{{0.487464f, -0.611261f, -2.13077e-08f},},
		{{0.487464f, 0.611260f, -2.13077e-08f},},
		{{0.344689f, 0.611260f, -0.344689f},},
		{{-4.26155e-08f, 0.611260f, -0.487464f},},
		{{0.344689f, -0.611261f, -0.344689f},},
		{{0.344689f, 0.611260f, -0.344689f},},
		{{-4.26155e-08f, 0.611260f, -0.487464f},},
		{{-0.344689f, 0.611260f, -0.344689f},},
		{{-4.26155e-08f, -0.611261f, -0.487464f},},
		{{-4.26155e-08f, 0.611260f, -0.487464f},},
		{{-0.344689f, 0.611260f, -0.344689f},},
		{{-0.487464f, 0.611260f, 5.81295e-09f},},
		{{-0.344689f, -0.611261f, -0.344689f},},
		{{-0.344689f, 0.611260f, -0.344689f},},
		{{-0.487464f, 0.611260f, 5.81295e-09f},},
		{{-0.344689f, 0.611260f, 0.344689f},},
		{{-0.487464f, -0.611261f, 5.81295e-09f},},
		{{-0.487464f, 0.611260f, 5.81295e-09f},},
		{{-0.344689f, 0.611260f, 0.344689f},},
		{{0.00000f, 0.611260f, 0.487464f},},
		{{-0.344689f, -0.611261f, 0.344689f},},
		{{-0.344689f, 0.611260f, 0.344689f},},
		{{0.00000f, 0.811745f, 0.390916f},},
		{{0.276419f, 0.811745f, 0.276419f},},
		{{0.00000f, 0.611260f, 0.487464f},},
		{{0.00000f, 0.811745f, 0.390916f},},
		{{0.276419f, 0.811745f, 0.276419f},},
		{{0.390916f, 0.811745f, -1.70875e-08f},},
		{{0.344689f, 0.611260f, 0.344689f},},
		{{0.276419f, 0.811745f, 0.276419f},},
		{{0.390916f, 0.811745f, -1.70875e-08f},},
		{{0.276419f, 0.811745f, -0.276419f},},
		{{0.487464f, 0.611260f, -2.13077e-08f},},
		{{0.390916f, 0.811745f, -1.70875e-08f},},
		{{0.276419f, 0.811745f, -0.276419f},},
		{{-3.41749e-08f, 0.811745f, -0.390916f},},
		{{0.344689f, 0.611260f, -0.344689f},},
		{{0.276419f, 0.811745f, -0.276419f},},
		{{-3.41749e-08f, 0.811745f, -0.390916f},},
		{{-0.276419f, 0.811745f, -0.276419f},},
		{{-4.26155e-08f, 0.611260f, -0.487464f},},
		{{-3.41749e-08f, 0.811745f, -0.390916f},},
		{{-0.276419f, 0.811745f, -0.276419f},},
		{{-0.390916f, 0.811745f, 4.66162e-09f},},
		{{-0.344689f, 0.611260f, -0.344689f},},
		{{-0.276419f, 0.811745f, -0.276419f},},
		{{-0.390916f, 0.811745f, 4.66162e-09f},},
		{{-0.276419f, 0.811745f, 0.276419f},},
		{{-0.487464f, 0.611260f, 5.81295e-09f},},
		{{-0.390916f, 0.811745f, 4.66162e-09f},},
		{{-0.276419f, 0.811745f, 0.276419f},},
		{{0.00000f, 0.811745f, 0.390916f},},
		{{-0.344689f, 0.611260f, 0.344689f},},
		{{-0.276419f, 0.811745f, 0.276419f},},
		{{0.00000f, 0.950484f, 0.216942f},},
		{{0.153401f, 0.950484f, 0.153401f},},
		{{0.00000f, 0.811745f, 0.390916f},},
		{{0.00000f, 0.950484f, 0.216942f},},
		{{0.153401f, 0.950484f, 0.153401f},},
		{{0.216942f, 0.950484f, -9.48283e-09f},},
		{{0.276419f, 0.811745f, 0.276419f},},
		{{0.153401f, 0.950484f, 0.153401f},},
		{{0.216942f, 0.950484f, -9.48283e-09f},},
		{{0.153401f, 0.950484f, -0.153401f},},
		{{0.390916f, 0.811745f, -1.70875e-08f},},
		{{0.216942f, 0.950484f, -9.48283e-09f},},
		{{0.153401f, 0.950484f, -0.153401f},},
		{{-1.89657e-08f, 0.950484f, -0.216942f},},
		{{0.276419f, 0.811745f, -0.276419f},},
		{{0.153401f, 0.950484f, -0.153401f},},
		{{-1.89657e-08f, 0.950484f, -0.216942f},},
		{{-0.153401f, 0.950484f, -0.153401f},},
		{{-3.41749e-08f, 0.811745f, -0.390916f},},
		{{-1.89657e-08f, 0.950484f, -0.216942f},},
		{{-0.153401f, 0.950484f, -0.153401f},},
		{{-0.216942f, 0.950484f, 2.58701e-09f},},
		{{-0.276419f, 0.811745f, -0.276419f},},
		{{-0.153401f, 0.950484f, -0.153401f},},
		{{-0.216942f, 0.950484f, 2.58701e-09f},},
		{{-0.153401f, 0.950484f, 0.153401f},},
		{{-0.390916f, 0.811745f, 4.66162e-09f},},
		{{-0.216942f, 0.950484f, 2.58701e-09f},},
		{{-0.153401f, 0.950484f, 0.153401f},},
		{{0.00000f, 0.950484f, 0.216942f},},
		{{-0.276419f, 0.811745f, 0.276419f},},
		{{-0.153401f, 0.950484f, 0.153401f},},
		/////////////////////////
		{{0.00000f, 1.00000f, 0.00000f},},
		{{-0.153401f, 0.950484f, 0.153401f},},
		{{0.00000f, 1.00000f, 0.00000f},},
		{{-0.216942f, 0.950484f, 2.58701e-09f},},
		{{0.00000f, 1.00000f, 0.00000f},},
		{{-0.153401f, 0.950484f, -0.153401f},},
		{{0.00000f, 1.00000f, 0.00000f},},
		{{-1.89657e-08f, 0.950484f, -0.216942f},},
		{{0.00000f, 1.00000f, 0.00000f},},
		{{0.153401f, 0.950484f, -0.153401f},},
		{{0.00000f, 1.00000f, 0.00000f},},
		{{0.216942f, 0.950484f, -9.48283e-09f},},
		{{0.00000f, 1.00000f, 0.00000f},},
		{{0.153401f, 0.950484f, 0.153401f},},
		{{0.00000f, 1.00000f, 0.00000f},},
		{{0.00000f, 0.950484f, 0.216942f},},
		/////////////////////////
	};
	vertex = new graphics::VertexBuffer<graphics::VertexPosition>(graphics::LINES, v, NELEMS(v));
}
#undef _VSTEPS

/*!
\brief V_̃RXgN^
*/
primitive::Cylinder::Cylinder() : vertex(0) 
{
#if 0
#ifdef _DEBUG
	Vector3 pos[500];
	Vector3 nrm[500];
	u32 n(0);
	f32 r(0.5f);
	f32 hh(0.5f); //< half height
	pos[n] = -Vector3::UnitY() * hh;
	nrm[n++] = -Vector3::UnitY();

	for(u32 i=0;i<2;++i){
		f32 y(i==0 ? -1.0f : 1.0f);
		for(u32 j=0;j<_HSTEPS;++j){
			f32 l(static_cast<f32>(j) * INDI_PI * 2.0f / static_cast<f32>(_HSTEPS));
			f32 x(math::Sin(l));
			f32 z(math::Cos(l));
			pos[n] = Vector3(x, y, z) * r;
			nrm[n++] = Vector3(x, y, z);
		}
	}

	pos[n] = Vector3::UnitY() * hh;
	nrm[n++] = Vector3::UnitY();

	//< 
	for(u32 i=0;i<_HSTEPS;++i){
		u32 idx(0);
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
		idx = ((i + 1) % _HSTEPS) + 1;
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
		idx = i + 1;
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
	}

	//< 
	for(u32 i=0;i<_HSTEPS;++i){
		u32 idx(i + 1);
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
		idx = ((i + 1) % _HSTEPS) + 1;
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
		idx = i + 1 + _HSTEPS;
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;

		idx = i + 1 + _HSTEPS;
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
		idx = ((i + 1) % _HSTEPS) + 1;
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
		idx = ((i + 1) % _HSTEPS) + 1 + _HSTEPS;
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
	}

	//< 
	for(u32 i=0;i<_HSTEPS;++i){
		u32 idx(n - 1);
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
		idx = n - 2 - ((i + 1) % _HSTEPS);
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
		idx = n - 2 - i;
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f }, {" << nrm[idx].X() << "f, " << nrm[idx].Y() << "f, " << nrm[idx].Z() << "f},}," << endl;
	}
#endif
#endif
	graphics::VertexPositionNormal v[] = {
		{{0.00000f, -0.500000f, 0.00000f }, {-0.00000f, -1.00000f, -0.00000f},},
		{{0.353553f, -0.500000f, 0.353553f }, {0.707107f, -1.00000f, 0.707107f},},
		{{0.00000f, -0.500000f, 0.500000f }, {0.00000f, -1.00000f, 1.00000f},},
		{{0.00000f, -0.500000f, 0.00000f }, {-0.00000f, -1.00000f, -0.00000f},},
		{{0.500000f, -0.500000f, -2.18557e-08f }, {1.00000f, -1.00000f, -4.37114e-08f},},
		{{0.353553f, -0.500000f, 0.353553f }, {0.707107f, -1.00000f, 0.707107f},},
		{{0.00000f, -0.500000f, 0.00000f }, {-0.00000f, -1.00000f, -0.00000f},},
		{{0.353553f, -0.500000f, -0.353553f }, {0.707107f, -1.00000f, -0.707107f},},
		{{0.500000f, -0.500000f, -2.18557e-08f }, {1.00000f, -1.00000f, -4.37114e-08f},},
		{{0.00000f, -0.500000f, 0.00000f }, {-0.00000f, -1.00000f, -0.00000f},},
		{{-4.37114e-08f, -0.500000f, -0.500000f }, {-8.74228e-08f, -1.00000f, -1.00000f},},
		{{0.353553f, -0.500000f, -0.353553f }, {0.707107f, -1.00000f, -0.707107f},},
		{{0.00000f, -0.500000f, 0.00000f }, {-0.00000f, -1.00000f, -0.00000f},},
		{{-0.353553f, -0.500000f, -0.353553f }, {-0.707107f, -1.00000f, -0.707107f},},
		{{-4.37114e-08f, -0.500000f, -0.500000f }, {-8.74228e-08f, -1.00000f, -1.00000f},},
		{{0.00000f, -0.500000f, 0.00000f }, {-0.00000f, -1.00000f, -0.00000f},},
		{{-0.500000f, -0.500000f, 5.96244e-09f }, {-1.00000f, -1.00000f, 1.19249e-08f},},
		{{-0.353553f, -0.500000f, -0.353553f }, {-0.707107f, -1.00000f, -0.707107f},},
		{{0.00000f, -0.500000f, 0.00000f }, {-0.00000f, -1.00000f, -0.00000f},},
		{{-0.353553f, -0.500000f, 0.353554f }, {-0.707107f, -1.00000f, 0.707107f},},
		{{-0.500000f, -0.500000f, 5.96244e-09f }, {-1.00000f, -1.00000f, 1.19249e-08f},},
		{{0.00000f, -0.500000f, 0.00000f }, {-0.00000f, -1.00000f, -0.00000f},},
		{{0.00000f, -0.500000f, 0.500000f }, {0.00000f, -1.00000f, 1.00000f},},
		{{-0.353553f, -0.500000f, 0.353554f }, {-0.707107f, -1.00000f, 0.707107f},},
		{{0.00000f, -0.500000f, 0.500000f }, {0.00000f, -1.00000f, 1.00000f},},
		{{0.353553f, -0.500000f, 0.353553f }, {0.707107f, -1.00000f, 0.707107f},},
		{{0.00000f, 0.500000f, 0.500000f }, {0.00000f, 1.00000f, 1.00000f},},
		{{0.00000f, 0.500000f, 0.500000f }, {0.00000f, 1.00000f, 1.00000f},},
		{{0.353553f, -0.500000f, 0.353553f }, {0.707107f, -1.00000f, 0.707107f},},
		{{0.353553f, 0.500000f, 0.353553f }, {0.707107f, 1.00000f, 0.707107f},},
		{{0.353553f, -0.500000f, 0.353553f }, {0.707107f, -1.00000f, 0.707107f},},
		{{0.500000f, -0.500000f, -2.18557e-08f }, {1.00000f, -1.00000f, -4.37114e-08f},},
		{{0.353553f, 0.500000f, 0.353553f }, {0.707107f, 1.00000f, 0.707107f},},
		{{0.353553f, 0.500000f, 0.353553f }, {0.707107f, 1.00000f, 0.707107f},},
		{{0.500000f, -0.500000f, -2.18557e-08f }, {1.00000f, -1.00000f, -4.37114e-08f},},
		{{0.500000f, 0.500000f, -2.18557e-08f }, {1.00000f, 1.00000f, -4.37114e-08f},},
		{{0.500000f, -0.500000f, -2.18557e-08f }, {1.00000f, -1.00000f, -4.37114e-08f},},
		{{0.353553f, -0.500000f, -0.353553f }, {0.707107f, -1.00000f, -0.707107f},},
		{{0.500000f, 0.500000f, -2.18557e-08f }, {1.00000f, 1.00000f, -4.37114e-08f},},
		{{0.500000f, 0.500000f, -2.18557e-08f }, {1.00000f, 1.00000f, -4.37114e-08f},},
		{{0.353553f, -0.500000f, -0.353553f }, {0.707107f, -1.00000f, -0.707107f},},
		{{0.353553f, 0.500000f, -0.353553f }, {0.707107f, 1.00000f, -0.707107f},},
		{{0.353553f, -0.500000f, -0.353553f }, {0.707107f, -1.00000f, -0.707107f},},
		{{-4.37114e-08f, -0.500000f, -0.500000f }, {-8.74228e-08f, -1.00000f, -1.00000f},},
		{{0.353553f, 0.500000f, -0.353553f }, {0.707107f, 1.00000f, -0.707107f},},
		{{0.353553f, 0.500000f, -0.353553f }, {0.707107f, 1.00000f, -0.707107f},},
		{{-4.37114e-08f, -0.500000f, -0.500000f }, {-8.74228e-08f, -1.00000f, -1.00000f},},
		{{-4.37114e-08f, 0.500000f, -0.500000f }, {-8.74228e-08f, 1.00000f, -1.00000f},},
		{{-4.37114e-08f, -0.500000f, -0.500000f }, {-8.74228e-08f, -1.00000f, -1.00000f},},
		{{-0.353553f, -0.500000f, -0.353553f }, {-0.707107f, -1.00000f, -0.707107f},},
		{{-4.37114e-08f, 0.500000f, -0.500000f }, {-8.74228e-08f, 1.00000f, -1.00000f},},
		{{-4.37114e-08f, 0.500000f, -0.500000f }, {-8.74228e-08f, 1.00000f, -1.00000f},},
		{{-0.353553f, -0.500000f, -0.353553f }, {-0.707107f, -1.00000f, -0.707107f},},
		{{-0.353553f, 0.500000f, -0.353553f }, {-0.707107f, 1.00000f, -0.707107f},},
		{{-0.353553f, -0.500000f, -0.353553f }, {-0.707107f, -1.00000f, -0.707107f},},
		{{-0.500000f, -0.500000f, 5.96244e-09f }, {-1.00000f, -1.00000f, 1.19249e-08f},},
		{{-0.353553f, 0.500000f, -0.353553f }, {-0.707107f, 1.00000f, -0.707107f},},
		{{-0.353553f, 0.500000f, -0.353553f }, {-0.707107f, 1.00000f, -0.707107f},},
		{{-0.500000f, -0.500000f, 5.96244e-09f }, {-1.00000f, -1.00000f, 1.19249e-08f},},
		{{-0.500000f, 0.500000f, 5.96244e-09f }, {-1.00000f, 1.00000f, 1.19249e-08f},},
		{{-0.500000f, -0.500000f, 5.96244e-09f }, {-1.00000f, -1.00000f, 1.19249e-08f},},
		{{-0.353553f, -0.500000f, 0.353554f }, {-0.707107f, -1.00000f, 0.707107f},},
		{{-0.500000f, 0.500000f, 5.96244e-09f }, {-1.00000f, 1.00000f, 1.19249e-08f},},
		{{-0.500000f, 0.500000f, 5.96244e-09f }, {-1.00000f, 1.00000f, 1.19249e-08f},},
		{{-0.353553f, -0.500000f, 0.353554f }, {-0.707107f, -1.00000f, 0.707107f},},
		{{-0.353553f, 0.500000f, 0.353554f }, {-0.707107f, 1.00000f, 0.707107f},},
		{{-0.353553f, -0.500000f, 0.353554f }, {-0.707107f, -1.00000f, 0.707107f},},
		{{0.00000f, -0.500000f, 0.500000f }, {0.00000f, -1.00000f, 1.00000f},},
		{{-0.353553f, 0.500000f, 0.353554f }, {-0.707107f, 1.00000f, 0.707107f},},
		{{-0.353553f, 0.500000f, 0.353554f }, {-0.707107f, 1.00000f, 0.707107f},},
		{{0.00000f, -0.500000f, 0.500000f }, {0.00000f, -1.00000f, 1.00000f},},
		{{0.00000f, 0.500000f, 0.500000f }, {0.00000f, 1.00000f, 1.00000f},},
		{{0.00000f, 0.500000f, 0.00000f }, {0.00000f, 1.00000f, 0.00000f},},
		{{-0.500000f, 0.500000f, 5.96244e-09f }, {-1.00000f, 1.00000f, 1.19249e-08f},},
		{{-0.353553f, 0.500000f, 0.353554f }, {-0.707107f, 1.00000f, 0.707107f},},
		{{0.00000f, 0.500000f, 0.00000f }, {0.00000f, 1.00000f, 0.00000f},},
		{{-0.353553f, 0.500000f, -0.353553f }, {-0.707107f, 1.00000f, -0.707107f},},
		{{-0.500000f, 0.500000f, 5.96244e-09f }, {-1.00000f, 1.00000f, 1.19249e-08f},},
		{{0.00000f, 0.500000f, 0.00000f }, {0.00000f, 1.00000f, 0.00000f},},
		{{-4.37114e-08f, 0.500000f, -0.500000f }, {-8.74228e-08f, 1.00000f, -1.00000f},},
		{{-0.353553f, 0.500000f, -0.353553f }, {-0.707107f, 1.00000f, -0.707107f},},
		{{0.00000f, 0.500000f, 0.00000f }, {0.00000f, 1.00000f, 0.00000f},},
		{{0.353553f, 0.500000f, -0.353553f }, {0.707107f, 1.00000f, -0.707107f},},
		{{-4.37114e-08f, 0.500000f, -0.500000f }, {-8.74228e-08f, 1.00000f, -1.00000f},},
		{{0.00000f, 0.500000f, 0.00000f }, {0.00000f, 1.00000f, 0.00000f},},
		{{0.500000f, 0.500000f, -2.18557e-08f }, {1.00000f, 1.00000f, -4.37114e-08f},},
		{{0.353553f, 0.500000f, -0.353553f }, {0.707107f, 1.00000f, -0.707107f},},
		{{0.00000f, 0.500000f, 0.00000f }, {0.00000f, 1.00000f, 0.00000f},},
		{{0.353553f, 0.500000f, 0.353553f }, {0.707107f, 1.00000f, 0.707107f},},
		{{0.500000f, 0.500000f, -2.18557e-08f }, {1.00000f, 1.00000f, -4.37114e-08f},},
		{{0.00000f, 0.500000f, 0.00000f }, {0.00000f, 1.00000f, 0.00000f},},
		{{0.00000f, 0.500000f, 0.500000f }, {0.00000f, 1.00000f, 1.00000f},},
		{{0.353553f, 0.500000f, 0.353553f }, {0.707107f, 1.00000f, 0.707107f},},
		{{0.00000f, 0.500000f, 0.00000f }, {0.00000f, 1.00000f, 0.00000f},},
		{{-0.353553f, 0.500000f, 0.353554f }, {-0.707107f, 1.00000f, 0.707107f},},
		{{0.00000f, 0.500000f, 0.500000f }, {0.00000f, 1.00000f, 1.00000f},},
	};
	vertex = new graphics::VertexBuffer<graphics::VertexPositionNormal>(graphics::TRIANGLES, v, NELEMS(v));
}

/*!
\brief C[t[V_̃RXgN^
*/
primitive::WireCylinder::WireCylinder() : vertex(0) 
{
#if 0
#ifdef _DEBUG
	Vector3 pos[500];
	u32 n(0);
	f32 r(0.5f);
	f32 hh(0.5f); //< half height
	pos[n++] = -Vector3::UnitY() * hh;

	for(u32 i=0;i<2;++i){
		f32 y(i==0 ? -1.0f : 1.0f);
		for(u32 j=0;j<_HSTEPS;++j){
			f32 l(static_cast<f32>(j) * INDI_PI * 2.0f / static_cast<f32>(_HSTEPS));
			f32 x(math::Sin(l));
			f32 z(math::Cos(l));
			pos[n++] = Vector3(x, y, z) * r;
		}
	}

	pos[n++] = Vector3::UnitY() * hh;

	//< 
	for(u32 i=0;i<_HSTEPS;++i){
		u32 idx(i + 1);
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f},}," << endl;
		idx = ((i + 1) % _HSTEPS) + 1;
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f},}," << endl;
	}

	//< 
	for(u32 i=0;i<_HSTEPS;++i){
		u32 idx(i + 1);
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f},}," << endl;
		idx = i + 1 + _HSTEPS;
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f},}," << endl;
	}

	//< 
	for(u32 i=0;i<_HSTEPS;++i){
		u32 idx(n - 2 - i);
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f},}," << endl;
		idx = n - 2 - ((i + 1) % _HSTEPS);
		cout << showpoint << "\t\t{{" << pos[idx].X() << "f, " << pos[idx].Y() << "f, " << pos[idx].Z() << "f},}," << endl;
	}
#endif
#endif
	graphics::VertexPosition v[] = {
		{{0.00000f, -0.500000f, 0.500000f},},
		{{0.353553f, -0.500000f, 0.353553f},},
		{{0.353553f, -0.500000f, 0.353553f},},
		{{0.500000f, -0.500000f, -2.18557e-08f},},
		{{0.500000f, -0.500000f, -2.18557e-08f},},
		{{0.353553f, -0.500000f, -0.353553f},},
		{{0.353553f, -0.500000f, -0.353553f},},
		{{-4.37114e-08f, -0.500000f, -0.500000f},},
		{{-4.37114e-08f, -0.500000f, -0.500000f},},
		{{-0.353553f, -0.500000f, -0.353553f},},
		{{-0.353553f, -0.500000f, -0.353553f},},
		{{-0.500000f, -0.500000f, 5.96244e-09f},},
		{{-0.500000f, -0.500000f, 5.96244e-09f},},
		{{-0.353553f, -0.500000f, 0.353554f},},
		{{-0.353553f, -0.500000f, 0.353554f},},
		{{0.00000f, -0.500000f, 0.500000f},},
		{{0.00000f, -0.500000f, 0.500000f},},
		{{0.00000f, 0.500000f, 0.500000f},},
		{{0.353553f, -0.500000f, 0.353553f},},
		{{0.353553f, 0.500000f, 0.353553f},},
		{{0.500000f, -0.500000f, -2.18557e-08f},},
		{{0.500000f, 0.500000f, -2.18557e-08f},},
		{{0.353553f, -0.500000f, -0.353553f},},
		{{0.353553f, 0.500000f, -0.353553f},},
		{{-4.37114e-08f, -0.500000f, -0.500000f},},
		{{-4.37114e-08f, 0.500000f, -0.500000f},},
		{{-0.353553f, -0.500000f, -0.353553f},},
		{{-0.353553f, 0.500000f, -0.353553f},},
		{{-0.500000f, -0.500000f, 5.96244e-09f},},
		{{-0.500000f, 0.500000f, 5.96244e-09f},},
		{{-0.353553f, -0.500000f, 0.353554f},},
		{{-0.353553f, 0.500000f, 0.353554f},},
		{{-0.353553f, 0.500000f, 0.353554f},},
		{{-0.500000f, 0.500000f, 5.96244e-09f},},
		{{-0.500000f, 0.500000f, 5.96244e-09f},},
		{{-0.353553f, 0.500000f, -0.353553f},},
		{{-0.353553f, 0.500000f, -0.353553f},},
		{{-4.37114e-08f, 0.500000f, -0.500000f},},
		{{-4.37114e-08f, 0.500000f, -0.500000f},},
		{{0.353553f, 0.500000f, -0.353553f},},
		{{0.353553f, 0.500000f, -0.353553f},},
		{{0.500000f, 0.500000f, -2.18557e-08f},},
		{{0.500000f, 0.500000f, -2.18557e-08f},},
		{{0.353553f, 0.500000f, 0.353553f},},
		{{0.353553f, 0.500000f, 0.353553f},},
		{{0.00000f, 0.500000f, 0.500000f},},
		{{0.00000f, 0.500000f, 0.500000f},},
		{{-0.353553f, 0.500000f, 0.353554f},},
	};
	vertex = new graphics::VertexBuffer<graphics::VertexPosition>(graphics::LINES, v, NELEMS(v));
}
#undef _HSTEPS

primitive::Box::Box() 
{
#ifndef _BOXMAX
#define _BOXMAX 0.5f
#endif
#ifndef _BOXMIN
#define _BOXMIN -0.5f
#endif
	graphics::VertexPositionNormal box_v[] = {
		{{_BOXMAX, _BOXMAX, _BOXMAX}, {1.0f, 0.0f, 0.0f} },
		{{_BOXMAX, _BOXMIN, _BOXMAX}, {1.0f, 0.0f, 0.0f} },
		{{_BOXMAX, _BOXMAX, _BOXMIN}, {1.0f, 0.0f, 0.0f} },
		{{_BOXMAX, _BOXMAX, _BOXMIN}, {1.0f, 0.0f, 0.0f} },
		{{_BOXMAX, _BOXMIN, _BOXMAX}, {1.0f, 0.0f, 0.0f} },
		{{_BOXMAX, _BOXMIN, _BOXMIN}, {1.0f, 0.0f, 0.0f} },

		{{_BOXMIN, _BOXMAX, _BOXMAX}, {-1.0f, 0.0f, 0.0f} },
		{{_BOXMIN, _BOXMAX, _BOXMIN}, {-1.0f, 0.0f, 0.0f} },
		{{_BOXMIN, _BOXMIN, _BOXMAX}, {-1.0f, 0.0f, 0.0f} },
		{{_BOXMIN, _BOXMIN, _BOXMAX}, {-1.0f, 0.0f, 0.0f} },
		{{_BOXMIN, _BOXMAX, _BOXMIN}, {-1.0f, 0.0f, 0.0f} },
		{{_BOXMIN, _BOXMIN, _BOXMIN}, {-1.0f, 0.0f, 0.0f} },

		{{_BOXMIN, _BOXMAX, _BOXMIN}, {0.0f, 1.0f, 0.0f} },
		{{_BOXMIN, _BOXMAX, _BOXMAX}, {0.0f, 1.0f, 0.0f} },
		{{_BOXMAX, _BOXMAX, _BOXMIN}, {0.0f, 1.0f, 0.0f} },
		{{_BOXMAX, _BOXMAX, _BOXMIN}, {0.0f, 1.0f, 0.0f} },
		{{_BOXMIN, _BOXMAX, _BOXMAX}, {0.0f, 1.0f, 0.0f} },
		{{_BOXMAX, _BOXMAX, _BOXMAX}, {0.0f, 1.0f, 0.0f} },

		{{_BOXMIN, _BOXMIN, _BOXMIN}, {0.0f, -1.0f, 0.0f} },
		{{_BOXMAX, _BOXMIN, _BOXMIN}, {0.0f, -1.0f, 0.0f} },
		{{_BOXMIN, _BOXMIN, _BOXMAX}, {0.0f, -1.0f, 0.0f} },
		{{_BOXMIN, _BOXMIN, _BOXMAX}, {0.0f, -1.0f, 0.0f} },
		{{_BOXMAX, _BOXMIN, _BOXMIN}, {0.0f, -1.0f, 0.0f} },
		{{_BOXMAX, _BOXMIN, _BOXMAX}, {0.0f, -1.0f, 0.0f} },

		{{_BOXMIN, _BOXMIN, _BOXMAX}, {0.0f, 0.0f, 1.0f} },
		{{_BOXMAX, _BOXMAX, _BOXMAX}, {0.0f, 0.0f, 1.0f} },
		{{_BOXMIN, _BOXMAX, _BOXMAX}, {0.0f, 0.0f, 1.0f} },
		{{_BOXMAX, _BOXMIN, _BOXMAX}, {0.0f, 0.0f, 1.0f} },
		{{_BOXMAX, _BOXMAX, _BOXMAX}, {0.0f, 0.0f, 1.0f} },
		{{_BOXMIN, _BOXMIN, _BOXMAX}, {0.0f, 0.0f, 1.0f} },

		{{_BOXMIN, _BOXMAX, _BOXMIN}, {0.0f, 0.0f, -1.0f} },
		{{_BOXMAX, _BOXMAX, _BOXMIN}, {0.0f, 0.0f, -1.0f} },
		{{_BOXMIN, _BOXMIN, _BOXMIN}, {0.0f, 0.0f, -1.0f} },
		{{_BOXMIN, _BOXMIN, _BOXMIN}, {0.0f, 0.0f, -1.0f} },
		{{_BOXMAX, _BOXMAX, _BOXMIN}, {0.0f, 0.0f, -1.0f} },
		{{_BOXMAX, _BOXMIN, _BOXMIN}, {0.0f, 0.0f, -1.0f} },
	};
#undef _BOXMAX
#undef _BOXMIN
	vertex =  new graphics::VertexBuffer<graphics::VertexPositionNormal>(graphics::TRIANGLES, box_v, NELEMS(box_v));
}

primitive::WireBox::WireBox() 
{
#ifndef _BOXMAX
#define _BOXMAX 0.5f
#endif
#ifndef _BOXMIN
#define _BOXMIN -0.5f
#endif
	graphics::VertexPosition box_v[] = {
		{{_BOXMAX, _BOXMAX, _BOXMAX}}, {{_BOXMAX, _BOXMIN, _BOXMAX}},
		{{_BOXMAX, _BOXMAX, _BOXMAX}}, {{_BOXMAX, _BOXMAX, _BOXMIN}},
		{{_BOXMAX, _BOXMIN, _BOXMAX}}, {{_BOXMAX, _BOXMIN, _BOXMIN}}, 
		{{_BOXMAX, _BOXMAX, _BOXMIN}}, {{_BOXMAX, _BOXMIN, _BOXMIN}}, 

		{{_BOXMIN, _BOXMAX, _BOXMAX}}, {{_BOXMIN, _BOXMIN, _BOXMAX}},
		{{_BOXMIN, _BOXMAX, _BOXMAX}}, {{_BOXMIN, _BOXMAX, _BOXMIN}},
		{{_BOXMIN, _BOXMIN, _BOXMAX}}, {{_BOXMIN, _BOXMIN, _BOXMIN}}, 
		{{_BOXMIN, _BOXMAX, _BOXMIN}}, {{_BOXMIN, _BOXMIN, _BOXMIN}}, 

		{{_BOXMAX, _BOXMAX, _BOXMAX}}, {{_BOXMIN, _BOXMAX, _BOXMAX}}, 
		{{_BOXMAX, _BOXMIN, _BOXMAX}}, {{_BOXMIN, _BOXMIN, _BOXMAX}}, 
		{{_BOXMAX, _BOXMAX, _BOXMIN}}, {{_BOXMIN, _BOXMAX, _BOXMIN}},
		{{_BOXMAX, _BOXMIN, _BOXMIN}}, {{_BOXMIN, _BOXMIN, _BOXMIN}},
	};
#undef _BOXMAX
#undef _BOXMIN
	vertex =  new graphics::VertexBuffer<graphics::VertexPosition>(graphics::LINES, box_v, NELEMS(box_v));
}

primitive::InnerBox::InnerBox() 
{
#ifndef _BOXMAX
#define _BOXMAX 0.5f
#endif
#ifndef _BOXMIN
#define _BOXMIN -0.5f
#endif
	graphics::VertexPosition box_v[] = {
		{{_BOXMAX, _BOXMAX, _BOXMIN}},
		{{_BOXMAX, _BOXMIN, _BOXMAX}},
		{{_BOXMAX, _BOXMAX, _BOXMAX}},
		{{_BOXMAX, _BOXMIN, _BOXMIN}},
		{{_BOXMAX, _BOXMIN, _BOXMAX}},
		{{_BOXMAX, _BOXMAX, _BOXMIN}},

		{{_BOXMIN, _BOXMIN, _BOXMAX}},
		{{_BOXMIN, _BOXMAX, _BOXMIN}},
		{{_BOXMIN, _BOXMAX, _BOXMAX}},
		{{_BOXMIN, _BOXMIN, _BOXMIN}},
		{{_BOXMIN, _BOXMAX, _BOXMIN}},
		{{_BOXMIN, _BOXMIN, _BOXMAX}},

		{{_BOXMAX, _BOXMAX, _BOXMIN}},
		{{_BOXMIN, _BOXMAX, _BOXMAX}},
		{{_BOXMIN, _BOXMAX, _BOXMIN}},
		{{_BOXMAX, _BOXMAX, _BOXMAX}},
		{{_BOXMIN, _BOXMAX, _BOXMAX}},
		{{_BOXMAX, _BOXMAX, _BOXMIN}},

		{{_BOXMIN, _BOXMIN, _BOXMAX}},
		{{_BOXMAX, _BOXMIN, _BOXMIN}},
		{{_BOXMIN, _BOXMIN, _BOXMIN}},
		{{_BOXMAX, _BOXMIN, _BOXMAX}},
		{{_BOXMAX, _BOXMIN, _BOXMIN}},
		{{_BOXMIN, _BOXMIN, _BOXMAX}},

		{{_BOXMIN, _BOXMAX, _BOXMAX}},
		{{_BOXMAX, _BOXMAX, _BOXMAX}},
		{{_BOXMIN, _BOXMIN, _BOXMAX}},
		{{_BOXMIN, _BOXMIN, _BOXMAX}},
		{{_BOXMAX, _BOXMAX, _BOXMAX}},
		{{_BOXMAX, _BOXMIN, _BOXMAX}},

		{{_BOXMIN, _BOXMIN, _BOXMIN}},
		{{_BOXMAX, _BOXMAX, _BOXMIN}},
		{{_BOXMIN, _BOXMAX, _BOXMIN}},
		{{_BOXMAX, _BOXMIN, _BOXMIN}},
		{{_BOXMAX, _BOXMAX, _BOXMIN}},
		{{_BOXMIN, _BOXMIN, _BOXMIN}},
	};
#undef _BOXMAX
#undef _BOXMIN
	vertex =  new graphics::VertexBuffer<graphics::VertexPosition>(graphics::TRIANGLES, box_v, NELEMS(box_v));
}