/*!
$Id: sprite.cpp 585 2009-12-01 09:50:47Z horino $
*/
#include "stdafx.h"

#define SPRITE_CPP

#ifdef _DEBUG
#include <iostream>
using namespace std;
#endif

#include "indi.h"
#include "graphics/graphics.h"
#include "sprite/sprite.h"
using namespace indi;

/*!
\brief VF[_֓ñׂeNX`WԂ܂
\return eNX`W
*/
Vector4 Sprite::GetTexcoord() const 
{ 
#ifdef _DEBUG
	ASSERT(GetWidth() && GetHeight());
#endif
	Vector2 lt(_cut_lt.X() / GetWidth(), _cut_lt.Y() / GetHeight());
	Vector2 rb(Vector2(_cut_size.X() / GetWidth(), _cut_size.Y() / GetHeight()) + lt);
	return Vector4(lt.X(), rb.X(), lt.Y(), rb.Y());
}

/*!
\brief VF[_֓nׂ̍ŏIIȃ}gNXԂ܂
\return }gNX
*/
Matrix44 Sprite::GetMatrix()
{
	//< ؂o傫ʏŐȂ悤ȃXP[
	Matrix44 scl(Matrix44::Scale(_cut_size.X() / graphics::System::GetScreenWidth(), _cut_size.Y() / graphics::System::GetScreenHeight(), 1.0f));

	//< ItZbg
	Vector3 ofs(Vector3::Zero());
	if(_origin & Left) 
		ofs.SetX(1.0f);
	else if(_origin & Right) 
		ofs.SetX(-1.0f);
	if(_origin & Top) 
		ofs.SetY(-1.0f);
	else if(_origin & Bottom) 
		ofs.SetY(1.0f);

	//< [e[V
	Matrix44 rot(_rotation == 0.0f ? Matrix44::Identity() : Matrix44::RotationZ(_rotation));

	return Matrix44::Translation(ofs) * Matrix44::Scale(_scale) * rot * scl * Matrix44::Translation(_position);
}
