/*!
$Id: file_manager.h 500 2009-11-10 10:00:19Z horino $
*/
#ifndef FILE_MANAGER_H
#define FILE_MANAGER_H

#include <cell/cell_fs.h>

#include "indi.h"
#include "file/file.h"

namespace indi
{
	namespace file
	{
		class FileManager 
		{
			friend class File;
		private:
			FileManager(const char *mnt, u32 n);
			~FileManager();

			u32 Regist(File *f);
			void UnRegist(File *f);
			static void Callback(CellFsAio *aio, CellFsErrno err, s32 id, uint64_t size);

			static FileManager *_file_manager;

			char *_mount_point;
			u32 _file_num;
			File **_files;

		public:
			static FileManager *Create(const char *mnt, u32 n) { 
				if(!_file_manager)
					_file_manager = new FileManager(mnt, n);
				return _file_manager; 
			}
			static FileManager *Get() { return _file_manager; }
			static void Release() { if(_file_manager) {  delete _file_manager; _file_manager = 0; } }

			const char *GetMountPoint() { return _mount_point; }
			void Update();

#ifdef _DEBUG
			static void delay() { for(u32 i=0;i<10000000;++i) {} }
#endif
		};
	}
}

#endif // FILE_MANAGER_H