/*!
$Id: framebuffer.h 541 2009-11-20 10:40:29Z horino $
*/
#ifndef FRAMEBUFFER_H
#define FRAMEBUFFER_H

#include <vector>
#include <iostream>
using namespace std;

#include <PSGL/psgl.h>
#include <PSGL/psglu.h>

#include "indi.h"
#include "typedefs.h"
#include "itl/vector.h"

namespace indi
{
	namespace graphics
	{
		class RenderTargetBase;

		/*!
		\brief t[obt@NX
		*/
		class FrameBuffer
		{
		public:
			FrameBuffer(RenderTargetBase *rt0 = 0, RenderTargetBase *rt1 = 0, RenderTargetBase *rt2 = 0, RenderTargetBase *rt3 = 0, RenderTargetBase *rt4 = 0);
			~FrameBuffer() { glDeleteFramebuffersOES(1, &_frame_buffer); _rendertargets.clear(); }

			void Add(u32 i, RenderTargetBase *rt);
			void Clear(u8 r = 0, u8 g = 0, u8 b = 0, u8 a = 255);

			void Begin();
			void End();

			void FullScreenRender(const RenderTexture *t);

			/*!
			\brief XR[v𔲂ƂɎIEnd()R[֗NX
			*/
			class AutoBegin
			{
			public:
				AutoBegin(FrameBuffer &fb) : _fb(fb) { _fb.Begin(); }
				AutoBegin(FrameBuffer *fb) : _fb(*fb) { _fb.Begin(); }
				~AutoBegin(){ _fb.End(); }
			private:
				FrameBuffer &_fb;
			};
		private:
			u32 _frame_buffer;

			static const s32 _ntarget = 5;
			itl::Vector<RenderTargetBase *, _ntarget> _rendertargets;
		};
	};
};

#endif // FRAMEBUFFER_H