/*!
$Id: vertexbuffer_specialization.h 518 2009-11-17 10:26:00Z horino $
*/
#ifndef VERTEXBUFFER_SPECIALIZATION_H
#define VERTEXBUFFER_SPECIALIZATION_H

#include "indi.h"
#include "utilities.h"

/*!
\brief Kvȃo[ebNXobt@tH[}bgŒ`܂
\note 𑝂₵vertexbuffer_specialization.cppɂGgǉĂ
*/
namespace indi
{
	namespace graphics
	{
		struct VertexPosition
		{
			f32 position[3];

			u32 Read(const u8 *data) {
				const u8 *p(data);
				for(u32 i=0;i<NELEMS(position);++i) { position[i] = ToF32(*reinterpret_cast<const u32 *>(p)); p += sizeof(position[i]); }
				return p - data;
			}
		};

		struct VertexPositionColor
		{
			f32 position[3];
			f32 color[4];

			u32 Read(const u8 *data) {
				const u8 *p(data);
				for(u32 i=0;i<NELEMS(position);++i) { position[i] = ToF32(*reinterpret_cast<const u32 *>(p)); p += sizeof(position[i]); }
				for(u32 i=0;i<NELEMS(color);++i)    { color[i] = ToF32(*reinterpret_cast<const u32 *>(p));  p += sizeof(color[i]); }
				return p - data;
			}
		};

		struct VertexPositionTexture
		{
			f32 position[3];
			f32 texture[2];

			u32 Read(const u8 *data) {
				const u8 *p(data);
				for(u32 i=0;i<NELEMS(position);++i) { position[i] = ToF32(*reinterpret_cast<const u32 *>(p)); p += sizeof(position[i]); }
				for(u32 i=0;i<NELEMS(texture);++i)  { texture[i] = ToF32(*reinterpret_cast<const u32 *>(p)); p += sizeof(texture[i]); }
				return p - data;
			}
		};

		struct VertexPositionNormal
		{
			f32 position[3];
			f32 normal[3];

			u32 Read(const u8 *data) {
				const u8 *p(data);
				for(u32 i=0;i<NELEMS(position);++i) { position[i] = ToF32(*reinterpret_cast<const u32 *>(p)); p += sizeof(position[i]); }
				for(u32 i=0;i<NELEMS(normal);++i)   { normal[i] = ToF32(*reinterpret_cast<const u32 *>(p)); p += sizeof(normal[i]); }
				return p - data;
			}
		};

		struct VertexPositionNormalColor
		{
			f32 position[3];
			f32 normal[3];
			f32 color[4];

			u32 Read(const u8 *data) {
				const u8 *p(data);
				for(u32 i=0;i<NELEMS(position);++i) { position[i] = ToF32(*reinterpret_cast<const u32 *>(p)); p += sizeof(position[i]); }
				for(u32 i=0;i<NELEMS(normal);++i)   { normal[i] = ToF32(*reinterpret_cast<const u32 *>(p)); p += sizeof(normal[i]); }
				for(u32 i=0;i<NELEMS(color);++i)    { color[i] = ToF32(*reinterpret_cast<const u32 *>(p)); p += sizeof(color[i]); }
				return p - data;
			}
		};

		struct VertexPositionNormalTexture
		{
			f32 position[3];
			f32 normal[3];
			f32 texture[2];

			u32 Read(const u8 *data) {
				const u8 *p(data);
				for(u32 i=0;i<NELEMS(position);++i) { position[i] = ToF32(*reinterpret_cast<const u32 *>(p)); p += sizeof(position[i]); }
				for(u32 i=0;i<NELEMS(normal);++i)   { normal[i] = ToF32(*reinterpret_cast<const u32 *>(p)); p += sizeof(normal[i]); }
				for(u32 i=0;i<NELEMS(texture);++i)  { texture[i] = ToF32(*reinterpret_cast<const u32 *>(p)); p += sizeof(texture[i]); }
				return p - data;
			}
		};

		struct VertexPositionNormalColorTexture
		{
			f32 position[3];
			f32 normal[3];
			f32 color[4];
			f32 texture[2];

			u32 Read(const u8 *data) {
				const u8 *p(data);
				for(u32 i=0;i<NELEMS(position);++i) { position[i] = ToF32(*reinterpret_cast<const u32 *>(p)); p += sizeof(position[i]); }
				for(u32 i=0;i<NELEMS(normal);++i)   { normal[i] = ToF32(*reinterpret_cast<const u32 *>(p)); p += sizeof(normal[i]); }
				for(u32 i=0;i<NELEMS(color);++i)    { color[i] = ToF32(*reinterpret_cast<const u32 *>(p)); p += sizeof(color[i]); }
				for(u32 i=0;i<NELEMS(texture);++i)  { texture[i] = ToF32(*reinterpret_cast<const u32 *>(p)); p += sizeof(texture[i]); }
				return p - data;
			}
		};

		struct VertexPositionNormalIndexWeight
		{
			f32 position[3];
			f32 normal[3];
			f32 index[4];
			f32 weight[4];

			u32 Read(const u8 *data) {
				const u8 *p(data);
				for(u32 i=0;i<NELEMS(position);++i) { position[i] = ToF32(*reinterpret_cast<const u32 *>(p)); p += sizeof(position[i]); }
				for(u32 i=0;i<NELEMS(normal);++i)   { normal[i] = ToF32(*reinterpret_cast<const u32 *>(p)); p += sizeof(normal[i]); }
				for(u32 i=0;i<NELEMS(index);++i)    { index[i] = ToF32(*reinterpret_cast<const u32 *>(p)); p += sizeof(index[i]); }
				for(u32 i=0;i<NELEMS(weight);++i)   { weight[i] = ToF32(*reinterpret_cast<const u32 *>(p)); p += sizeof(weight[i]); }
				return p - data;
			}
		};

		struct VertexPositionNormalTextureIndexWeight
		{
			f32 position[3];
			f32 normal[3];
			f32 texture[2];
			f32 index[4];
			f32 weight[4];

			u32 Read(const u8 *data) {
				const u8 *p(data);
				for(u32 i=0;i<NELEMS(position);++i) { position[i] = ToF32(*reinterpret_cast<const u32 *>(p)); p += sizeof(position[i]); }
				for(u32 i=0;i<NELEMS(normal);++i)   { normal[i] = ToF32(*reinterpret_cast<const u32 *>(p)); p += sizeof(normal[i]); }
				for(u32 i=0;i<NELEMS(texture);++i)  { texture[i] = ToF32(*reinterpret_cast<const u32 *>(p)); p += sizeof(texture[i]); }
				for(u32 i=0;i<NELEMS(index);++i)    { index[i] = ToF32(*reinterpret_cast<const u32 *>(p)); p += sizeof(index[i]); }
				for(u32 i=0;i<NELEMS(weight);++i)   { weight[i] = ToF32(*reinterpret_cast<const u32 *>(p)); p += sizeof(weight[i]); }
				return p - data;
			}
		};
	};
};

#ifdef _DEBUG
static ostream ATTR_USED &operator<<(ostream &lhs, const indi::graphics::VertexPosition &rhs) { 
	cout << "POSITION : " << rhs.position[0] << ", " << rhs.position[1] << ", " << rhs.position[2] << endl;
	return lhs; 
}
static ostream ATTR_USED &operator<<(ostream &lhs, const indi::graphics::VertexPositionColor &rhs) { 
	cout << "POSITION : " << rhs.position[0] << ", " << rhs.position[1] << ", " << rhs.position[2] << endl;
	cout << "COLOR    : " << rhs.color[0] << ", " << rhs.color[1] << ", " << rhs.color[2] << ", " << rhs.color[3] << endl;
	return lhs; 
}
static ostream ATTR_USED &operator<<(ostream &lhs, const indi::graphics::VertexPositionTexture &rhs) { 
	cout << "POSITION : " << rhs.position[0] << ", " << rhs.position[1] << ", " << rhs.position[2] << endl;
	cout << "TEXTURE  : " << rhs.texture[0] << ", " << rhs.texture[1] << endl;
	return lhs; 
}
static ostream ATTR_USED &operator<<(ostream &lhs, const indi::graphics::VertexPositionNormal &rhs) { 
	cout << "POSITION : " << rhs.position[0] << ", " << rhs.position[1] << ", " << rhs.position[2] << endl;
	cout << "NORMAL   : " << rhs.normal[0] << ", " << rhs.normal[1] << ", " << rhs.normal[2] << endl;
	return lhs; 
}
static ostream ATTR_USED &operator<<(ostream &lhs, const indi::graphics::VertexPositionNormalColor &rhs) { 
	cout << "POSITION : " << rhs.position[0] << ", " << rhs.position[1] << ", " << rhs.position[2] << endl;
	cout << "NORMAL   : " << rhs.normal[0] << ", " << rhs.normal[1] << ", " << rhs.normal[2] << endl;
	cout << "COLOR    : " << rhs.color[0] << ", " << rhs.color[1] << ", " << rhs.color[2] << ", " << rhs.color[3] << endl;
	return lhs; 
}
static ostream ATTR_USED &operator<<(ostream &lhs, const indi::graphics::VertexPositionNormalTexture &rhs) { 
	cout << "POSITION : " << rhs.position[0] << ", " << rhs.position[1] << ", " << rhs.position[2] << endl;
	cout << "NORMAL   : " << rhs.normal[0] << ", " << rhs.normal[1] << ", " << rhs.normal[2] << endl;
	cout << "TEXTURE  : " << rhs.texture[0] << ", " << rhs.texture[1] << endl;
	return lhs; 
}
static ostream ATTR_USED &operator<<(ostream &lhs, const indi::graphics::VertexPositionNormalColorTexture &rhs) { 
	cout << "POSITION : " << rhs.position[0] << ", " << rhs.position[1] << ", " << rhs.position[2] << endl;
	cout << "NORMAL   : " << rhs.normal[0] << ", " << rhs.normal[1] << ", " << rhs.normal[2] << endl;
	cout << "COLOR    : " << rhs.color[0] << ", " << rhs.color[1] << ", " << rhs.color[2] << ", " << rhs.color[3] << endl;
	cout << "TEXTURE  : " << rhs.texture[0] << ", " << rhs.texture[1] << endl;
	return lhs; 
}
static ostream ATTR_USED &operator<<(ostream &lhs, const indi::graphics::VertexPositionNormalTextureIndexWeight &rhs) { 
	cout << "POSITION : " << rhs.position[0] << ", " << rhs.position[1] << ", " << rhs.position[2] << endl;
	cout << "NORMAL   : " << rhs.normal[0] << ", " << rhs.normal[1] << ", " << rhs.normal[2] << endl;
	cout << "TEXTURE  : " << rhs.texture[0] << ", " << rhs.texture[1] << endl;
	cout << "INDEX    : " << rhs.index[0] << ", " << rhs.index[1] << ", " << rhs.index[2] << ", " << rhs.index[3] << endl;
	cout << "WEIGHT   : " << rhs.weight[0] << ", " << rhs.weight[1] << ", " << rhs.weight[2] << ", " << rhs.weight[3] << endl;
	return lhs; 
}
#endif

#endif // VERTEXBUFFER_SPECIALIZATION_H