/*!
$Id: file.cpp 421 2009-10-16 09:18:39Z horino $
*/
#define FILE_CPP

#ifdef _DEBUG
#include <iostream>
using namespace std;
#endif

#include <cell/cell_fs.h>

#include "file/file_manager.h"
#include "file/file.h"
using namespace indi;

/*!
\brief RXgN^
\note ̌AOOpen(), Load()Kvł
*/
file::File::File() : _req_id(NoRequest), _index(0xffffffff)
{ 
	Memzero(&_aio, sizeof(_aio)); 
	_aio.fd = -1;
}

/*!
\brief RXgN^
\note t@C̃I[vƓǂݍ݃NGXg܂ł܂
*/
file::File::File(const char *path) : _req_id(NoRequest)
{
	Memzero(&_aio, sizeof(_aio)); 
	_aio.fd = -1;
	Open(path);
	Load();
}

/*!
\brief fXgN^
*/
file::File::~File()
{
	FileManager::Get()->UnRegist(this);
	Release();
	Close();
}

/*!
\brief t@C̃I[v
*/
void file::File::Open(const char *path)
{
	char fullpath[BUFFER_SIZE];
	Strncpy(fullpath, FileManager::Get()->GetMountPoint(), sizeof(fullpath));
	Strcat(fullpath, path);
	cellFsOpen(fullpath, CELL_FS_O_RDONLY, &_aio.fd, NULL, 0);
	cellFsStat(fullpath, &_stat);
}

/*!
\brief t@C̃N[Y
*/
void file::File::Close()
{
	if(_aio.fd != -1){
		cellFsClose(_aio.fd);
		_aio.fd = -1;
	}
}

/*!
\brief t@Cǂݍ݂̃NGXg𔭍s܂
*/
void file::File::Load()
{
	//< ̃A[P[g̓e|prŎgq[v֊mۂAǂݍ݂Iėpς񂾂Ă܂
	_aio.buf = new u8[(_aio.size = GetSize())];
	_aio.user_data = _index = FileManager::Get()->Regist(this);
	cellFsAioRead(&_aio, &_req_id, file::FileManager::Callback);
}