/*!
$Id: file_manager.cpp 531 2009-11-19 03:33:59Z horino $
*/
#define FILE_MANAGER_CPP

#ifdef _DEBUG
#include <iostream>
using namespace std;
#endif

#include "utilities.h"
#include "file/file_manager.h"
#include "file/file.h"
using namespace indi;

file::FileManager *file::FileManager::_file_manager = 0;

/*!
\brief t@C񓯊ǂݍ݊̃R[obN
*/
void file::FileManager::Callback(CellFsAio *aio, CellFsErrno err, s32 id, uint64_t size)
{
	//< ǂݍݒx̃G~[g
#ifdef _DEBUG
	delay();
#endif

	ASSERT(err == CELL_FS_SUCCEEDED); // ǂݍ݂Ɏs

	file::FileManager *man(file::FileManager::Get());
	if(man){
		ASSERT(aio->user_data < man->_file_num);

		File *file(man->_files[aio->user_data]);
		if(file)
			if(file->GetRequestID() == id) {
				//< ł̓tO𗧂Ă邾
				file->GetRequestID() = File::Callbacked;
			}
	}
}

/*!
\brief 
*/
file::FileManager::FileManager(const char *mnt, u32 n) : _mount_point(0), _file_num(n), _files(new File *[_file_num])
{
	string::AllocStrcpy(&_mount_point, mnt);
	ASSERT(cellFsAioInit(_mount_point) == CELL_FS_SUCCEEDED);
	Memzero(_files, sizeof(*_files) * _file_num);
}

/*!
\brief 
*/
file::FileManager::~FileManager()
{
	if(_files) { delete [] _files; _files = 0; }
	if(_mount_point) {
		cellFsAioFinish(_mount_point);
		delete [] _mount_point;
		_mount_point = 0;
	}
}

/*!
\brief 
*/
u32 file::FileManager::Regist(File *f) 
{	
	for(u32 i=0;i<_file_num;++i){
		if(!_files[i]){
			_files[i] = f;
			return i;
		}
	}
#ifdef _DEBUG
	ASSERT(0); //< WXgłȂ
#endif
	return 0xffffffff;
}

/*!
\brief 
*/
void file::FileManager::UnRegist(File *f)
{ 
	if(f && f->GetIndex() != 0xffffffff)
		_files[f->GetIndex()] = 0;
}

/*!
\brief ǂݍݏIĂt@C̃R[obN֐R[܂
*/
void file::FileManager::Update()
{
	//< tO̗Ă̂́AR[obNĂяoăXg
	for(u32 i=0;i<_file_num;++i){
		File *f(_files[i]);
		if(f){
			if(f->GetRequestID() == File::Callbacked){
				f->GetRequestID() = File::Loaded;
				f->OnLoaded();
				f->Close();
				file::FileManager::Get()->UnRegist(f);
			}
		}
	}
}