/*!
$Id: shader.cpp 624 2009-12-17 07:37:52Z horino $
*/
#define SHADER_CPP

#include "graphics/shader/shader.h"
#include "graphics/texture.h"
#include "vector2.h"
#include "vector3.h"
#include "vector4.h"
#include "matrix44.h"
using namespace indi;

CGcontext graphics::shader::System::_context;

graphics::shader::Program *graphics::shader::Program::_current_vs_program = 0;
graphics::shader::Program *graphics::shader::Program::_current_ps_program = 0;

void graphics::shader::Parameter::operator=(f32 rhs) 
{ 
#ifdef _DEBUG
	NAN_CHECK(rhs);
#endif
	cgGLSetParameter1f(_parameter, rhs); CG_CHECKER() 
}
void graphics::shader::Parameter::operator=(const Vector2 &rhs) 
{
#ifdef _DEBUG
	rhs.NanCheck();
#endif
	cgGLSetParameter2f(_parameter, rhs.X(), rhs.Y()); CG_CHECKER() 
}
void graphics::shader::Parameter::operator=(const Vector3 &rhs) 
{
#ifdef _DEBUG
	rhs.NanCheck();
#endif
	cgGLSetParameter3f(_parameter, rhs.X(), rhs.Y(), rhs.Z()); CG_CHECKER()
}
void graphics::shader::Parameter::operator=(const Vector4 &rhs)
{
#ifdef _DEBUG
	rhs.NanCheck();
#endif
	cgGLSetParameter4f(_parameter, rhs.X(), rhs.Y(), rhs.Z(), rhs.W()); CG_CHECKER() 
}
void graphics::shader::Parameter::operator=(const Matrix44 &rhs) 
{
#ifdef _DEBUG
	rhs.NanCheck();
#endif
	f32 m[16]; cgGLSetMatrixParameterfc(_parameter, rhs.toF32(m)); CG_CHECKER() 
}
void graphics::shader::Parameter::operator=(const graphics::TextureBase *lhs)
{
	cgGLSetTextureParameter(_parameter, lhs->GetId()); CG_CHECKER();
	cgGLEnableTextureParameter(_parameter); CG_CHECKER();
}
