/*!
$Id: texture.cpp 623 2009-12-17 04:07:13Z horino $
*/
#define TEXTURE_CPP

#include "graphics/texture.h"
#include "mesh/dds_header.h"
using namespace indi;

/*!
\brief oCif[^쐬܂
*/
u32 graphics::TextureBase::Read(const u8 *data)
{
	const u8 *p(data);

	//< ʎq擾
	char ident[4];
	Strncpy(ident, reinterpret_cast<const char *>(p), sizeof(ident)); p += sizeof(ident);
	ASSERT(!Strncmp(reinterpret_cast<const char *>(ident), "DDS ", strlen("DDS "))); //< DDStH[}bgłȂ

	//< wb_ǂݍ݂܂
	mesh::DDSHeader header;
	Memcpy(&header, p, sizeof(header)); p += sizeof(header);
	SwapEndian(reinterpret_cast<u32 *>(&header), sizeof(header) >> 2);

	//< f[^`FbN
#ifdef _DEBUG
	header.Checker();
#endif

	_width = header._width;
	_height = header._height;
	//< 1sNZ̃TCY(oCgłȂărbgȂ̂ŒӁI)
	u32 pixel_byte(header._pixel_format._bitcount >> 3);
	u32 nsur((header.IsCubemap() ? 6 : 1)); //< L[u}bvȂU
	u32 nmip(math::Max(header._mipmapcount, static_cast<u32>(1)));
	for(u32 i=0;i<nsur;++i){
		u32 w(_width);
		u32 h(_height);
		for(u32 j=0;j<nmip;++j){
			//< F̏C GL_BGRAg΂ȂčςނAptH[}XɉêłŕϊĂ
			//< BGRA -> RGBA ... RBւ
			for(u32 k=0;k<w*h;++k) {
				*const_cast<u32 *>(reinterpret_cast<const u32 *>(p) + k) = ((*const_cast<u32 *>(reinterpret_cast<const u32 *>(p) + k)) & 0x00ff00ff) |
					(((*const_cast<u32 *>(reinterpret_cast<const u32 *>(p) + k)) & 0xff000000)>>16) | (((*const_cast<u32 *>(reinterpret_cast<const u32 *>(p) + k)) & 0x0000ff00)<<16);
			}

			AddMipmap(i, j, w, h, p); p += pixel_byte * w * h;
			w >>= 1; w = math::Max(w, static_cast<u32>(1));
			h >>= 1; h = math::Max(h, static_cast<u32>(1));
		}
	}

	MipmapSettings(nmip > 1);

	return p - data;
}

/*!
\brief Aj[VeNX`̓ǂݍ
*/
u32 graphics::AnimationTexture::Read(const u8 *data)
{
	const u8 *p(data);
#ifdef _DEBUG
	char ident[4];
	Strncpy(ident, reinterpret_cast<const char *>(p), sizeof(ident)); p += sizeof(ident);
	ASSERT(!Strncmp(reinterpret_cast<const char *>(ident), "DDS ", strlen("DDS "))); //< DDStH[}bgłȂ
#else
	p += 4;
#endif

	mesh::DDSHeader header;
	Memcpy(&header, p, sizeof(header)); p += sizeof(header);
	SwapEndian(reinterpret_cast<u32 *>(&header), sizeof(header) >> 2);

	_width = header._width;
	_height = header._height;

	u32 pixel_byte(_format == SINGLE4 ? 16 : 8); //< SINGLE4 ܂ HALF4̂ݑΉ
	u32 nsur(1);
	u32 nmip(1);
	for(u32 i=0;i<nsur;++i){
		u32 w(header._width);
		u32 h(header._height);
		for(u32 j=0;j<nmip;++j){
#ifdef _DEBUG
			cout << "sur[" << i << "] mip[" << j << "]" << w << " x " << h << endl;
#endif
			AddMipmap(i, j, w, h, p);

			p += pixel_byte * w * h;
			w >>= 1; w = math::Max(w, static_cast<u32>(1));
			h >>= 1; h = math::Max(h, static_cast<u32>(1));
		}
	}

	u32 size(p - data);

	return size;
}

/*!
\brief wW̃gXtH[擾܂
*/
QuaternionTransform graphics::AnimationTexture::GetTransform(u32 x, u32 y, const u8 *data) const
{
	const u8 *top(data + 4 + sizeof(mesh::DDSHeader)); //< Awb_΂擪
	const u32 *p(reinterpret_cast<const u32 *>(top) + (x << 2) + (GetWidth() << 2) * y);
	return QuaternionTransform(Quaternion(ToF32(*(p + 0)), ToF32(*(p + 1)), ToF32(*(p + 2)), ToF32(*(p + 3))), Vector3(ToF32(*(p + 4)), ToF32(*(p + 5)), ToF32(*(p + 6))));
}