/*!
$Id: input.cpp 128 2009-07-01 09:32:40Z horino $
*/
#define INPUT_CPP

#include "input/input.h"
using namespace indi;

BOOL Input::State::Update(u32 i) 
{ 
	BOOL ret(cellPadGetData(i, &_state) == 0);
	(math::Abs(_state.button[4] - 128) < 20 && math::Abs(_state.button[5] - 128) < 20) ? _flag.Set(RS_DEADZONE) : _flag.Reset(RS_DEADZONE);
	(math::Abs(_state.button[6] - 128) < 20 && math::Abs(_state.button[7] - 128) < 20) ? _flag.Set(LS_DEADZONE) : _flag.Reset(LS_DEADZONE);
	_state.button[18] < 30 ? _flag.Set(LT_DEADZONE) : _flag.Reset(LT_DEADZONE);
	_state.button[19] < 30 ? _flag.Set(RT_DEADZONE) : _flag.Reset(RT_DEADZONE);
	return ret;
}

#ifdef _DEBUG
/*!
\brief {^̎ނ\Ԃ܂i#ifdef _DEBUĜ݁j
\param {^̎
\return {^̎ނ\
*/
char *Input::State::KindString(Kind k) 
{
	static char *tbl[] = {
#define PADASSIGN(id, input, index) #id, 
#include "input/input.h"
#undef PADASSIGN
	};
	return tbl[k];
 }
#endif


/*!
\brief {^̎ނ̂ƂinputMasklԂ܂
\param {^̎
\return inputMaskl
*/
u32 Input::State::InputMask(Kind k)
{
	static u32 tbl[] = {
#define PADASSIGN(id, input, index) input, 
#include "input/input.h"
#undef PADASSIGN
	};
	return tbl[k];
}

/*!
\brief {^̎ނ̂ƂinputIndexlԂ܂
\param {^̎
\return inputIndexl
*/
u32 Input::State::InputIndex(Kind k)
{
	static u32 tbl[] = {
#define PADASSIGN(id, input, index) index, 
#include "input/input.h"
#undef PADASSIGN
	};
	return tbl[k];
}


void Input::Update()
{
	for(u32 i = 0;i < NELEMS(_state);++i)
		cellPadSetPortSetting(i, CELL_PAD_SETTING_PRESS_ON | CELL_PAD_SETTING_SENSOR_ON);

	ASSERT(cellPadGetInfo2(&_info) == CELL_OK); //< Rg[ڑ󋵂Ď
	for(u32 i = 0;i < NELEMS(_state);++i){
		cellPadSetPortSetting(i, CELL_PAD_SETTING_PRESS_ON | CELL_PAD_SETTING_SENSOR_ON);

		indi::Memcpy(reinterpret_cast<void *>(&_state[i][1]), reinterpret_cast<void *>(&_state[i][0]), sizeof(_state[i][1]));
		if((_info.port_status[i] & CELL_PAD_STATUS_CONNECTED) > 0)
			_state[i][0].Update(i);
	}
}
