/*!
$Id: vector3.cpp 627 2009-12-18 08:21:53Z horino $
*/
#define VECTOR3_CPP

#include "vector2.h"
#include "vector3.h"
#include "vector4.h"
#include "quaternion.h"
#include "matrix44.h"
using namespace indi;

Vector3::Vector3(const Vector2 &v2, f32 z) : _e(Aos::Vector3(v2.X(), v2.Y(), z)) {}
Vector3::Vector3(const Quaternion &q) : _e(Aos::Vector3(q.X(), q.Y(), q.Z())) {}
Vector3::Vector3(const Matrix44 &m44) : _e(m44(3, 0), m44(3, 1), m44(3, 2)) {}
Vector3::Vector3(const Vector4 &v) : _e(v.X(), v.Y(), v.Z()) {}