/*!
$Id: main.cpp 623 2009-12-17 04:07:13Z horino $

XLjOAj[VTv
(skinning_modelTv𗝉Ă邱Ƃ𐄏)
*/
#include "stdafx.h"

#define MAIN_CPP

#include "indi.h"
#include "graphics/graphics.h"
#include "file/file_manager.h"
#include "input/input.h"
#include "camera/debugcamera.h"
#include "mesh/scenes.h"
#include "mesh/scenes_texture.h"
#include "mesh/animation.h"
#include "graphics/shader/shader.h"
#include "graphics/rendertarget.h"
#include "graphics/framebuffer.h"
#include "timer.h"
#include "debug_stop.h"
using namespace indi;

#ifdef PS3
//#define ROOT "/dev_bdvd/PS3_GAME/USRDIR/"
#define ROOT "/app_home/samples/"
#else
#define ROOT "game:\\"
#endif

//< L[t[Ԃgꍇɂ͒`(VF[_̒`킹Ă)
#define USE_SLERP

/*!
\brief f̕`@JX^}CY邽߁AepăI[o[Ch܂
*/

//< Controller : ǂ̃eNX`g̏Ă̂ŃI[o[ChKv܂
class MyController : public mesh::Controller
{
public:
	MyController(mesh::Node *p) : mesh::Controller(p), _texture(0), _vertex_shader(0), _pixel_shader(0), _animation(0) {}
	virtual ~MyController() {}

	//< Draw()I[o[Ch
	void Draw() const 
	{
		const mesh::Mesh *mesh(GetMesh());
		if(mesh) {
			//< gCAO̕
			u32 ntri(mesh->GetTriangleNum());
			for(u32 i=0;i<ntri;++i){
				const mesh::Triangle *tri(mesh->GetTriangle(i));
				if(tri){
					//< gCAO̕`Ɏgp}eACfbNX  }eA擾
					u32 mate_idx(tri->GetMaterialIndex());
					const mesh::Material *mate(GetMaterial(mate_idx));
					if(mate){
						//< vt@C擾(ProfileCommon̂)
						const mesh::Profile *prof(mate->GetProfile());
						if(prof){
							switch(prof->GetProfileType()){
                            case mesh::ProfileCommon:
								{
									const mesh::Common *cmn(static_cast<const mesh::Common *>(prof));
									//< VF[fBO^Cv擾A(Tv)łPhonĝݑΉ
									switch(cmn->GetShader()->GetShaderType()){
							        case mesh::PhongShader:
										{
											const mesh::Phong *png(static_cast<const mesh::Phong *>(cmn->GetShader()));
											if(png){
												//< iTvjłDiffuseɃeNX`ATCĂP[X݂̂Ώ
												if(png->GetDiffuse().IsTexture()){
													//< eNX`CfbNX擾
													u32 tex_idx(png->GetDiffuse().GetTextureIndex());
													//< VF[_փeNX`n܂
													if(_texture) {
														if(_pixel_shader && _pixel_shader->IsLoaded() && _vertex_shader && _vertex_shader->IsLoaded()){
															graphics::shader::Parameter smp(_pixel_shader->GetParameter("Sampler"));
															graphics::shader::Parameter idx(_vertex_shader->GetParameter("AnimationIndex"));
#ifdef USE_SLERP
															graphics::shader::Parameter idx_max(_vertex_shader->GetParameter("AnimationIndexMax"));
															graphics::shader::Parameter idx_ratio(_vertex_shader->GetParameter("AnimationIndexRatio"));
#endif
															{
																graphics::shader::Parameter::AutoBeginTexture auto_tex(smp, _texture->GetTexture(tex_idx));

																u32 clip(0); //< ł͂OԖڂ̃Aj[V݂̂Đ
																u32 ctrl(GetIndex()); //< Rg[g̃CfbNX𓾂
																f32 time(Timer::ToSecond(AnimationTimer::current)); //< Aj[V邽߂̌ݎ
																//< LAj[VeNX`ł̂xWCfbNX֕ϊăVF[_֓n
																_animation->SetClip(clip);
																_animation->SetController(ctrl);
																idx = static_cast<f32>(_animation->GetLoopY(time));

#ifdef USE_SLERP
																idx_max = static_cast<f32>(_animation->GetMaxY());
																idx_ratio = _animation->GetLoopRatio(time);
#endif
																tri->Draw();
															}
														}
													}
												}
											}
										}
										break;
									default: ASSERT(0); break; //< (Tv)ł͑ΉȂ
									}
								}
								break;
							default: ASSERT(0); break; //< (Tv)ł͑ΉȂ
							}
						}
					}
				}
			}
		}
	}
	//< ÕeNX`ݒ֐
	void MySetTexture(mesh::ScenesTextureFile *t) { _texture = t; }
	//< Õo[ebNXVF[_ݒ֐
	void MySetVertexShader(graphics::shader::VertexProgram *v){ _vertex_shader = v; }
	//< ÕsNZVF[_ݒ֐
	void MySetPixelShader(graphics::shader::PixelProgram *p){ _pixel_shader = p; }
	//< ÕAj[Vݒ֐
	void MySetAnimation(mesh::AnimationMapFile *a){	_animation = a; }
private:
	mesh::ScenesTextureFile *_texture;
	graphics::shader::VertexProgram *_vertex_shader;
	graphics::shader::PixelProgram *_pixel_shader;
	mesh::AnimationMapFile *_animation;
};

//< Node : m[h̃ItZbgݒA`}gNXݒAʃNXControllerJX^}CY邽߂ɃI[o[ChKv܂
class MyNode : public mesh::Node
{
public:
	MyNode(mesh::Node *p) : mesh::Node(p), _vertex_shader(0), _view_projection(0), _animation(0) {}
	virtual ~MyNode() {}

	mesh::Controller *ControllerCreator(mesh::Node *p = 0) const { return new MyController(p); } //< ̃NXg悤ɃI[o[Ch
	mesh::Node *NodeCreator(mesh::Node *p = 0) const { return new MyNode(p); } //< ̃NXg悤ɃI[o[Ch

	//< Draw()I[o[Ch
	void Draw() const
	{
		if(_vertex_shader && _vertex_shader->IsLoaded()){
			//< VF[_̐ݒ܂
			graphics::shader::Parameter w(_vertex_shader->GetParameter("World"));
			graphics::shader::Parameter vp(_vertex_shader->GetParameter("ViewProjection"));
			graphics::shader::Parameter smp(_vertex_shader->GetParameter("AnimationSampler"));
			graphics::shader::Parameter siz(_vertex_shader->GetParameter("AnimationSize"));
			if(_view_projection && _animation){
				w = GetTransform();
				vp = *_view_projection;
				siz = _animation->GetTextureSize();
				graphics::shader::Parameter::AutoBeginTexture auto_tex(smp, _animation->GetAnimationTexture());

				//< DrawR[܂
				mesh::Node::Draw();
			}
		}
	}

	//< ÕeNX`ݒ֐
	void MySetTexture(mesh::ScenesTextureFile *t) {
		for(u32 i=0;i<GetNodeNum();++i)
			static_cast<MyNode *>(GetNode(i))->MySetTexture(t);
		for(u32 i=0;i<GetControllerNum();++i)
			static_cast<MyController *>(GetController(i))->MySetTexture(t);
	}
	//< Õo[ebNXVF[_ݒ֐
	void MySetVertexShader(graphics::shader::VertexProgram *v){
		_vertex_shader = v;
		for(u32 i=0;i<GetNodeNum();++i)
			static_cast<MyNode *>(GetNode(i))->MySetVertexShader(v);
		for(u32 i=0;i<GetControllerNum();++i)
			static_cast<MyController *>(GetController(i))->MySetVertexShader(v);
	}
	//< ÕsNZVF[_ݒ֐
	void MySetPixelShader(graphics::shader::PixelProgram *p){
		for(u32 i=0;i<GetNodeNum();++i)
			static_cast<MyNode *>(GetNode(i))->MySetPixelShader(p);
		for(u32 i=0;i<GetControllerNum();++i)
			static_cast<MyController *>(GetController(i))->MySetPixelShader(p);
	}
	//< OViewProjectionݒ֐
	void MySetViewProjection(Matrix44 *vp){
		_view_projection = vp;
		for(u32 i=0;i<GetNodeNum();++i)
			static_cast<MyNode *>(GetNode(i))->MySetViewProjection(vp);
	}
	//< ÕAj[Vݒ֐
	void MySetAnimation(mesh::AnimationMapFile *a){
		_animation = a;
		for(u32 i=0;i<GetNodeNum();++i)
			static_cast<MyNode *>(GetNode(i))->MySetAnimation(a);
		for(u32 i=0;i<GetControllerNum();++i)
			static_cast<MyController *>(GetController(i))->MySetAnimation(a);
	}
private:
	graphics::shader::VertexProgram *_vertex_shader;
	Matrix44 *_view_projection;
	mesh::AnimationMapFile *_animation;
};

//< Scene : ʃNXNodeControllerJX^}CY邽߂ɃI[o[ChKv܂
class MyScene : public mesh::Scene
{
public:
	MyScene() : mesh::Scene() {}
	virtual ~MyScene() {}

	mesh::Node *NodeCreator(mesh::Node *p = 0) const { return new MyNode(p); } //< ̃NXg悤ɃI[o[Ch

	//< ÕeNX`ݒ֐
	void MySetTexture(mesh::ScenesTextureFile *t) {
		for(u32 i=0;i<GetNodeNum();++i)
			static_cast<MyNode *>(GetNode(i))->MySetTexture(t);
	}
	//< Õo[ebNXVF[_ݒ֐
	void MySetVertexShader(graphics::shader::VertexProgram *v){
		for(u32 i=0;i<GetNodeNum();++i)
			static_cast<MyNode *>(GetNode(i))->MySetVertexShader(v);
	}
	//< ÕsNZVF[_ݒ֐
	void MySetPixelShader(graphics::shader::PixelProgram *p){
		for(u32 i=0;i<GetNodeNum();++i)
			static_cast<MyNode *>(GetNode(i))->MySetPixelShader(p);
	}
	//< OViewProjectionݒ֐
	void MySetViewProjection(Matrix44 *vp){
		for(u32 i=0;i<GetNodeNum();++i)
			static_cast<MyNode *>(GetNode(i))->MySetViewProjection(vp);
	}
	//< ÕAj[Vݒ֐
	void MySetAnimation(mesh::AnimationMapFile *a){
		for(u32 i=0;i<GetNodeNum();++i)
			static_cast<MyNode *>(GetNode(i))->MySetAnimation(a);
	}
};

//< ScenesFile : ʃNXSceneNodeControllerJX^}CY邽߂ɃI[o[ChKv܂
class MyScenesFile : public mesh::ScenesFile
{
public:
	MyScenesFile(const char *path) : mesh::ScenesFile(path) {}
	virtual ~MyScenesFile() {}

	mesh::Scene *SceneCreator() const { return new MyScene(); } //< ̃NXg悤ɃI[o[Ch

	//< ÕeNX`ݒ֐
	void MySetTexture(mesh::ScenesTextureFile *t){
		for(u32 i=0;i<GetSceneNum();++i)
			static_cast<MyScene *>(GetScene(i))->MySetTexture(t);
	}
	//< Õo[ebNXVF[_ݒ֐
	void MySetVertexShader(graphics::shader::VertexProgram *v){
		for(u32 i=0;i<GetSceneNum();++i)
			static_cast<MyScene *>(GetScene(i))->MySetVertexShader(v);
	}
	//< ÕsNZVF[_ݒ֐
	void MySetPixelShader(graphics::shader::PixelProgram *p){
		for(u32 i=0;i<GetSceneNum();++i)
			static_cast<MyScene *>(GetScene(i))->MySetPixelShader(p);
	}
	//< OViewProjectionݒ֐
	void MySetViewProjection(Matrix44 *vp){
		for(u32 i=0;i<GetSceneNum();++i)
			static_cast<MyScene *>(GetScene(i))->MySetViewProjection(vp);
	}
	//< ÕAj[Vݒ֐
	void MySetAnimation(mesh::AnimationMapFile *a){
		for(u32 i=0;i<GetSceneNum();++i)
			static_cast<MyScene *>(GetScene(i))->MySetAnimation(a);
	}
};


/////////////////////////////////////////
//< main()
/////////////////////////////////////////
int main(int argc, char *argv[])
{
	//< 
	System::Initialize(ROOT"media"SEPARATOR);

	//< pbh͗p
	Input input;

	//< J
	DebugCamera camera(Vector3(0.0f, 15.0f, 100.0f), Vector3::Zero(), Vector3::Up(), Matrix44::Perspective(INDI_PI * 0.25f, graphics::System::GetAspectRatio(), 0.1f, 1000.0f));

	//< f
	mesh::ScenesTextureFile *texture(new mesh::ScenesTextureFile("dude.tex"));
	MyScenesFile *model(new MyScenesFile("dude.scn"));
	//< Aj[Vt@C
	mesh::AnimationMapFile *animation(new mesh::AnimationMapFile("dude.amp"));

//	mesh::ScenesTextureFile *texture(new mesh::ScenesTextureFile("EnemyBeast.tex"));
//	MyScenesFile *model(new MyScenesFile("EnemyBeast.scn"));
//	mesh::AnimationMapFile *animation(new mesh::AnimationMapFile("EnemyBeast.amp"));

//	mesh::ScenesTextureFile *texture(new mesh::ScenesTextureFile("PlayerMarine.tex"));
//	MyScenesFile *model(new MyScenesFile("PlayerMarine.scn"));
//	mesh::AnimationMapFile *animation(new mesh::AnimationMapFile("PlayerMarine.amp"));

	//< VF[_
	graphics::shader::VertexProgram *vs(new graphics::shader::VertexProgram("skinning_animation_vs"SH_EXT));
	graphics::shader::PixelProgram *ps(new graphics::shader::PixelProgram("skinning_animation_ps"SH_EXT));

	graphics::System::ClearColor(127, 127, 255);

#ifdef _DEBUG
	//< fobOXgbv
	DebugStop debug_stop;
#endif

	//< Q[[v
	while(1){
		//< 񓯊ǂݍ݂̏
		if(file::FileManager::Get())
			file::FileManager::Get()->Update();

		//< pbh
		input.Update();

		//< fobOJ
		if(input.Current(0).IsValid())
			camera.Control(input.Current(0));
		//< J̍XV
		camera.Update();

#ifdef _DEBUG
		//< fobOXgbv̑
		debug_stop.Control(input.Previous(0), input.Current(0));
#endif

		graphics::System::BeginBackBuffer();{

			graphics::System::Clear();

			if(vs->IsLoaded() && ps->IsLoaded()){
				//< f̕`
				if(model->IsLoaded() && texture->IsLoaded() && animation->IsLoaded()){
					//< f`ɕKvƂœnĂ
					model->MySetViewProjection(&camera.ViewProjection());
					model->MySetTexture(texture);
					model->MySetVertexShader(vs);
					model->MySetPixelShader(ps);
					model->MySetAnimation(animation);

					graphics::shader::Program::AutoBegin auto_vs(*vs);
					graphics::shader::Program::AutoBegin auto_ps(*ps);

					//< CfbNXƃEGCg̃f[^VF[_p[^֓n
					model->SetIndexWeight(vs); 

					model->Draw();
				}
			}

		} graphics::System::EndBackBuffer();
		graphics::System::SwapBuffers();

#ifdef _DEBUG
		if(!debug_stop.IsStop())
			++AnimationTimer::current;
#else
		++AnimationTimer::current;
#endif
	}

	delete ps;
	delete vs;

	delete animation;

	delete model;
	delete texture;

	System::Finalize();
}
