/*!
  $Id: main.cpp 637 2009-12-22 10:16:47Z horino $

  Aj[V̊em[h̃gXtH[擾Tv
*/
#include "stdafx.h"

#define MAIN_CPP

#include "indi.h"
#include "graphics/graphics.h"
#include "file/file_manager.h"
#include "input/input.h"
#include "camera/debugcamera.h"
#include "mesh/scenes.h"
#include "mesh/scenes_texture.h"
#include "mesh/animation.h"
#include "graphics/shader/shader.h"
#include "graphics/rendertarget.h"
#include "graphics/framebuffer.h"
#include "timer.h"
#include "debug_stop.h"
#include "primitive/primitive.h"
#include "font/font.h"
using namespace indi;

#ifdef PS3
//#define ROOT "/dev_bdvd/PS3_GAME/USRDIR/"
#define ROOT "/app_home/samples/"
#else
#define ROOT "game:\\"
#endif

//< L[t[Ԃgꍇɂ͒`(VF[_̒`킹Ă)
#define USE_SLERP

/*!
  \brief FontNXpĎOtHgNX쐬܂
  256 x 256 -> 16J x 9E -> P 16 x 28.4

  0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5
  0 ACEGIJLNPRTVXZ\ 
  1 ^`cegijklm@BDFH
  2 nqtwz}~@|
  3 JKb
  4 KMOQSUWY[]_adfh
  5 orux{psvy|E
  6 `abcdefghijklmn
  7 opqrstuvwxyOPQR
  8 STUVWX
*/
class MyFont : public Font
{
public:
	MyFont(const char *path, graphics::shader::VertexProgram *vs, graphics::shader::PixelProgram *ps) : Font(path), _vs(vs), _ps(ps) {}
	virtual ~MyFont() {}

	f32 GetLineSpace() const { return 256.0f / 9.0f; }

	/*!
	  \brief `֐܂
	  \note 쐬ꂽtHgeNX`ɂ蕶̕т܂܂Ȃ̂ŁA[UŎKv
	  ̃P[Xł̓eNX`ł̕̕тgbL[Ȃ̂ŃR[h債Ă邪AтHv΂ƊȒPɂł(http://ash.jp/code/codetbl2.htm)̕тȂ炢̂
	*/
	f32 Draw(const char *s) {
		if(!IsLoaded()) return 0.0f;
		//< ؂oʒu肵܂
		f32 w(16.0f), h(GetLineSpace());
		f32 x, y;
		if(Is8BitChar(s[0])){ //< 1bytȅꍇ
			if(Isspace(s[0])){
				x = 15.0f * w;
				y = h * 8.0f;
			} else if(Isdigit(s[0])){
				if(s[0] >= '4'){
					y = h * 8.0f;
					x = static_cast<f32>(s[0] - '4') * w;
				} else {
					y = h * 7.0f;
					x = static_cast<f32>(s[0] - '0' + 11) * w;
				}
			} else if(Isalpha(s[0])){
				if(Islower(s[0])){
					if(s[0] >= 'p') {
						y = h * 7.0f;
						x = static_cast<f32>(s[0] - 'p') * w;
					} else {
						y = h * 6.0f;
						x = static_cast<f32>(s[0] - 'a') * w;
					}
				} else {
					if(s[0] >= 'P') {
						y = h * 7.0f;
						x = static_cast<f32>(s[0] - 'P') * w;
					} else {
						y = h * 6.0f;
						x = static_cast<f32>(s[0] - 'A') * w;
					}
				}
			} else 
				return 0.0f;
		} else { //< 2bytȅꍇ
			const u16 c(*reinterpret_cast<const u16 *>(s));
			if((c > 0x829e && c < 0x839e) || c == 0x8145 || c == 0x815b){ //< Ђ炪 ` J^Ji͈̔͂"["A"E"̂ݑΉ
				switch(c){
					//< "E"
				case 0x8145:             
					x = w * 10.0f; y = h * 5.0f;      
					break;
					//< "["
				case 0x815b:       
					x = w * 14.0f; y = h * 2.0f;      
					break;

					//< s
				case 0x8341: //< A
				case 0x82a0: //< 
					x = w * 0.0f; y = h * 0.0f;
					break;
				case 0x8341 + 2: //< C
				case 0x82a0 + 2: //< 
					x = w * 1.0f; y = h * 0.0f;
					break;
				case 0x8341 + 4: //< E
				case 0x82a0 + 4: //< 
					x = w * 2.0f; y = h * 0.0f;
					break;
				case 0x8341 + 6: //< G
				case 0x82a0 + 6: //< 
					x = w * 3.0f; y = h * 0.0f;
					break;
				case 0x8341 + 8: //< I
				case 0x82a0 + 8: //< 
					x = w * 4.0f; y = h * 0.0f;
					break;

					//< s
				case 0x8341 - 1:
				case 0x82a0 - 1:
					x = w * 10.0f; y = h * 1.0f;
					break;
				case 0x8341 + 2 - 1:
				case 0x82a0 + 2 - 1:
					x = w * 11.0f; y = h * 1.0f;
					break;
				case 0x8341 + 4 - 1:
				case 0x82a0 + 4 - 1:
					x = w * 12.0f; y = h * 1.0f;
					break;
				case 0x8341 + 6 - 1:
				case 0x82a0 + 6 - 1:
					x = w * 13.0f; y = h * 1.0f;
					break;
				case 0x8341 + 8 - 1:
				case 0x82a0 + 8 - 1:
					x = w * 14.0f; y = h * 1.0f;
					break;

					//< s
				case 0x8341 + 9:
				case 0x82a0 + 9:
					x = w * 5.0f; y = h * 0.0f;
					break;
				case 0x8341 + 11: 
				case 0x82a0 + 11: 
					x = w * 6.0f; y = h * 0.0f;
					break;
				case 0x8341 + 13: 
				case 0x82a0 + 13: 
					x = w * 7.0f; y = h * 0.0f;
					break;
				case 0x8341 + 15: 
				case 0x82a0 + 15: 
					x = w * 8.0f; y = h * 0.0f;
					break;
				case 0x8341 + 17: 
				case 0x82a0 + 17: 
					x = w * 9.0f; y = h * 0.0f;
					break;

					//< s
				case 0x8341 + 9 + 1:
				case 0x82a0 + 9 + 1:
					x = w * 0.0f; y = h * 4.0f;
					break;
				case 0x8341 + 11 + 1: 
				case 0x82a0 + 11 + 1: 
					x = w * 1.0f; y = h * 4.0f;
					break;
				case 0x8341 + 13 + 1: 
				case 0x82a0 + 13 + 1: 
					x = w * 2.0f; y = h * 4.0f;
					break;
				case 0x8341 + 15 + 1: 
				case 0x82a0 + 15 + 1: 
					x = w * 3.0f; y = h * 4.0f;
					break;
				case 0x8341 + 17 + 1: 
				case 0x82a0 + 17 + 1: 
					x = w * 4.0f; y = h * 4.0f;
					break;

					//< s
				case 0x8341 + 19:
				case 0x82a0 + 19:
					x = w * 10.0f; y = 0.0f;
					break;
				case 0x8341 + 21: 
				case 0x82a0 + 21: 
					x = w * 11.0f; y = 0.0f;
					break;
				case 0x8341 + 23: 
				case 0x82a0 + 23: 
					x = w * 12.0f; y = 0.0f;
					break;
				case 0x8341 + 25: 
				case 0x82a0 + 25: 
					x = w * 13.0f; y = 0.0f;
					break;
				case 0x8341 + 27: 
				case 0x82a0 + 27: 
					x = w * 14.0f; y = 0.0f;
					break;

					//< s
				case 0x8341 + 19 + 1:
				case 0x82a0 + 19 + 1:
					x = w * 5.0f; y = h * 4.0f;
					break;
				case 0x8341 + 21 + 1: 
				case 0x82a0 + 21 + 1: 
					x = w * 6.0f; y = h * 4.0f;
					break;
				case 0x8341 + 23 + 1: 
				case 0x82a0 + 23 + 1: 
					x = w * 7.0f; y = h * 4.0f;
					break;
				case 0x8341 + 25 + 1: 
				case 0x82a0 + 25 + 1: 
					x = w * 8.0f; y = h * 4.0f;
					break;
				case 0x8341 + 27 + 1: 
				case 0x82a0 + 27 + 1: 
					x = w * 9.0f; y = h * 4.0f;
					break;

					//< s
				case 0x8341 + 29:
				case 0x82a0 + 29:
					x = 0.0f; y = h;
					break;
				case 0x8341 + 31: 
				case 0x82a0 + 31: 
					x = w; y = h;
					break;
				case 0x8341 + 34: 
				case 0x82a0 + 34: 
					x = w * 2.0f; y = h;
					break;
				case 0x8341 + 36: 
				case 0x82a0 + 36: 
					x = w * 3.0f; y = h;
					break;
				case 0x8341 + 38: 
				case 0x82a0 + 38: 
					x = w * 4.0f; y = h;
					break;

					//< s
				case 0x8341 + 29 + 1:
				case 0x82a0 + 29 + 1:
					x = w * 10.0f; y = h * 4.0f;
					break;
				case 0x8341 + 31 + 1: 
				case 0x82a0 + 31 + 1: 
					x = w * 11.0f; y = h * 4.0f;
					break;
				case 0x8341 + 34 + 1: 
				case 0x82a0 + 34 + 1: 
					x = w * 12.0f; y = h * 4.0f;
					break;
				case 0x8341 + 36 + 1: 
				case 0x82a0 + 36 + 1: 
					x = w * 13.0f; y = h * 4.0f;
					break;
				case 0x8341 + 38 + 1:
				case 0x82a0 + 38 + 1: 
					x = w * 14.0f; y = h * 4.0f;
					break;

					//< 
				case 0x8362:
				case 0x82c1: 
					x = w * 13.0f; y = h * 3.0f;
					break;

					//< ȍs
				case 0x8341 + 40:
				case 0x82a0 + 40:
					x = w * 5.0f; y = h;
					break;
				case 0x8341 + 41: 
				case 0x82a0 + 41: 
					x = w * 6.0f; y = h;
					break;
				case 0x8341 + 42: 
				case 0x82a0 + 42: 
					x = w * 7.0f; y = h;
					break;
				case 0x8341 + 43: 
				case 0x82a0 + 43: 
					x = w * 8.0f; y = h;
					break;
				case 0x8341 + 44: 
				case 0x82a0 + 44: 
					x = w * 9.0f; y = h;
					break;

					//< ͍s
				case 0x8341 + 45:
				case 0x82a0 + 45:
					x = w * 0.0f; y = h * 2.0f;
					break;
				case 0x8341 + 48: 
				case 0x82a0 + 48: 
					x = w * 1.0f; y = h * 2.0f;
					break;
				case 0x8341 + 51: 
				case 0x82a0 + 51: 
					x = w * 2.0f; y = h * 2.0f;
					break;
				case 0x8341 + 54: 
				case 0x82a0 + 54: 
					x = w * 3.0f; y = h * 2.0f;
					break;
				case 0x8341 + 57: 
				case 0x82a0 + 57: 
					x = w * 4.0f; y = h * 2.0f;
					break;

					//< ΍s
				case 0x8341 + 45 + 1:
				case 0x82a0 + 45 + 1:
					x = w * 0.0f; y = h * 5.0f;
					break;
				case 0x8341 + 48 + 1: 
				case 0x82a0 + 48 + 1: 
					x = w * 1.0f; y = h * 5.0f;
					break;
				case 0x8341 + 51 + 1: 
				case 0x82a0 + 51 + 1: 
					x = w * 2.0f; y = h * 5.0f;
					break;
				case 0x8341 + 54 + 1: 
				case 0x82a0 + 54 + 1: 
					x = w * 3.0f; y = h * 5.0f;
					break;
				case 0x8341 + 57 + 1: 
				case 0x82a0 + 57 + 1: 
					x = w * 4.0f; y = h * 5.0f;
					break;

					//< ύs
				case 0x8341 + 45 + 2:
				case 0x82a0 + 45 + 2:
					x = w * 5.0f; y = h * 5.0f;
					break;
				case 0x8341 + 48 + 2: 
				case 0x82a0 + 48 + 2: 
					x = w * 6.0f; y = h * 5.0f;
					break;
				case 0x8341 + 51 + 2: 
				case 0x82a0 + 51 + 2: 
					x = w * 7.0f; y = h * 5.0f;
					break;
				case 0x8341 + 54 + 2: 
				case 0x82a0 + 54 + 2: 
					x = w * 8.0f; y = h * 5.0f;
					break;
				case 0x8341 + 57 + 2: 
				case 0x82a0 + 57 + 2: 
					x = w * 9.0f; y = h * 5.0f;
					break;

					//< ܍s
				case 0x8341 + 60:
				case 0x82a0 + 60:
					x = w * 5.0f; y = h * 2.0f;
					break;
				case 0x8341 + 61: 
				case 0x82a0 + 61: 
					x = w * 6.0f; y = h * 2.0f;
					break;
				case 0x8341 + 63:
				case 0x82a0 + 62: 
					x = w * 7.0f; y = h * 2.0f;
					break;
				case 0x8341 + 64: 
				case 0x82a0 + 63: 
					x = w * 8.0f; y = h * 2.0f;
					break;
				case 0x8341 + 65: 
				case 0x82a0 + 64:
					x = w * 9.0f; y = h * 2.0f;
					break;

					//< s
				case 0x8341 + 67:
				case 0x82a0 + 66:
					x = w * 10.0f; y = h * 2.0f;
					break;
				case 0x8341 + 69: 
				case 0x82a0 + 68: 
					x = w * 11.0f; y = h * 2.0f;
					break;
				case 0x8341 + 71: 
				case 0x82a0 + 70: 
					x = w * 12.0f; y = h * 2.0f;
					break;

					//< s
				case 0x8341 + 67 -1:
				case 0x82a0 + 66 -1:
					x = w * 10.0f; y = h * 3.0f;
					break;
				case 0x8341 + 69 -1: 
				case 0x82a0 + 68 -1: 
					x = w * 11.0f; y = h * 3.0f;
					break;
				case 0x8341 + 71 -1: 
				case 0x82a0 + 70 -1: 
					x = w * 12.0f; y = h * 3.0f;
					break;

					//< s
				case 0x8341 + 72:
				case 0x82a0 + 71:
					x = w * 0.0f; y = h * 3.0f;
					break;
				case 0x8341 + 73: 
				case 0x82a0 + 72: 
					x = w * 1.0f; y = h * 3.0f;
					break;
				case 0x8341 + 74: 
				case 0x82a0 + 73: 
					x = w * 2.0f; y = h * 3.0f;
					break;
				case 0x8341 + 75: 
				case 0x82a0 + 74: 
					x = w * 3.0f; y = h * 3.0f;
					break;
				case 0x8341 + 76: 
				case 0x82a0 + 75: 
					x = w * 4.0f; y = h * 3.0f;
					break;

					//< 
				case 0x8341 + 78 -1:
				case 0x82a0 + 77 -1:
					x = w * 14.0f; y = h * 3.0f;
					break;

					//< s
				case 0x8341 + 78:
				case 0x82a0 + 77:
					x = w * 5.0f; y = h * 3.0f;
					break;
				case 0x8341 + 81: 
				case 0x82a0 + 80: 
					x = w * 6.0f; y = h * 3.0f;
					break;
				case 0x8341 + 82: 
				case 0x82a0 + 81: 
					x = w * 7.0f; y = h * 3.0f;
					break;

				default:
					return 0.0f;
				}
			}
		}

		CutOrigin() = Vector2(x, y);
		CutSize() = Vector2(w, h);

		_world = GetMatrix();
		_cut = GetTexcoord();
		_alpha = Alpha();
		graphics::shader::Parameter::AutoBeginTexture auto_tex(_smp, this);

		_plane.Begin();{
			_plane.Draw();
		} _plane.End();

		return w;
	}

	void Begin() {
		if(_vs->IsLoaded() && _ps->IsLoaded()){
			_vs->Begin();
			_ps->Begin();
		}
	}
	void End() {
		if(_vs->IsLoaded() && _ps->IsLoaded()){
			_vs->End();
			_ps->End();
		}
	}

	void OnLoaded() {
		Font::OnLoaded();

		_world = _vs->GetParameter("World");
		_cut = _vs->GetParameter("CutTexcoord");
		_smp = _ps->GetParameter("Sampler");
		_alpha = _ps->GetParameter("Alpha");
	}

private:
	graphics::shader::VertexProgram *_vs;
	graphics::shader::PixelProgram *_ps;
	graphics::shader::Parameter _world;
	graphics::shader::Parameter _cut;
	graphics::shader::Parameter _smp;
	graphics::shader::Parameter _alpha;
	primitive::ScreenPlane _plane;
};

/////////////////////////////////////////
//< main()
/////////////////////////////////////////
int main(int argc, char *argv[])
{
	//< 
	System::Initialize(ROOT"media"SEPARATOR);

	//< pbh͗p
	Input input;

	//< J
	DebugCamera camera(Vector3(0.0f, 15.0f, 50.0f), Vector3::Zero(), Vector3::Up(), Matrix44::Perspective(INDI_PI * 0.25f, graphics::System::GetAspectRatio(), 0.1f, 1000.0f));

#if 1
	//< f
	mesh::ScenesTextureFile *texture(new mesh::ScenesTextureFile("PlayerMarine.tex"));
	mesh::ScenesFile *model(new mesh::ScenesFile("PlayerMarine.scn"));
	//< Aj[Vt@C
	mesh::AnimationMapFile *animation(new mesh::AnimationMapFile("PlayerMarine.amp"));
#else
	mesh::ScenesTextureFile *texture(new mesh::ScenesTextureFile("dude.tex"));
	mesh::ScenesFile *model(new mesh::ScenesFile("dude.scn"));
	mesh::AnimationMapFile *animation(new mesh::AnimationMapFile("dude.amp"));
#endif

	//< XLjOVF[_
	graphics::shader::VertexProgram *vs(new graphics::shader::VertexProgram("skinning_animation_vs"SH_EXT));
	graphics::shader::PixelProgram *ps(new graphics::shader::PixelProgram("skinning_animation_ps"SH_EXT));
	//< {[ʒu\{bNXpAJ[VF[_
	graphics::shader::VertexProgram *color_vs(new graphics::shader::VertexProgram("color_vs"SH_EXT));
	graphics::shader::PixelProgram *color_ps(new graphics::shader::PixelProgram("color_ps"SH_EXT));
	//< {[\pAXvCgVF[_
	graphics::shader::VertexProgram *sprite_vs(new graphics::shader::VertexProgram("sprite_vs"SH_EXT));
	graphics::shader::PixelProgram *sprite_ps(new graphics::shader::PixelProgram("sprite_ps"SH_EXT));

	//< OtHgNX
	MyFont *font(new MyFont("font.tex", sprite_vs, sprite_ps));
	font->Origin() = static_cast<Sprite::SpriteOrigin>(Sprite::Left | Sprite::Top);

	graphics::System::ClearColor(127, 127, 255);

	//< WCgʒu֕\{bNX
	primitive::Box box;

#ifdef _DEBUG
	//< fobOXgbv
	DebugStop debug_stop;
#endif

	//< Q[[v
	while(1){
		//< 񓯊ǂݍ݂̏
		if(file::FileManager::Get())
			file::FileManager::Get()->Update();

		//< pbh
		input.Update();

		//< fobOJ
		if(input.Current(0).IsValid())
			camera.Control(input.Current(0));
		//< J̍XV
		camera.Update();

#ifdef _DEBUG
		//< fobOXgbv̑
		debug_stop.Control(input.Previous(0), input.Current(0));
#endif

		graphics::System::BeginBackBuffer();{
			
			graphics::System::Clear();

			if(animation->IsLoaded()){
				animation->SetClip(static_cast<u32>(0)); //< OԖڂ̃[Vw
				animation->SetController(0); //< ł̓Rg[͂OԂ݂̂̑O
			}

			//< fƃWCg\̐؂ւ
			BOOL joint_disp = ((AnimationTimer::current % 240) < 120); //< Ԍo߂ŃWCg̃f\ؑցiftHgj
			if(input.Current(0).A()) //< A{^ŋWCg\
				joint_disp = TRUE;
			else if(input.Current(0).B()) //< B{^ŋf\
				joint_disp = FALSE;

			//< f̕`
			if(!joint_disp){
				if(vs->IsLoaded() && ps->IsLoaded()){
					graphics::shader::Program::AutoBegin auto_vs(*vs);
					graphics::shader::Program::AutoBegin auto_ps(*ps);

					if(model->IsLoaded() && texture->IsLoaded() && animation->IsLoaded()){
						graphics::shader::Parameter w(vs->GetParameter("World"));
						graphics::shader::Parameter vp(vs->GetParameter("ViewProjection"));
						graphics::shader::Parameter anm_smp(vs->GetParameter("AnimationSampler"));
						graphics::shader::Parameter anm_siz(vs->GetParameter("AnimationSize"));
						graphics::shader::Parameter anm_idx(vs->GetParameter("AnimationIndex"));
#ifdef USE_SLERP
						graphics::shader::Parameter anm_idx_max(vs->GetParameter("AnimationIndexMax"));
						graphics::shader::Parameter anm_ratio(vs->GetParameter("AnimationIndexRatio"));
#endif

						graphics::shader::Parameter smp(ps->GetParameter("Sampler"));
										
						if(texture->GetTextureNum()) {
							vp = camera.ViewProjection();
							anm_siz = animation->GetTextureSize();

							graphics::shader::Parameter::AutoBeginTexture auto_anm_tex(anm_smp, animation->GetAnimationTexture()); //< Aj[V}bv
							graphics::shader::Parameter::AutoBeginTexture auto_tex(smp, texture->GetTexture(0)); //< f̃eNX`

							//< CfbNXƃEGCg̃f[^VF[_p[^֓n
							//< (VF[_̕ϐ"In.Indices"A"In.Weights"ȊOgĂꍇ͖IɑQARɎw肵Ă)
							model->SetIndexWeight(vs); 

							w = Matrix44::Identity() * Matrix44::Scale(1.0f);
							f32 tm(Timer::ToSecond(AnimationTimer::current)); //< ݂̃t[(b)
							anm_idx = static_cast<f32>(animation->GetLoopY(tm)); 
#ifdef USE_SLERP
							anm_idx_max = static_cast<f32>(animation->GetMaxY());
							anm_ratio = animation->GetLoopRatio(tm);
#endif
							model->Draw();
						}
					}
				}
			} else {
				if(model->IsLoaded() && animation->IsLoaded()){
					//< ŏ̃Rg[iRg[PȂ̂Ă̂ŁA蔲j
					const mesh::Controller *ctrl(0);
					for(u32 i=0;i<model->GetSceneNum();++i){
						const mesh::Scene *scene(model->GetScene(i));
						for(u32 j=0;j<scene->GetNodeNum();++j){
							const mesh::Node *node(scene->GetNode(j));
							if(node->GetControllerNum()){
								ctrl = node->GetController(0);
								break;
							}
							for(u32 k=0;k<node->GetNodeNum();++k){} //< {͍ċAIɒTȂĂ͂ȂȂBĩTvł͂Ȑ[Ƃɂ͖̂Ă̂Łj
						}
					}

					if(ctrl) {
						//< eWCg̈ʒuփ{bNX`
						if(!input.Current(0).Y() && color_vs->IsLoaded() && color_ps->IsLoaded()){
							graphics::shader::Program::AutoBegin auto_vs(*color_vs);
							graphics::shader::Program::AutoBegin auto_ps(*color_ps);

							Matrix44 scl(Matrix44::Scale(0.5f)); //< {bNX̕\TCY

							for(u32 i=0;i<ctrl->GetJointNum();++i) {	
								const mesh::Joint *jnt(ctrl->GetJoint(i));	
								//< Aj[ṼgXtH[(WCgԍƃAj[V}bvłYʒui狁܂jw肵āA擾܂)
								Matrix44 anm_trans(animation->GetTransform(i, animation->GetLoopY(Timer::ToSecond(AnimationTimer::current)))); 

								//< WCgԍƎɂxlgXtH[擾
								color_vs->GetParameter("WorldViewProjection") = scl * jnt->GetTransform() * anm_trans * camera.ViewProjection();
								color_ps->GetParameter("Color") = color::Green;

								box.Begin();{
									box.Draw();
								} box.End();
							}
						}

						//< WCg̈ʒuփWCg\(tHgɊ܂܂ĂȂ"_"͏o܂...)
						if(!input.Current(0).X() && font->IsLoaded()){
							graphics::System::Blend::AutoBegin auto_blend;
							graphics::System::Blend::Set(graphics::System::Blend::SRC_ALPHA, graphics::System::Blend::INV_SRC_ALPHA);

							for(u32 i=0;i<ctrl->GetJointNum();++i) {	
								const mesh::Joint *jnt(ctrl->GetJoint(i));	
								Matrix44 anm_trans(animation->GetTransform(i, animation->GetLoopY(Timer::ToSecond(AnimationTimer::current)))); 
								Vector3 screen_pos(graphics::System::Project(Vector3(jnt->GetTransform() * anm_trans), camera.ViewProjection() * graphics::System::GetViewportMatrix()));

								Font::AutoBegin font_auto(*font);
								font->Locate(static_cast<u32>(screen_pos.X()), static_cast<u32>(screen_pos.Y()));
								font->Puts(jnt->GetId());
							}
						}
					}
				}
			}
		} graphics::System::EndBackBuffer();
		graphics::System::SwapBuffers();

#ifdef _DEBUG
		if(!debug_stop.IsStop())
			++AnimationTimer::current;
#else
		++AnimationTimer::current;
#endif
	}

	delete font;

	delete sprite_ps;
	delete sprite_vs;

	delete color_ps;
	delete color_vs;

	delete ps;
	delete vs;

	delete ps;
	delete vs;

	delete animation;

	delete model;
	delete texture;

	System::Finalize();
}
