/*!
$Id: main.cpp 566 2009-11-27 02:41:47Z horino $

r{[hTv

  V_r{[h : ɃJ̕悤ɁAYiYȊOw\j̎ɉ]܂B^ォ猩낷ƃyȂ̂܂B́u؁vȂǂɂ悭pB
  r{[h : ֌WȂɃJ̕܂B
*/
#include "stdafx.h"

#define MAIN_CPP

#include "indi.h"
#include "graphics/graphics.h"
#include "file/file_manager.h"
#include "input/input.h"
#include "camera/debugcamera.h"
#include "mesh/scenes.h"
#include "graphics/shader/shader.h"
#include "primitive/primitive.h"
#include "graphics/texture_file.h"
using namespace indi;

#ifdef PS3
//#define ROOT "/dev_bdvd/PS3_GAME/USRDIR/"
#define ROOT "/app_home/samples/"
#else
#define ROOT "game:\\"
#endif

int main(int argc, char *argv[])
{
	//< 
	System::Initialize(ROOT"media"SEPARATOR);

	//< pbh͗p
	Input input;

	//< J
	DebugCamera camera(Vector3(0.0f, 0.0f, 50.0f), Vector3::Zero(), Vector3::Up(), Matrix44::Perspective(INDI_PI * 0.25f, graphics::System::GetAspectRatio(), 1.0f, 1000.0f));

	//< r{[h\p̃v[
	primitive::BillboardPlane plane;

	//< r{[heNX`i̊Gj
	graphics::TextureFile *texture(new graphics::TextureFile("billboard.tex"));

	//< VF[_
	graphics::shader::VertexProgram *cyl_vs(new graphics::shader::VertexProgram("cylindrical_billboard_vs"SH_EXT));
	graphics::shader::VertexProgram *sph_vs(new graphics::shader::VertexProgram("spherical_billboard_vs"SH_EXT));
	graphics::shader::PixelProgram *ps(new graphics::shader::PixelProgram("billboard_ps"SH_EXT));

	graphics::System::ClearColor(127, 127, 255);

	//< Q[[v
	while(1){
		//< 񓯊ǂݍ݂̏
		if(file::FileManager::Get())
			file::FileManager::Get()->Update();

		//< pbh
		input.Update();

		//< fobOJ
		if(input.Current(0).IsValid())
			camera.Control(input.Current(0));
		//< J̍XV
		camera.Update();

		graphics::System::BeginBackBuffer(); {
			graphics::System::Clear();

			if(texture->IsLoaded()){
				if(input.Current(0).A()){ //< (A{^ĂԂ)r{[h
					if(sph_vs->IsLoaded() && ps->IsLoaded()){
						graphics::shader::Program::AutoBegin auto_vs(*sph_vs);
						graphics::shader::Program::AutoBegin auto_ps(*ps);

						graphics::shader::Parameter vp(sph_vs->GetParameter("ViewProjection"));
						graphics::shader::Parameter world(sph_vs->GetParameter("World"));
						graphics::shader::Parameter cam(sph_vs->GetParameter("CameraPosition"));
						graphics::shader::Parameter up(sph_vs->GetParameter("CameraUp"));
						graphics::shader::Parameter smp(ps->GetParameter("Sampler"));

						vp = camera.ViewProjection();
						cam = camera.Position();
						up = camera.Up();
						{
							graphics::shader::Parameter::AutoBeginTexture auto_tex(smp, texture);

							for(u32 x = 0;x<10;++x)
								for(u32 y = 0;y<10;++y)
									for(u32 z = 0;z<10;++z){
										world = Matrix44::Translation(x * 5.0f - 25.0f, y * 5.0f - 25.0f, z * 5.0f - 25.0f);
										plane.Begin();{
											plane.Draw();
										} plane.End();
									}
						}
					}
				} else { //< V_r{[h
					if(cyl_vs->IsLoaded() && ps->IsLoaded()){
						graphics::shader::Program::AutoBegin auto_vs(*cyl_vs);
						graphics::shader::Program::AutoBegin auto_ps(*ps);

						graphics::shader::Parameter vp(cyl_vs->GetParameter("ViewProjection"));
						graphics::shader::Parameter world(cyl_vs->GetParameter("World"));
						graphics::shader::Parameter cam(cyl_vs->GetParameter("CameraPosition"));
						graphics::shader::Parameter axis(cyl_vs->GetParameter("Axis"));
						graphics::shader::Parameter smp(ps->GetParameter("Sampler"));

						vp = camera.ViewProjection();
						cam = camera.Position();
						axis = Vector3::Up();
						{
							graphics::shader::Parameter::AutoBeginTexture auto_tex(smp, texture);

							for(u32 x = 0;x<10;++x)
								for(u32 y = 0;y<10;++y)
									for(u32 z = 0;z<10;++z){
										world = Matrix44::Translation(x * 5.0f - 25.0f, y * 5.0f - 25.0f, z * 5.0f - 25.0f);
										plane.Begin();{
											plane.Draw();
										} plane.End();
									}
						}
					}
				}
			}
		} graphics::System::EndBackBuffer();
		graphics::System::SwapBuffers();
	}

	delete ps;
	delete sph_vs;
	delete cyl_vs;

	System::Finalize();
}
