/*!
$Id: main.cpp 581 2009-11-30 08:50:06Z horino $

}bvTv
XJC{bNXTv𗝉Ă邱Ƃ𐄏

*/
#include "stdafx.h"

#define MAIN_CPP

#include "indi.h"
#include "graphics/graphics.h"
#include "graphics/texture_file.h"
#include "file/file_manager.h"
#include "input/input.h"
#include "camera/debugcamera.h"
#include "mesh/scenes.h"
#include "mesh/scenes_texture.h"
#include "graphics/shader/shader.h"
#include "primitive/primitive.h"
#include "timer.h"
using namespace indi;

#ifdef PS3
//#define ROOT "/dev_bdvd/PS3_GAME/USRDIR/"
#define ROOT "/app_home/samples/"
#else
#define ROOT "game:\\"
#endif

int main(int argc, char *argv[])
{
	//< 
	System::Initialize(ROOT"media"SEPARATOR);

	//< pbh͗p
	Input input;

	//< J
	DebugCamera camera(Vector3(0.0f, 15.0f, 200.0f), Vector3::Zero(), Vector3::Up(), Matrix44::Perspective(INDI_PI * 0.25f, graphics::System::GetAspectRatio(), 10.0f, 1000.0f));

	//< XJC{bNXpv~eBuAL[ueNX`
	primitive::InnerBox sky_box;
	graphics::CubeTextureFile *sky_texture(new graphics::CubeTextureFile("skybox2.tex"));

	//< f
	mesh::ScenesTextureFile *texture(new mesh::ScenesTextureFile("duck.tex"));
	mesh::ScenesFile *model(new mesh::ScenesFile("duck.scn"));

//	mesh::ScenesTextureFile *texture(new mesh::ScenesTextureFile("EnemyBeast.tex"));
//	mesh::ScenesFile *model(new mesh::ScenesFile("EnemyBeast.scn"));

//	mesh::ScenesTextureFile *texture(new mesh::ScenesTextureFile("dude.tex"));
//	mesh::ScenesFile *model(new mesh::ScenesFile("dude.scn"));

//	mesh::ScenesTextureFile *texture(new mesh::ScenesTextureFile("PlayerMarine.tex"));
//	mesh::ScenesFile *model(new mesh::ScenesFile("PlayerMarine.scn"));

	//< VF[_
	graphics::shader::VertexProgram *vs(new graphics::shader::VertexProgram("environment_map_vs"SH_EXT));
	graphics::shader::PixelProgram *ps(new graphics::shader::PixelProgram("environment_map_ps"SH_EXT));

	graphics::shader::VertexProgram *sky_vs(new graphics::shader::VertexProgram("skybox_vs"SH_EXT));
	graphics::shader::PixelProgram *sky_ps(new graphics::shader::PixelProgram("skybox_ps"SH_EXT));

	graphics::System::ClearColor(255, 0, 0);

	//< Q[[v
	while(1){
		//< 񓯊ǂݍ݂̏
		if(file::FileManager::Get())
			file::FileManager::Get()->Update();

		//< pbh
		input.Update();

		//< fobOJ
		if(input.Current(0).IsValid())
			camera.Control(input.Current(0));
		//< J̍XV
		camera.Update();

		//< Cg̈ʒu
		f32 radian(math::ToRadian(static_cast<f32>(AnimationTimer::current % 360)));
		Vector3 light_pos(Quaternion::RotationY(radian).Rotate(Vector3(250.0f, 150.0f, 0.0f))); 

		graphics::System::BeginBackBuffer();{
			graphics::System::Clear();

			//< XJC{bNX̕`
			if(sky_vs->IsLoaded() && sky_ps->IsLoaded()){
				if(sky_texture->IsLoaded()){
					//< fvX݂̏𖳌ɂ܂
					graphics::System::DepthWrite(FALSE); {
						graphics::shader::Program::AutoBegin auto_vs(*sky_vs);
						graphics::shader::Program::AutoBegin auto_ps(*sky_ps);

						//< Jʒuփ{bNXu܂
						graphics::shader::Parameter wvp(sky_vs->GetParameter("WorldViewProjection"));
						graphics::shader::Parameter smp(sky_ps->GetParameter("Sampler"));
						{							
							//< XJC{bNX͏fȂ̂(jAAt@[)Nbvlɒ
							wvp = Matrix44::Translation(camera.Position()) * camera.View() * Matrix44::Perspective(INDI_PI * 0.25f, graphics::System::GetAspectRatio(), 0.1f, 10.0f);
							graphics::shader::Parameter::AutoBeginTexture auto_tex(smp, sky_texture);

							sky_box.Begin();{	   
								sky_box.Draw();
							} sky_box.End();
						}
					} graphics::System::DepthWrite(TRUE);
				}
			}

			//< VF[_ǂݍ݊ĂȂƂ`͂łȂ
			if(vs->IsLoaded() && ps->IsLoaded()){
				//< fƃeNX`ǂݍ܂ĂΕ`
				if(model->IsLoaded() && texture->IsLoaded() && sky_texture->IsLoaded()){
					graphics::shader::Program::AutoBegin auto_vs(*vs);
					graphics::shader::Program::AutoBegin auto_ps(*ps);

					//< {͖t[Ŏ擾̂͗ǂȂ(Tvł͉ǐd)
					graphics::shader::Parameter wvp(vs->GetParameter("WorldViewProjection"));
					graphics::shader::Parameter world(vs->GetParameter("World"));
					graphics::shader::Parameter cam(vs->GetParameter("CameraPosition"));
					graphics::shader::Parameter light(vs->GetParameter("LightPosition"));
					graphics::shader::Parameter smp(ps->GetParameter("Sampler"));
					graphics::shader::Parameter csmp(ps->GetParameter("CubeSampler"));
					if(texture->GetTextureNum()) {
						Matrix44 w(Matrix44::RotationY(radian));
						wvp = w * camera.ViewProjection();
						world = w;
						cam = camera.Position();
						light = light_pos;
						graphics::shader::Parameter::AutoBeginTexture auto_tex(smp, texture->GetTexture(0));
						graphics::shader::Parameter::AutoBeginTexture auto_cube_tex(csmp, sky_texture);

						model->Draw();
					}
				}
			}
		} graphics::System::EndBackBuffer();
		graphics::System::SwapBuffers();

		++AnimationTimer::current;
	}

	delete sky_ps;
	delete sky_vs;

	delete ps;
	delete vs;

	delete model;
	delete texture;

	delete sky_texture;

	System::Finalize();
}
