/*!
$Id: main.cpp 640 2009-12-24 07:03:53Z horino $

JOTv
*/
#include "stdafx.h"

#define MAIN_CPP

#include "indi.h"
#include "file/file_manager.h"
#include "graphics/graphics.h"
#include "input/input.h"
#include "camera/debugcamera.h"
#include "graphics/shader/shader.h"
#include "primitive/primitive.h"
#include "mesh/scenes.h"
#include "colors.h"
#include "timer.h"
#include "collision/collision.h"
#include "font/font.h"
using namespace indi;

#ifdef PS3
//#define ROOT "/dev_bdvd/PS3_GAME/USRDIR/"
#define ROOT "/app_home/samples/"
#else
#define ROOT "game:\\"
#endif

/*!
  \brief FontNXpĎOtHgNX쐬܂
  256 x 256 -> 16J x 9E -> P 16 x 28.4

  0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5
  0 ACEGIJLNPRTVXZ\ 
  1 ^`cegijklm@BDFH
  2 nqtwz}~@|
  3 JKb
  4 KMOQSUWY[]_adfh
  5 orux{psvy|E
  6 `abcdefghijklmn
  7 opqrstuvwxyOPQR
  8 STUVWX
*/
class MyFont : public Font
{
public:
	MyFont(const char *path, graphics::shader::VertexProgram *vs, graphics::shader::PixelProgram *ps) : Font(path), _vs(vs), _ps(ps) {}
	virtual ~MyFont() {}

	f32 GetLineSpace() const { return 256.0f / 9.0f; }

	/*!
	  \brief `֐܂
	  \note 쐬ꂽtHgeNX`ɂ蕶̕т܂܂Ȃ̂ŁA[UŎKv
	  ̃P[Xł̓eNX`ł̕̕тgbL[Ȃ̂ŃR[h債Ă邪AтHv΂ƊȒPɂł(http://ash.jp/code/codetbl2.htm)̕тȂ炢̂
	*/
	f32 Draw(const char *s) {
		if(!IsLoaded()) return 0.0f;
		//< ؂oʒu肵܂
		f32 w(16.0f), h(GetLineSpace());
		f32 x, y;
		if(Is8BitChar(s[0])){ //< 1bytȅꍇ
			if(Isspace(s[0])){
				x = 15.0f * w;
				y = h * 8.0f;
			} else if(Isdigit(s[0])){
				if(s[0] >= '4'){
					y = h * 8.0f;
					x = static_cast<f32>(s[0] - '4') * w;
				} else {
					y = h * 7.0f;
					x = static_cast<f32>(s[0] - '0' + 11) * w;
				}
			} else if(Isalpha(s[0])){
				if(Islower(s[0])){
					if(s[0] >= 'p') {
						y = h * 7.0f;
						x = static_cast<f32>(s[0] - 'p') * w;
					} else {
						y = h * 6.0f;
						x = static_cast<f32>(s[0] - 'a') * w;
					}
				} else {
					if(s[0] >= 'P') {
						y = h * 7.0f;
						x = static_cast<f32>(s[0] - 'P') * w;
					} else {
						y = h * 6.0f;
						x = static_cast<f32>(s[0] - 'A') * w;
					}
				}
			} else 
				return 0.0f;
		} else { //< 2bytȅꍇ
			const u16 c(*reinterpret_cast<const u16 *>(s));
			if((c > 0x829e && c < 0x839e) || c == 0x8145 || c == 0x815b){ //< Ђ炪 ` J^Ji͈̔͂"["A"E"̂ݑΉ
				switch(c){
					//< "E"
				case 0x8145:             
					x = w * 10.0f; y = h * 5.0f;      
					break;
					//< "["
				case 0x815b:       
					x = w * 14.0f; y = h * 2.0f;      
					break;

					//< s
				case 0x8341: //< A
				case 0x82a0: //< 
					x = w * 0.0f; y = h * 0.0f;
					break;
				case 0x8341 + 2: //< C
				case 0x82a0 + 2: //< 
					x = w * 1.0f; y = h * 0.0f;
					break;
				case 0x8341 + 4: //< E
				case 0x82a0 + 4: //< 
					x = w * 2.0f; y = h * 0.0f;
					break;
				case 0x8341 + 6: //< G
				case 0x82a0 + 6: //< 
					x = w * 3.0f; y = h * 0.0f;
					break;
				case 0x8341 + 8: //< I
				case 0x82a0 + 8: //< 
					x = w * 4.0f; y = h * 0.0f;
					break;

					//< s
				case 0x8341 - 1:
				case 0x82a0 - 1:
					x = w * 10.0f; y = h * 1.0f;
					break;
				case 0x8341 + 2 - 1:
				case 0x82a0 + 2 - 1:
					x = w * 11.0f; y = h * 1.0f;
					break;
				case 0x8341 + 4 - 1:
				case 0x82a0 + 4 - 1:
					x = w * 12.0f; y = h * 1.0f;
					break;
				case 0x8341 + 6 - 1:
				case 0x82a0 + 6 - 1:
					x = w * 13.0f; y = h * 1.0f;
					break;
				case 0x8341 + 8 - 1:
				case 0x82a0 + 8 - 1:
					x = w * 14.0f; y = h * 1.0f;
					break;

					//< s
				case 0x8341 + 9:
				case 0x82a0 + 9:
					x = w * 5.0f; y = h * 0.0f;
					break;
				case 0x8341 + 11: 
				case 0x82a0 + 11: 
					x = w * 6.0f; y = h * 0.0f;
					break;
				case 0x8341 + 13: 
				case 0x82a0 + 13: 
					x = w * 7.0f; y = h * 0.0f;
					break;
				case 0x8341 + 15: 
				case 0x82a0 + 15: 
					x = w * 8.0f; y = h * 0.0f;
					break;
				case 0x8341 + 17: 
				case 0x82a0 + 17: 
					x = w * 9.0f; y = h * 0.0f;
					break;

					//< s
				case 0x8341 + 9 + 1:
				case 0x82a0 + 9 + 1:
					x = w * 0.0f; y = h * 4.0f;
					break;
				case 0x8341 + 11 + 1: 
				case 0x82a0 + 11 + 1: 
					x = w * 1.0f; y = h * 4.0f;
					break;
				case 0x8341 + 13 + 1: 
				case 0x82a0 + 13 + 1: 
					x = w * 2.0f; y = h * 4.0f;
					break;
				case 0x8341 + 15 + 1: 
				case 0x82a0 + 15 + 1: 
					x = w * 3.0f; y = h * 4.0f;
					break;
				case 0x8341 + 17 + 1: 
				case 0x82a0 + 17 + 1: 
					x = w * 4.0f; y = h * 4.0f;
					break;

					//< s
				case 0x8341 + 19:
				case 0x82a0 + 19:
					x = w * 10.0f; y = 0.0f;
					break;
				case 0x8341 + 21: 
				case 0x82a0 + 21: 
					x = w * 11.0f; y = 0.0f;
					break;
				case 0x8341 + 23: 
				case 0x82a0 + 23: 
					x = w * 12.0f; y = 0.0f;
					break;
				case 0x8341 + 25: 
				case 0x82a0 + 25: 
					x = w * 13.0f; y = 0.0f;
					break;
				case 0x8341 + 27: 
				case 0x82a0 + 27: 
					x = w * 14.0f; y = 0.0f;
					break;

					//< s
				case 0x8341 + 19 + 1:
				case 0x82a0 + 19 + 1:
					x = w * 5.0f; y = h * 4.0f;
					break;
				case 0x8341 + 21 + 1: 
				case 0x82a0 + 21 + 1: 
					x = w * 6.0f; y = h * 4.0f;
					break;
				case 0x8341 + 23 + 1: 
				case 0x82a0 + 23 + 1: 
					x = w * 7.0f; y = h * 4.0f;
					break;
				case 0x8341 + 25 + 1: 
				case 0x82a0 + 25 + 1: 
					x = w * 8.0f; y = h * 4.0f;
					break;
				case 0x8341 + 27 + 1: 
				case 0x82a0 + 27 + 1: 
					x = w * 9.0f; y = h * 4.0f;
					break;

					//< s
				case 0x8341 + 29:
				case 0x82a0 + 29:
					x = 0.0f; y = h;
					break;
				case 0x8341 + 31: 
				case 0x82a0 + 31: 
					x = w; y = h;
					break;
				case 0x8341 + 34: 
				case 0x82a0 + 34: 
					x = w * 2.0f; y = h;
					break;
				case 0x8341 + 36: 
				case 0x82a0 + 36: 
					x = w * 3.0f; y = h;
					break;
				case 0x8341 + 38: 
				case 0x82a0 + 38: 
					x = w * 4.0f; y = h;
					break;

					//< s
				case 0x8341 + 29 + 1:
				case 0x82a0 + 29 + 1:
					x = w * 10.0f; y = h * 4.0f;
					break;
				case 0x8341 + 31 + 1: 
				case 0x82a0 + 31 + 1: 
					x = w * 11.0f; y = h * 4.0f;
					break;
				case 0x8341 + 34 + 1: 
				case 0x82a0 + 34 + 1: 
					x = w * 12.0f; y = h * 4.0f;
					break;
				case 0x8341 + 36 + 1: 
				case 0x82a0 + 36 + 1: 
					x = w * 13.0f; y = h * 4.0f;
					break;
				case 0x8341 + 38 + 1:
				case 0x82a0 + 38 + 1: 
					x = w * 14.0f; y = h * 4.0f;
					break;

					//< 
				case 0x8362:
				case 0x82c1: 
					x = w * 13.0f; y = h * 3.0f;
					break;

					//< ȍs
				case 0x8341 + 40:
				case 0x82a0 + 40:
					x = w * 5.0f; y = h;
					break;
				case 0x8341 + 41: 
				case 0x82a0 + 41: 
					x = w * 6.0f; y = h;
					break;
				case 0x8341 + 42: 
				case 0x82a0 + 42: 
					x = w * 7.0f; y = h;
					break;
				case 0x8341 + 43: 
				case 0x82a0 + 43: 
					x = w * 8.0f; y = h;
					break;
				case 0x8341 + 44: 
				case 0x82a0 + 44: 
					x = w * 9.0f; y = h;
					break;

					//< ͍s
				case 0x8341 + 45:
				case 0x82a0 + 45:
					x = w * 0.0f; y = h * 2.0f;
					break;
				case 0x8341 + 48: 
				case 0x82a0 + 48: 
					x = w * 1.0f; y = h * 2.0f;
					break;
				case 0x8341 + 51: 
				case 0x82a0 + 51: 
					x = w * 2.0f; y = h * 2.0f;
					break;
				case 0x8341 + 54: 
				case 0x82a0 + 54: 
					x = w * 3.0f; y = h * 2.0f;
					break;
				case 0x8341 + 57: 
				case 0x82a0 + 57: 
					x = w * 4.0f; y = h * 2.0f;
					break;

					//< ΍s
				case 0x8341 + 45 + 1:
				case 0x82a0 + 45 + 1:
					x = w * 0.0f; y = h * 5.0f;
					break;
				case 0x8341 + 48 + 1: 
				case 0x82a0 + 48 + 1: 
					x = w * 1.0f; y = h * 5.0f;
					break;
				case 0x8341 + 51 + 1: 
				case 0x82a0 + 51 + 1: 
					x = w * 2.0f; y = h * 5.0f;
					break;
				case 0x8341 + 54 + 1: 
				case 0x82a0 + 54 + 1: 
					x = w * 3.0f; y = h * 5.0f;
					break;
				case 0x8341 + 57 + 1: 
				case 0x82a0 + 57 + 1: 
					x = w * 4.0f; y = h * 5.0f;
					break;

					//< ύs
				case 0x8341 + 45 + 2:
				case 0x82a0 + 45 + 2:
					x = w * 5.0f; y = h * 5.0f;
					break;
				case 0x8341 + 48 + 2: 
				case 0x82a0 + 48 + 2: 
					x = w * 6.0f; y = h * 5.0f;
					break;
				case 0x8341 + 51 + 2: 
				case 0x82a0 + 51 + 2: 
					x = w * 7.0f; y = h * 5.0f;
					break;
				case 0x8341 + 54 + 2: 
				case 0x82a0 + 54 + 2: 
					x = w * 8.0f; y = h * 5.0f;
					break;
				case 0x8341 + 57 + 2: 
				case 0x82a0 + 57 + 2: 
					x = w * 9.0f; y = h * 5.0f;
					break;

					//< ܍s
				case 0x8341 + 60:
				case 0x82a0 + 60:
					x = w * 5.0f; y = h * 2.0f;
					break;
				case 0x8341 + 61: 
				case 0x82a0 + 61: 
					x = w * 6.0f; y = h * 2.0f;
					break;
				case 0x8341 + 63:
				case 0x82a0 + 62: 
					x = w * 7.0f; y = h * 2.0f;
					break;
				case 0x8341 + 64: 
				case 0x82a0 + 63: 
					x = w * 8.0f; y = h * 2.0f;
					break;
				case 0x8341 + 65: 
				case 0x82a0 + 64:
					x = w * 9.0f; y = h * 2.0f;
					break;

					//< s
				case 0x8341 + 67:
				case 0x82a0 + 66:
					x = w * 10.0f; y = h * 2.0f;
					break;
				case 0x8341 + 69: 
				case 0x82a0 + 68: 
					x = w * 11.0f; y = h * 2.0f;
					break;
				case 0x8341 + 71: 
				case 0x82a0 + 70: 
					x = w * 12.0f; y = h * 2.0f;
					break;

					//< s
				case 0x8341 + 67 -1:
				case 0x82a0 + 66 -1:
					x = w * 10.0f; y = h * 3.0f;
					break;
				case 0x8341 + 69 -1: 
				case 0x82a0 + 68 -1: 
					x = w * 11.0f; y = h * 3.0f;
					break;
				case 0x8341 + 71 -1: 
				case 0x82a0 + 70 -1: 
					x = w * 12.0f; y = h * 3.0f;
					break;

					//< s
				case 0x8341 + 72:
				case 0x82a0 + 71:
					x = w * 0.0f; y = h * 3.0f;
					break;
				case 0x8341 + 73: 
				case 0x82a0 + 72: 
					x = w * 1.0f; y = h * 3.0f;
					break;
				case 0x8341 + 74: 
				case 0x82a0 + 73: 
					x = w * 2.0f; y = h * 3.0f;
					break;
				case 0x8341 + 75: 
				case 0x82a0 + 74: 
					x = w * 3.0f; y = h * 3.0f;
					break;
				case 0x8341 + 76: 
				case 0x82a0 + 75: 
					x = w * 4.0f; y = h * 3.0f;
					break;

					//< 
				case 0x8341 + 78 -1:
				case 0x82a0 + 77 -1:
					x = w * 14.0f; y = h * 3.0f;
					break;

					//< s
				case 0x8341 + 78:
				case 0x82a0 + 77:
					x = w * 5.0f; y = h * 3.0f;
					break;
				case 0x8341 + 81: 
				case 0x82a0 + 80: 
					x = w * 6.0f; y = h * 3.0f;
					break;
				case 0x8341 + 82: 
				case 0x82a0 + 81: 
					x = w * 7.0f; y = h * 3.0f;
					break;

				default:
					return 0.0f;
				}
			}
		}

		CutOrigin() = Vector2(x, y);
		CutSize() = Vector2(w, h);

		_world = GetMatrix();
		_cut = GetTexcoord();
		_alpha = Alpha();
		graphics::shader::Parameter::AutoBeginTexture auto_tex(_smp, this);

		_plane.Begin();{
			_plane.Draw();
		} _plane.End();

		return w;
	}

	void Begin() {
		if(_vs->IsLoaded() && _ps->IsLoaded()){
			_vs->Begin();
			_ps->Begin();
		}
	}
	void End() {
		if(_vs->IsLoaded() && _ps->IsLoaded()){
			_vs->End();
			_ps->End();
		}
	}

	void OnLoaded() {
		Font::OnLoaded();

		_world = _vs->GetParameter("World");
		_cut = _vs->GetParameter("CutTexcoord");
		_smp = _ps->GetParameter("Sampler");
		_alpha = _ps->GetParameter("Alpha");
	}

private:
	graphics::shader::VertexProgram *_vs;
	graphics::shader::PixelProgram *_ps;
	graphics::shader::Parameter _world;
	graphics::shader::Parameter _cut;
	graphics::shader::Parameter _smp;
	graphics::shader::Parameter _alpha;
	primitive::ScreenPlane _plane;
};

/////////////////////////////////////////
//< main()
/////////////////////////////////////////
int main(int argc, char *argv[])
{
	//< 
	System::Initialize(ROOT"media"SEPARATOR);

	//< pbh͗p
	Input input;

	//< f(AABBt)
	mesh::ScenesAABBFile *model(new mesh::ScenesAABBFile("duck.scn"));

	//< J
	DebugCamera camera(Vector3(0.0f, 0.0f, 25.0f), Vector3::Zero(), Vector3::Up(), Matrix44::Perspective(INDI_PI * 0.25f, graphics::System::GetAspectRatio(), 0.1f, 200.0f));

	//< VF[_
	graphics::shader::VertexProgram *vs(new graphics::shader::VertexProgram("color_vs"SH_EXT));
	graphics::shader::PixelProgram *ps(new graphics::shader::PixelProgram("color_ps"SH_EXT));

	graphics::shader::VertexProgram *sprite_vs(new graphics::shader::VertexProgram("sprite_vs"SH_EXT));
	graphics::shader::PixelProgram *sprite_ps(new graphics::shader::PixelProgram("sprite_ps"SH_EXT));

	//< OtHgNX
	MyFont *font(new MyFont("font.tex", sprite_vs, sprite_ps));
	font->Origin() = static_cast<Sprite::SpriteOrigin>(Sprite::Left | Sprite::Top);

	graphics::System::ClearColor(127, 127, 255);

	//< {bNX
	primitive::WireBox wire_box;

	//< Q[[v
	while(1){
		//< 񓯊ǂݍ݂̏
		if(file::FileManager::Get())
			file::FileManager::Get()->Update();

		//< pbh
		input.Update();
		
		//< fobOJ
		if(input.Current(0).IsValid())
			camera.Control(input.Current(0));

		//< J̍XV
		camera.Update();

		graphics::System::BeginBackBuffer();{
			
			graphics::System::Clear();

			u32 draw_cnt(0); //< `悵JEg

			if(vs->IsLoaded() && ps->IsLoaded()){
				graphics::shader::Program::AutoBegin auto_vs(*vs);
				graphics::shader::Program::AutoBegin auto_ps(*ps);

				if(model->IsLoaded()){
					graphics::shader::Parameter wvp(vs->GetParameter("WorldViewProjection"));
					graphics::shader::Parameter col(ps->GetParameter("Color"));

					static const u32 num(7);
					f32 offset(20.0f);
					f32 scale(0.05f);

					//< ̍XV
					Collision::Frustum &frustum(graphics::System::GetFrustum());
					frustum.Update(Matrix44::Identity(), camera.View(), camera.Projection());

					//< `
					for(u32 y=0;y<num;++y) {
						for(u32 x=0;x<num;++x) {
							for(u32 z=0;z<num;++z) {
								Vector3 pos(static_cast<f32>(x) - static_cast<f32>(num) * 0.5f, static_cast<f32>(y) - static_cast<f32>(num) * 0.5f, static_cast<f32>(z) - static_cast<f32>(num) * 0.5f);
								pos *= offset;

								//< Ɋ܂܂̂`
								if(input.Current(0).A() || frustum.Contains(model->Center() * scale + pos, model->Radius() * scale)){
									//< 3Df`
									Matrix44 tr(Matrix44::Scale(scale) * Matrix44::Translation(pos));
									wvp = tr * camera.ViewProjection();
									col = Vector4(static_cast<f32>(x) / num, static_cast<f32>(y) / num, static_cast<f32>(z) / num, 1.0f);
									model->Draw();

									col = color::Green;
									//< AABB\
									wvp = Matrix44::Scale(model->Radius() * 2.0f) * Matrix44::Translation(model->Center()) * tr * camera.ViewProjection();
									wire_box.Begin(); wire_box.Draw(); wire_box.End();

									++draw_cnt;
								}
							}
						}
					}
				}

				if(font->IsLoaded()){
					Font::AutoBegin font_auto(*font);

					font->Locate(50, 50);
					font->Scale() = Vector2::One();
					font->Printf("т傤 %d\n", draw_cnt);
				}
			}
		} graphics::System::EndBackBuffer();
		graphics::System::SwapBuffers();

		++AnimationTimer::current;
	}

	delete font;

	delete sprite_ps;
	delete sprite_vs;

	delete ps;
	delete vs;

	delete model;

	System::Finalize();
}
