/*!
$Id: main.cpp 558 2009-11-26 07:21:40Z horino $

m[}}bsOTv
(m[}}bṽeNX`pӂÃeNX`VF[_ŎQƂȂ`悵܂j

EnemyBeastf͐̓XLjOf̕`@gׂAł͊ȗ
*/
#include "stdafx.h"

#define MAIN_CPP

#include "indi.h"
#include "graphics/graphics.h"
#include "file/file_manager.h"
#include "input/input.h"
#include "camera/debugcamera.h"
#include "mesh/scenes.h"
#include "mesh/scenes_texture.h"
#include "graphics/shader/shader.h"
#include "graphics/texture_file.h"
#include "primitive/primitive.h"
#include "graphics/rendertarget.h"
#include "graphics/framebuffer.h"
#include "timer.h"
using namespace indi;

#ifdef PS3
//#define ROOT "/dev_bdvd/PS3_GAME/USRDIR/"
#define ROOT "/app_home/samples/"
#else
#define ROOT "game:\\"
#endif

int main(int argc, char *argv[])
{
	//< 
	System::Initialize(ROOT"media"SEPARATOR);

	//< pbh͗p
	Input input;

	//< J
	DebugCamera camera(Vector3(0.0f, 15.0f, 200.0f), Vector3::Zero(), Vector3::Up(), Matrix44::Perspective(INDI_PI * 0.25f, graphics::System::GetAspectRatio(), 10.0f, 1000.0f));

	//< eNX`fobO\p̃v[
	primitive::ScreenPlane plane;

	//< nʗpv[
	primitive::ScreenPlane ground;

	//< f(eNX`ɖ@}bv)
	mesh::ScenesTextureFile *texture(new mesh::ScenesTextureFile("EnemyBeast.tex"));
	mesh::ScenesFile *model(new mesh::ScenesFile("EnemyBeast.scn"));

	//< nʗpeNX`Ɩ@}bv
	mesh::ScenesTextureFile *ground_texture(new mesh::ScenesTextureFile("wall_normal.tex"));

	//< VF[_
	graphics::shader::VertexProgram *vs(new graphics::shader::VertexProgram("normal_map_vs"SH_EXT));
	graphics::shader::PixelProgram *ps(new graphics::shader::PixelProgram("normal_map_ps"SH_EXT));

	graphics::shader::VertexProgram *textured_vs(new graphics::shader::VertexProgram("textured_vs"SH_EXT));
	graphics::shader::PixelProgram *textured_ps(new graphics::shader::PixelProgram("textured_ps"SH_EXT));

	graphics::System::ClearColor(127, 127, 255);

	//< Q[[v
	while(1){
		//< 񓯊ǂݍ݂̏
		if(file::FileManager::Get())
			file::FileManager::Get()->Update();

		//< pbh
		input.Update();

		//< fobOJ
		if(input.Current(0).IsValid())
			camera.Control(input.Current(0));
		//< J̍XV
		camera.Update();

		//< Cg̈ʒu
		f32 radian(math::ToRadian(static_cast<f32>(AnimationTimer::current % 360)));
		Vector3 light_pos(Quaternion::RotationY(radian).Rotate(Vector3(250.0f, 150.0f, 0.0f))); 

		graphics::System::BeginBackBuffer();{

			graphics::System::Clear();

			if(textured_vs->IsLoaded() && textured_ps->IsLoaded()){
				mesh::ScenesTextureFile *target_tex = texture;
				if(input.Current(0).A())
					target_tex = ground_texture;
				//< ̃fgĂeNX`wiɕ\Ă݂
				if(target_tex->IsLoaded()){
					f32 sq(math::Sqrt(static_cast<f32>(target_tex->GetTextureNum())));
					u32 col(static_cast<u32>(sq) + (sq > static_cast<f32>(static_cast<u32>(sq)) ? 1 : 0));
					f32 ratio(1.0f / static_cast<f32>(col));

					graphics::System::DepthWrite(FALSE);{
						graphics::shader::Program::AutoBegin auto_vs(*textured_vs);
						graphics::shader::Program::AutoBegin auto_psinPS(*textured_ps);

						graphics::shader::Parameter wvp(textured_vs->GetParameter("WorldViewProjection"));
						graphics::shader::Parameter smp(textured_ps->GetParameter("Sampler"));
						for(u32 i=0;i<target_tex->GetTextureNum();++i) {
							wvp = Matrix44::Scale(ratio * 0.9f) * Matrix44::Translation((i % col) * ratio * 2.0f - (1.0f - ratio), -((i / col) * ratio * 2.0f - (1.0f - ratio)), 0);
							graphics::shader::Parameter::AutoBeginTexture auto_tex(smp, target_tex->GetTexture(i));

							plane.Begin();{
								plane.Draw();
							} plane.End();							
						}	
					} graphics::System::DepthWrite(TRUE);
				}
			}

			if(vs->IsLoaded() && ps->IsLoaded()){
				graphics::shader::Parameter wvp(vs->GetParameter("WorldViewProjection"));
				graphics::shader::Parameter world(vs->GetParameter("World"));
				graphics::shader::Parameter light(vs->GetParameter("LightPosition"));
				graphics::shader::Parameter cam(vs->GetParameter("CameraPosition"));
				graphics::shader::Parameter world_ps(ps->GetParameter("World"));
				graphics::shader::Parameter smp(ps->GetParameter("Sampler"));
				graphics::shader::Parameter nsmp(ps->GetParameter("NormalSampler"));
				//graphics::shader::Parameter ssmp(ps->GetParameter("SpecularSampler"));

				graphics::shader::Program::AutoBegin auto_vs(*vs);
				graphics::shader::Program::AutoBegin auto_ps(*ps);

				light = light_pos;
				cam = camera.Position();

				//< nʂ̕`
				if(ground_texture->IsLoaded() && ground_texture->GetTextureNum() > 1){
					Matrix44 m(Matrix44::RotationX(INDI_PI * 1.5f) * Matrix44::Scale(100.0f));
					wvp = m * camera.ViewProjection();
					world = m;
					world_ps = m;
					{
						graphics::shader::Parameter::AutoBeginTexture auto_tex(smp, ground_texture->GetTexture(0)); //< Diffuse Map
						graphics::shader::Parameter::AutoBeginTexture auto_normal_tex(nsmp, ground_texture->GetTexture(1)); //< Normal Map
						ground.Begin();{
							ground.Draw();
						} ground.End();
					}
				}

				//< f̕`
				if(model->IsLoaded() && texture->IsLoaded() && texture->GetTextureNum() > 2){
					wvp = Matrix44::Identity() * camera.ViewProjection();
					world = Matrix44::Identity();
					world_ps = Matrix44::Identity();
					{
						graphics::shader::Parameter::AutoBeginTexture auto_tex(smp, texture->GetTexture(0)); //< Diffuse Map
						graphics::shader::Parameter::AutoBeginTexture auto_normal_tex(nsmp, texture->GetTexture(1)); //< Normal Map
						//graphics::shader::Parameter::AutoBeginTexture auto_specular_tex(ssmp, texture->GetTexture(2)); //< Specular Map

						model->Draw();
					}
				}
			}

		} graphics::System::EndBackBuffer();
		graphics::System::SwapBuffers();

		++AnimationTimer::current;
	}

	delete textured_ps;
	delete textured_vs;

	delete ps;
	delete vs;

	delete ground_texture;

	delete model;
	delete texture;

	System::Finalize();
}
