/*!
$Id: main.cpp 537 2009-11-20 08:19:06Z horino $

eNX`ւ̃_O

*/
#include "stdafx.h"

#define MAIN_CPP

#include "indi.h"
#include "graphics/graphics.h"
#include "file/file_manager.h"
#include "input/input.h"
#include "camera/debugcamera.h"
#include "mesh/scenes.h"
#include "mesh/scenes_texture.h"
#include "graphics/shader/shader.h"
#include "primitive/primitive.h"
#include "graphics/rendertarget.h"
#include "graphics/framebuffer.h"
using namespace indi;

#ifdef PS3
//#define ROOT "/dev_bdvd/PS3_GAME/USRDIR/"
#define ROOT "/app_home/samples/"
#else
#define ROOT "game:\\"
#endif

int main(int argc, char *argv[])
{
	//< 
	System::Initialize(ROOT"media"SEPARATOR);

	//< pbh͗p
	Input input;

	//< J
	DebugCamera camera(Vector3(0.0f, 200.0f, 200.0f), Vector3::Zero(), Vector3::Up(), Matrix44::Perspective(INDI_PI * 0.25f, graphics::System::GetAspectRatio(), 10.f, 1000.0f));

	//< eNX`fobO\p̃v[
	primitive::ScreenPlane plane;

	//< f
	mesh::ScenesTextureFile *texture(new mesh::ScenesTextureFile("duck.tex"));
	mesh::ScenesFile *model(new mesh::ScenesFile("duck.scn"));

	//< VF[_
	graphics::shader::VertexProgram *vs(new graphics::shader::VertexProgram("textured_vs"SH_EXT));
	graphics::shader::PixelProgram *ps(new graphics::shader::PixelProgram("textured_ps"SH_EXT));
	//< UVV]ΉpVF[_
	graphics::shader::VertexProgram *render_vs(new graphics::shader::VertexProgram("render_texture_vs"SH_EXT));
	graphics::shader::PixelProgram *render_ps(new graphics::shader::PixelProgram("render_texture_ps"SH_EXT));

	u32 width(graphics::System::GetScreenWidth()), height(graphics::System::GetScreenHeight());
	//< `̃eNX`(color_map)ƃ_^[Qbg(color_target)
	graphics::RenderTexture *color_map(new graphics::RenderTexture(width, height)); 
	graphics::RenderTarget *color_target(new graphics::RenderTarget(color_map));
	//< Zobt@_^[Qbgi`̑O֌Wۂ߂ɕKvj
	graphics::DepthTarget *depth_target(new graphics::DepthTarget(width, height));
	//< eNX`ւ̃_Opt[obt@
	graphics::FrameBuffer *color_buffer(new graphics::FrameBuffer(color_target, depth_target));

	graphics::System::ClearColor(127, 127, 255);

	//< Q[[v
	while(1){
		//< 񓯊ǂݍ݂̏
		if(file::FileManager::Get())
			file::FileManager::Get()->Update();

		//< pbh
		input.Update();

		//< fobOJ
		if(input.Current(0).IsValid())
			camera.Control(input.Current(0));
		//< J̍XV
		camera.Update();
		
		//< t[obt@ւ̕`(ȉ̕`͉ʂɂ͕\܂)
		{
			graphics::FrameBuffer::AutoBegin auto_fb(color_buffer); //< `挋ʂcolor_map

			graphics::System::ClearColor(127, 255, 127);
			graphics::System::Clear();

			//< VF[_ǂݍ݊ĂȂƂ`͂łȂ
			if(vs->IsLoaded() && ps->IsLoaded()){
				//< fƃeNX`ǂݍ܂ĂΕ`
				if(model->IsLoaded() && texture->IsLoaded()){
					graphics::shader::Program::AutoBegin auto_vs(*vs);
					graphics::shader::Program::AutoBegin auto_ps(*ps);

					//< {͖t[Ŏ擾̂͗ǂȂ(Tvł͉ǐd)
					graphics::shader::Parameter wvp(vs->GetParameter("WorldViewProjection"));
					graphics::shader::Parameter smp(ps->GetParameter("Sampler"));
					if(texture->GetTextureNum()) {
						wvp = Matrix44::Identity() * camera.ViewProjection();
						graphics::shader::Parameter::AutoBeginTexture auto_tex(smp, texture->GetTexture(0));

						model->Draw();
					}
				}
			}
		}

		//< obNobt@ǐXbvʁjւ̕`
		graphics::System::BeginBackBuffer(); {
			graphics::System::ClearColor(127, 127, 255);
			graphics::System::Clear();

			//< color_map̓e\
			if(render_vs->IsLoaded() && render_ps->IsLoaded()){
				graphics::shader::Program::AutoBegin auto_vs(*render_vs);
				graphics::shader::Program::AutoBegin auto_ps(*render_ps);
					
				graphics::shader::Parameter wvp(render_vs->GetParameter("WorldViewProjection"));
				graphics::shader::Parameter smp(render_ps->GetParameter("Sampler"));
				{
					wvp = Matrix44::Scale(100) * camera.ViewProjection();
					graphics::shader::Parameter::AutoBeginTexture auto_tex(smp, color_map);
				
					plane.Begin();{
						plane.Draw();
					} plane.End();
				}
			}
		} graphics::System::EndBackBuffer();

		//< obNobt@̃Xbv
		graphics::System::SwapBuffers();
	}

	delete color_buffer;
	delete depth_target;
	delete color_target;
	delete color_map;

	delete ps;
	delete vs;

	delete render_ps;
	delete render_vs;

	delete model;
	delete texture;

	System::Finalize();
}
