uniform sampler2D Sampler;
uniform float BlurSize;

struct PS_IN
{
	float4 Position : POSITION;
	float2 Texcoord : TEXCOORD0;
};

struct PS_OUT
{
	float4 Color : COLOR;
};

PS_OUT main (PS_IN In)
{       
	PS_OUT Out = (PS_OUT)0;

	float positions = 0.0f;
	float weights = 0.0530577f;
	Out.Color += tex2D(Sampler, In.Texcoord + float2(positions, 0) * BlurSize) * weights + tex2D(Sampler, In.Texcoord - float2(positions, 0) * BlurSize) * weights;

	positions = 0.005f;
	weights = 0.1028506f;
	Out.Color += tex2D(Sampler, In.Texcoord + float2(positions, 0) * BlurSize) * weights + tex2D(Sampler, In.Texcoord - float2(positions, 0) * BlurSize) * weights;

	positions = 0.01166667f;
	weights = 0.09364651f;
	Out.Color += tex2D(Sampler, In.Texcoord + float2(positions, 0) * BlurSize) * weights + tex2D(Sampler, In.Texcoord - float2(positions, 0) * BlurSize) * weights;

	positions = 0.01833333f;
	weights = 0.0801001f;
	Out.Color += tex2D(Sampler, In.Texcoord + float2(positions, 0) * BlurSize) * weights + tex2D(Sampler, In.Texcoord - float2(positions, 0) * BlurSize) * weights;

	positions = 0.025f;
	weights = 0.06436224f;
	Out.Color += tex2D(Sampler, In.Texcoord + float2(positions, 0) * BlurSize) * weights + tex2D(Sampler, In.Texcoord - float2(positions, 0) * BlurSize) * weights;

	positions = 0.03166667f;
	weights = 0.04858317f;
	Out.Color += tex2D(Sampler, In.Texcoord + float2(positions, 0) * BlurSize) * weights + tex2D(Sampler, In.Texcoord - float2(positions, 0) * BlurSize) * weights;

	positions = 0.03833333f;
	weights = 0.03445063f;
	Out.Color += tex2D(Sampler, In.Texcoord + float2(positions, 0) * BlurSize) * weights + tex2D(Sampler, In.Texcoord - float2(positions, 0) * BlurSize) * weights;

	positions = 0.045f;
	weights = 0.02294906f;
	Out.Color += tex2D(Sampler, In.Texcoord + float2(positions, 0) * BlurSize) * weights + tex2D(Sampler, In.Texcoord - float2(positions, 0) * BlurSize) * weights;

	return Out;
}
