uniform sampler2D Sampler;

struct PS_IN
{
	float4 Position : POSITION;
	float2 Texcoord : TEXCOORD0;
	float4 ScreenPosition : TEXCOORD1;
};

struct PS_OUT
{
	float4 Color : COLOR0;
	float4 Depth : COLOR1;
};

PS_OUT main (PS_IN In)
{       
	PS_OUT Out;

	Out.Color = tex2D(Sampler, In.Texcoord);
	Out.Depth = In.ScreenPosition.z / In.ScreenPosition.w;

	return Out;
}
