uniform sampler2D Sampler;
uniform samplerCUBE CubeSampler;

struct PS_IN
{
	float4 Position : POSITION;
	float3 Normal : TEXCOORD0;
	float2 Texcoord : TEXCOORD1;

	float3 LightDirection : TEXCOORD2;
	float3 CameraDirection : TEXCOORD3;
};

struct PS_OUT
{
	float4 Color : COLOR;
};

PS_OUT main (PS_IN In)
{       
	PS_OUT Out;

	float3 ndir = normalize(In.Normal);
	float3 ldir = normalize(In.LightDirection);
	float3 vdir = -normalize(In.CameraDirection);

	float dot_val = max(dot(ldir, ndir), 0);
	float4 dif = tex2D(Sampler, In.Texcoord);
	float4 spc = pow(dot(reflect(ldir, ndir), vdir), 2.0f);
	Out.Color = (dif * 0.3f + dif * dot_val + spc)* texCUBE(CubeSampler, normalize(reflect(-vdir, ndir)));

	return Out;
}
