uniform sampler2D Sampler;

struct PS_IN
{
	float4 Position : POSITION;
	float3 Normal : TEXCOORD0;
	float2 Texcoord : TEXCOORD1;
	float4 ScreenPosition : TEXCOORD2;
};

struct PS_OUT
{
	float4 Color : COLOR0;
	float4 Normal : COLOR1;
	float4 Depth : COLOR2;
};

PS_OUT main (PS_IN In)
{       
	PS_OUT Out;

	Out.Color = tex2D(Sampler, In.Texcoord);
	Out.Normal = float4(In.Normal * 0.5f + 0.5f, 1);
	Out.Depth = In.ScreenPosition.z / In.ScreenPosition.w;

	return Out;
}
