uniform float4x4 WorldViewProjection;
uniform float4x4 World;

struct VS_IN
{
	float4 Position : POSITION;
	float3 Normal : NORMAL;
	float2 Texcoord : TEXCOORD0;
};

struct VS_OUT
{
	float4 Position : POSITION;
	float3 Normal : TEXCOORD0;
	float2 Texcoord : TEXCOORD1;
	float4 ScreenPosition : TEXCOORD2;
};

VS_OUT main(VS_IN In)
{
	VS_OUT Out;

	Out.Position = mul(WorldViewProjection, In.Position);
	Out.Normal = mul((float3x3)World, In.Normal);
	Out.Texcoord = float2(In.Texcoord.x, 1.0f - In.Texcoord.y);
	Out.ScreenPosition = Out.Position;

	return Out;
}
