uniform float4x4 World;
uniform sampler2D Sampler;
uniform sampler2D NormalSampler;

struct PS_IN
{
	float4 Position : POSITION;
	float2 Texcoord : TEXCOORD0;

	float3 LightDirection : TEXCOORD1;
	float3 CameraDirection : TEXCOORD2;
};

struct PS_OUT
{
	float4 Color : COLOR;
};

PS_OUT main (PS_IN In)
{       
	PS_OUT Out;

	float3 ndir = normalize(mul((float3x3)World, (tex2D(NormalSampler, In.Texcoord).xyz - 0.5f) * 2.0f));
	float3 ldir = normalize(In.LightDirection);
	float3 vdir = -normalize(In.CameraDirection);

	float dot_val = dot(ldir, ndir);

	float4 dif = tex2D(Sampler, In.Texcoord);

	Out.Color = dif * 0.5f + dif * dot_val + pow(max(dot(reflect(ldir, ndir), vdir), 0), 2.0f);

	return Out;
}
