uniform float4x4 WorldViewProjection;
uniform float4x4 World;
uniform float3 LightPosition;
uniform float3 CameraPosition;

struct VS_IN
{
	float4 Position : POSITION;
	float2 Texcoord : TEXCOORD0;
};

struct VS_OUT
{
	float4 Position : POSITION;
	float2 Texcoord : TEXCOORD0;

	float3 LightDirection : TEXCOORD1;
	float3 CameraDirection : TEXCOORD2;
};

VS_OUT main(VS_IN In)
{
	VS_OUT Out;

	Out.Position = mul(WorldViewProjection, In.Position);
	Out.Texcoord = float2(In.Texcoord.x, 1.0f - In.Texcoord.y);

	float3 pos = mul(World, In.Position).xyz;
	Out.LightDirection = -(pos - LightPosition);
	Out.CameraDirection = pos - CameraPosition;

	return Out;
}
