uniform float4x4 ViewProjection;
uniform float4x4 World;
uniform float3 CameraPosition;
uniform float3 CameraUp;

struct VS_IN
{
	float4 Position : POSITION;
	float2 Texcoord : TEXCOORD0;
};

struct VS_OUT
{
	float4 Position : POSITION;
	float2 Texcoord : TEXCOORD0;
};

VS_OUT main(VS_IN In)
{
	VS_OUT Out;

	float3 center = mul(World, In.Position).xyz;
	float3 eye = center - CameraPosition;
	float3 side = normalize(cross(CameraUp, eye));
	float3 up = normalize(cross(eye, side));
			
	Out.Position = mul(ViewProjection, float4(center + (In.Texcoord.x - 0.5f) * side + (0.5f - In.Texcoord.y) * up, 1.0f));
	Out.Texcoord = In.Texcoord;

	return Out;
}




