uniform float4x4 World;
uniform float4 CutTexcoord; //< LRTB

struct VS_IN
{
	float4 Position : POSITION;
	float2 Texcoord : TEXCOORD0;
};

struct VS_OUT
{
	float4 Position : POSITION;
	float2 Texcoord : TEXCOORD0;
};

VS_OUT main(VS_IN In)
{
	VS_OUT Out;

	const float threshold = 0.5f;
	Out.Position = mul(World, In.Position);
	Out.Texcoord = float2(In.Texcoord.x < threshold ? CutTexcoord.x : CutTexcoord.y, In.Texcoord.y < threshold ? CutTexcoord.w : CutTexcoord.z);

	return Out;
}
