uniform float4x4 WorldViewProjection;

struct VS_IN
{
	float4 Position : POSITION;
	float2 Texcoord : TEXCOORD0;
	float4 Weights : BLENDWEIGHT;
	float4 Indices : BLENDINDICES;
};

struct VS_OUT
{
	float4 Position : POSITION;
	float2 Texcoord : TEXCOORD0;
};

VS_OUT main(VS_IN In)
{
	VS_OUT Out;

	Out.Position = mul(WorldViewProjection, In.Position);
	Out.Texcoord = float2(In.Texcoord.x, 1.0f - In.Texcoord.y);

	return Out;
}
