uniform sampler2D Sampler;
uniform sampler2D ToonSampler;

struct PS_IN
{
	float4 Position : POSITION;
	float3 Normal : TEXCOORD0;
	float2 Texcoord : TEXCOORD1;

	float3 LightDirection : TEXCOORD2;
//	float3 CameraDirection : TEXCOORD3;
};

struct PS_OUT
{
	float4 Color : COLOR;
};

PS_OUT main (PS_IN In)
{       
	PS_OUT Out;

	float3 ndir = normalize(In.Normal);
	float3 ldir = normalize(In.LightDirection);
//	float3 vdir = -normalize(In.CameraDirection);

	Out.Color = tex2D(Sampler, In.Texcoord) * tex2D(ToonSampler, float2(min(max(dot(ldir, ndir), 0.05f), 0.95f), 0.0f));

	return Out;
}
