/*!
$Id: main.cpp 622 2009-12-16 10:10:00Z horino $

eNX`PƕĂꍇ́AXLjOAj[VTv
*/
#include "stdafx.h"

#define MAIN_CPP

#include "indi.h"
#include "graphics/graphics.h"
#include "file/file_manager.h"
#include "input/input.h"
#include "camera/debugcamera.h"
#include "mesh/scenes.h"
#include "mesh/scenes_texture.h"
#include "mesh/animation.h"
#include "graphics/shader/shader.h"
#include "graphics/rendertarget.h"
#include "graphics/framebuffer.h"
#include "timer.h"
#include "debug_stop.h"
using namespace indi;

#ifdef PS3
//#define ROOT "/dev_bdvd/PS3_GAME/USRDIR/"
#define ROOT "/app_home/samples/"
#else
#define ROOT "game:\\"
#endif

//< L[t[Ԃgꍇɂ͒`(VF[_̒`킹Ă)
#define USE_SLERP

/////////////////////////////////////////
//< main()
/////////////////////////////////////////
int main(int argc, char *argv[])
{
	//< 
	System::Initialize(ROOT"media"SEPARATOR);

	//< pbh͗p
	Input input;

	//< J
	DebugCamera camera(Vector3(0.0f, 15.0f, 100.0f), Vector3::Zero(), Vector3::Up(), Matrix44::Perspective(INDI_PI * 0.25f, graphics::System::GetAspectRatio(), 0.1f, 1000.0f));

	//< f
	mesh::ScenesTextureFile *texture(new mesh::ScenesTextureFile("PlayerMarine.tex"));
	//< Aj[Vt@C
	mesh::ScenesFile *model(new mesh::ScenesFile("PlayerMarine.scn"));
	mesh::AnimationMapFile *animation(new mesh::AnimationMapFile("PlayerMarine.amp"));

	//< VF[_
	graphics::shader::VertexProgram *vs(new graphics::shader::VertexProgram("skinning_animation_vs"SH_EXT));
	graphics::shader::PixelProgram *ps(new graphics::shader::PixelProgram("skinning_animation_ps"SH_EXT));

	graphics::System::ClearColor(127, 127, 255);

#ifdef _DEBUG
	//< fobOXgbv
	DebugStop debug_stop;
#endif

	//< Q[[v
	while(1){
		//< 񓯊ǂݍ݂̏
		if(file::FileManager::Get())
			file::FileManager::Get()->Update();

		//< pbh
		input.Update();

		//< fobOJ
		if(input.Current(0).IsValid())
			camera.Control(input.Current(0));
		//< J̍XV
		camera.Update();

#ifdef _DEBUG
		//< fobOXgbv̑
		debug_stop.Control(input.Previous(0), input.Current(0));
#endif

		graphics::System::BeginBackBuffer();{
			
			graphics::System::Clear();

			//< f̕`
			if(vs->IsLoaded() && ps->IsLoaded()){
				graphics::shader::Program::AutoBegin auto_vs(*vs);
				graphics::shader::Program::AutoBegin auto_ps(*ps);

				if(model->IsLoaded() && texture->IsLoaded() && animation->IsLoaded()){
					graphics::shader::Parameter w(vs->GetParameter("World"));
					graphics::shader::Parameter vp(vs->GetParameter("ViewProjection"));
					graphics::shader::Parameter anm_smp(vs->GetParameter("AnimationSampler"));
					graphics::shader::Parameter anm_siz(vs->GetParameter("AnimationSize"));
					graphics::shader::Parameter anm_idx(vs->GetParameter("AnimationIndex"));
#ifdef USE_SLERP
					graphics::shader::Parameter anm_idx_max(vs->GetParameter("AnimationIndexMax"));
					graphics::shader::Parameter anm_ratio(vs->GetParameter("AnimationIndexRatio"));
#endif

					graphics::shader::Parameter smp(ps->GetParameter("Sampler"));
										
					if(texture->GetTextureNum()) {
						vp = camera.ViewProjection();
						anm_siz = animation->GetTextureSize();

						animation->SetClip(static_cast<u32>(0)); //< OԖڂ̃[Vw
						animation->SetController(0); //< ł̓Rg[͂OԂ݂̂̑O

						graphics::shader::Parameter::AutoBeginTexture auto_anm_tex(anm_smp, animation->GetAnimationTexture()); //< Aj[V}bv
						graphics::shader::Parameter::AutoBeginTexture auto_tex(smp, texture->GetTexture(0)); //< f̃eNX`

						//< CfbNXƃEGCg̃f[^VF[_p[^֓n
						//< (VF[_̕ϐ"In.Indices"A"In.Weights"ȊOgĂꍇ͖IɑQARɎw肵Ă)
						model->SetIndexWeight(vs); 

						for(u32 x=0;x<2;++x){
							for(u32 z=0;z<2;++z) {
								w = Matrix44::Translation(x * 30.0f - 30.0f, 0.0f, z * 30.0f - 30.0f) * Matrix44::Scale(2.0f);
								//f32 tm(Timer::ToSecond(AnimationTimer::current); //< ݂̃t[(b)
								f32 tm(Timer::ToSecond((AnimationTimer::current << 1) + x * z * 10)); //< Ƀ[V̎ԍƃXs[hAbvĂ݂
								anm_idx = static_cast<f32>(animation->GetLoopY(tm)); 
#ifdef USE_SLERP
								anm_idx_max = static_cast<f32>(animation->GetMaxY());
								anm_ratio = animation->GetLoopRatio(tm);
#endif
								model->Draw();
							}
						}
					}
				}
			}
			
		} graphics::System::EndBackBuffer();
		graphics::System::SwapBuffers();

#ifdef _DEBUG
		if(!debug_stop.IsStop())
			++AnimationTimer::current;
#else
		++AnimationTimer::current;
#endif
	}

	delete ps;
	delete vs;

	delete animation;

	delete model;
	delete texture;

	System::Finalize();
}
