/*!
$Id: main.cpp 585 2009-12-01 09:50:47Z horino $

XvCgTv
*/
#include "stdafx.h"

#define MAIN_CPP

#include "indi.h"
#include "graphics/graphics.h"
#include "file/file_manager.h"
#include "input/input.h"
#include "camera/debugcamera.h"
#include "graphics/shader/shader.h"
#include "graphics/texture_file.h"
#include "sprite/sprite.h"
#include "primitive/primitive.h"
#include "timer.h"
#include "mesh/scenes.h"
using namespace indi;

#ifdef PS3
//#define ROOT "/dev_bdvd/PS3_GAME/USRDIR/"
#define ROOT "/app_home/samples/"
#else
#define ROOT "game:\\"
#endif

int main(int argc, char *argv[])
{
	//< 
	System::Initialize(ROOT"media"SEPARATOR);

	//< pbh͗p
	Input input;

	//< J
	DebugCamera camera(Vector3(0.0f, 15.0f, 200.0f), Vector3::Zero(), Vector3::Up(), Matrix44::Perspective(INDI_PI * 0.25f, graphics::System::GetAspectRatio(), 10.f, 1000.0f));

	//< XvCg\p̃v[
	primitive::ScreenPlane plane;

	//< f
	mesh::ScenesFile *model(new mesh::ScenesFile("duck.scn"));

	//< XvCgeNX`
	Sprite *sprite(new Sprite("billboard.tex"));
	Sprite *sprite2(new Sprite("duck.tex"));

	//< VF[_
	graphics::shader::VertexProgram *vs(new graphics::shader::VertexProgram("sprite_vs"SH_EXT));
	graphics::shader::PixelProgram *ps(new graphics::shader::PixelProgram("sprite_ps"SH_EXT));
	graphics::shader::VertexProgram *color_vs(new graphics::shader::VertexProgram("color_vs"SH_EXT));
	graphics::shader::PixelProgram *color_ps(new graphics::shader::PixelProgram("color_ps"SH_EXT));

	graphics::System::ClearColor(127, 127, 255);

	//< Q[[v
	while(1){
		//< 񓯊ǂݍ݂̏
		if(file::FileManager::Get())
			file::FileManager::Get()->Update();

		//< pbh
		input.Update();

		//< fobOJ
		if(input.Current(0).IsValid())
			camera.Control(input.Current(0));
		//< J̍XV
		camera.Update();

		f32 radian(math::ToRadian(static_cast<f32>(AnimationTimer::current % 360)));

		graphics::System::BeginBackBuffer(); {
			graphics::System::Clear();

			//< 3Df̕`
			if(color_vs->IsLoaded() && color_ps->IsLoaded()){
				if(model->IsLoaded()){
					graphics::shader::Program::AutoBegin auto_vs(*color_vs);
					graphics::shader::Program::AutoBegin auto_ps(*color_ps);
					color_vs->GetParameter("WorldViewProjection") = Matrix44::Identity() * camera.ViewProjection();
					color_ps->GetParameter("Color") = color::Green;
					model->Draw();
				}
			}

			//< fvXNA
			graphics::System::Clear(graphics::System::DEPTH);

			//< 3DfɎOɃXvCg`
			if(vs->IsLoaded() && ps->IsLoaded()){
				graphics::shader::Program::AutoBegin auto_vs(*vs);
				graphics::shader::Program::AutoBegin auto_ps(*ps);

				graphics::shader::Parameter world(vs->GetParameter("World"));
				graphics::shader::Parameter cuttex(vs->GetParameter("CutTexcoord"));
				graphics::shader::Parameter smp(ps->GetParameter("Sampler"));
				graphics::shader::Parameter alpha(ps->GetParameter("Alpha"));

				//< uhݒ
				graphics::System::Blend::AutoBegin auto_blend;
				graphics::System::Blend::Set(graphics::System::Blend::SRC_ALPHA, graphics::System::Blend::INV_SRC_ALPHA);

				if(sprite->IsLoaded()){
					//< uvXvCg
					graphics::shader::Parameter::AutoBeginTexture auto_tex(smp, sprite);

					//< gK[ŃXvCg̐[xύX
					sprite->SetDepthRatio(math::Min(1.0f - input.Current(0).LeftTriggerf(), 0.9f));

					//< XeBbNŊgk
					sprite->Scale() = Vector2(1.0f + input.Current(0).LeftStickXf() * 0.5f, 1.0f - input.Current(0).LeftStickYf() * 0.5f);

					//< XvCg\̊_ύX
					if(input.Current(0).A()) 
						sprite->Origin() = static_cast<Sprite::SpriteOrigin>(Sprite::Left | Sprite::Top);
					else if(input.Current(0).B())
						sprite->Origin() = static_cast<Sprite::SpriteOrigin>(Sprite::Left | Sprite::Bottom);
					else if(input.Current(0).X())
						sprite->Origin() = static_cast<Sprite::SpriteOrigin>(Sprite::Right | Sprite::Top);
					else if(input.Current(0).Y())
						sprite->Origin() = static_cast<Sprite::SpriteOrigin>(Sprite::Right | Sprite::Bottom);
					else
						sprite->Origin() = static_cast<Sprite::SpriteOrigin>(Sprite::Center | Sprite::Center);

					//< eNX`ł̐؂oʒuύX
					if(input.Current(0).Up()) 
						sprite->CutOrigin() = Vector2(static_cast<f32>(sprite->GetWidth()), static_cast<f32>(sprite->GetHeight())) * 0.2f;
					else if(input.Current(0).Down()) 
						sprite->CutOrigin() = Vector2(static_cast<f32>(sprite->GetWidth()), static_cast<f32>(sprite->GetHeight())) * 0.4f;
					else if(input.Current(0).Left()) 
						sprite->CutOrigin() = Vector2(static_cast<f32>(sprite->GetWidth()), static_cast<f32>(sprite->GetHeight())) * 0.6f;
					else if(input.Current(0).Right()) 
						sprite->CutOrigin() = Vector2(static_cast<f32>(sprite->GetWidth()), static_cast<f32>(sprite->GetHeight())) * 0.8f;
					else 
						sprite->CutOrigin() = Vector2::Zero();
					sprite->CutSize() = Vector2(static_cast<f32>(sprite->GetWidth()), static_cast<f32>(sprite->GetHeight())) - sprite->CutOrigin();
					cuttex = sprite->GetTexcoord();

					//sprite->SetPositionRatio(0.0f, 0.0f);
					sprite->SetPositionRatio(0, 0);
					world = sprite->GetMatrix();
					alpha = sprite->Alpha();
					plane.Begin(); plane.Draw(); plane.End();

					//sprite->SetPositionRatio(1.0f, 0.0f);
					sprite->SetPosition(graphics::System::GetScreenWidth(), 0);
					world = sprite->GetMatrix();
					alpha = sprite->Alpha();
					plane.Begin(); plane.Draw(); plane.End();

					//sprite->SetPositionRatio(0.0f, 1.0f);
					sprite->SetPosition(0, graphics::System::GetScreenHeight());
					world = sprite->GetMatrix();
					alpha = sprite->Alpha();
					plane.Begin(); plane.Draw(); plane.End();

					//sprite->SetPositionRatio(1.0f, 1.0f);
					sprite->SetPosition(graphics::System::GetScreenWidth(), graphics::System::GetScreenHeight());
					world = sprite->GetMatrix();
					alpha = sprite->Alpha();
					plane.Begin(); plane.Draw(); plane.End();

					//sprite->SetPositionRatio(0.5f, 0.5f);
					sprite->SetPosition(graphics::System::GetScreenWidth() >> 1, graphics::System::GetScreenHeight() >> 1);
					world = sprite->GetMatrix();
					alpha = sprite->Alpha();
					plane.Begin(); plane.Draw(); plane.End();
				}

				//< ЂeNX`XvCg
				if(sprite2->IsLoaded()){
					graphics::shader::Parameter::AutoBeginTexture auto_tex(smp, sprite2);

					sprite2->SetPosition(graphics::System::GetScreenWidth() >> 1, graphics::System::GetScreenHeight() >> 1);

					//< gK[ŃXvCg̐[xύX
					sprite2->SetDepthRatio(math::Min(input.Current(0).LeftTriggerf(), 0.9f));

					//< XeBbNŊgk
					sprite2->Scale() = Vector2(1.0f + input.Current(0).LeftStickXf() * 0.5f, 1.0f - input.Current(0).LeftStickYf() * 0.5f);

					//< XvCg\̊_ύX
					if(input.Current(0).A())
						sprite2->Origin() = static_cast<Sprite::SpriteOrigin>(Sprite::Left | Sprite::Top);
					else if(input.Current(0).B())
						sprite2->Origin() = static_cast<Sprite::SpriteOrigin>(Sprite::Left | Sprite::Bottom);
					else if(input.Current(0).X())
						sprite2->Origin() = static_cast<Sprite::SpriteOrigin>(Sprite::Right | Sprite::Top);
					else if(input.Current(0).Y())
						sprite2->Origin() = static_cast<Sprite::SpriteOrigin>(Sprite::Right | Sprite::Bottom);
					else
						sprite2->Origin() = static_cast<Sprite::SpriteOrigin>(Sprite::Center | Sprite::Center);
					sprite2->CutSize() = Vector2(static_cast<f32>(sprite2->GetWidth()), static_cast<f32>(sprite2->GetHeight()));

					//< XvCg̉]
					sprite2->Rotation() = radian;

					//< XvCg̓x
					sprite2->Alpha() = input.Current(0).RightStick().Y() * 0.5f + 0.5f;

					cuttex = sprite2->GetTexcoord();
					world = sprite2->GetMatrix();
					alpha = sprite2->Alpha();
					plane.Begin(); plane.Draw(); plane.End();
				}
			}
		} graphics::System::EndBackBuffer();
		graphics::System::SwapBuffers();

		++AnimationTimer::current;
	}

	delete color_ps;
	delete color_vs;

	delete ps;
	delete vs;

	delete sprite;
	delete sprite2;

	delete model;

	System::Finalize();
}
