/*!
$Id: main.cpp 536 2009-11-20 02:57:07Z horino $

eNX`PƕĂꍇ́AeNX`̃f`B
f͈ŁAeX̃m[hItZbgȂǂȂOB

*/
#include "stdafx.h"

#define MAIN_CPP

#include "indi.h"
#include "graphics/graphics.h"
#include "file/file_manager.h"
#include "input/input.h"
#include "camera/debugcamera.h"
#include "mesh/scenes.h"
#include "mesh/scenes_texture.h"
#include "graphics/shader/shader.h"
#include "primitive/primitive.h"
#include "graphics/rendertarget.h"
#include "graphics/framebuffer.h"
using namespace indi;

#ifdef PS3
//#define ROOT "/dev_bdvd/PS3_GAME/USRDIR/"
#define ROOT "/app_home/samples/"
#else
#define ROOT "game:\\"
#endif

int main(int argc, char *argv[])
{
	//< 
	System::Initialize(ROOT"media"SEPARATOR);

	//< pbh͗p
	Input input;

	//< J
	DebugCamera camera(Vector3(0.0f, 15.0f, 200.0f), Vector3::Zero(), Vector3::Up(), Matrix44::Perspective(INDI_PI * 0.25f, graphics::System::GetAspectRatio(), 10.f, 1000.0f));

	//< eNX`fobO\p̃v[
	primitive::ScreenPlane plane;

	//< f
	mesh::ScenesTextureFile *texture(new mesh::ScenesTextureFile("duck.tex"));
	mesh::ScenesFile *model(new mesh::ScenesFile("duck.scn"));

	//< VF[_
	graphics::shader::VertexProgram *vs(new graphics::shader::VertexProgram("textured_vs"SH_EXT));
	graphics::shader::PixelProgram *ps(new graphics::shader::PixelProgram("textured_ps"SH_EXT));

	graphics::System::ClearColor(127, 127, 255);

	//< Q[[v
	while(1){
		//< 񓯊ǂݍ݂̏
		if(file::FileManager::Get())
			file::FileManager::Get()->Update();

		//< pbh
		input.Update();

		//< fobOJ
		if(input.Current(0).IsValid())
			camera.Control(input.Current(0));
		//< J̍XV
		camera.Update();

		graphics::System::BeginBackBuffer();{

			graphics::System::Clear();

			//< VF[_ǂݍ݊ĂȂƂ`͂łȂ
			if(vs->IsLoaded() && ps->IsLoaded()){

				//< ̃fgĂeNX`wiɕ\Ă݂
				if(texture->IsLoaded()){
					f32 sq(math::Sqrt(static_cast<f32>(texture->GetTextureNum())));
					u32 col(static_cast<u32>(sq) + (sq > static_cast<f32>(static_cast<u32>(sq)) ? 1 : 0));
					f32 ratio(1.0f / static_cast<f32>(col));

					graphics::System::DepthWrite(FALSE);{
						graphics::shader::Program::AutoBegin auto_vs(*vs);
						graphics::shader::Program::AutoBegin auto_psinPS(*ps);

						graphics::shader::Parameter wvp(vs->GetParameter("WorldViewProjection"));
						graphics::shader::Parameter smp(ps->GetParameter("Sampler"));
						for(u32 i=0;i<texture->GetTextureNum();++i) {
							wvp = Matrix44::Scale(ratio * 0.9f) * Matrix44::Translation((i % col) * ratio * 2.0f - (1.0f - ratio), -((i / col) * ratio * 2.0f - (1.0f - ratio)), 0);
							graphics::shader::Parameter::AutoBeginTexture auto_tex(smp, texture->GetTexture(i));

							plane.Begin();{
								plane.Draw();
							} plane.End();							
						}	
					} graphics::System::DepthWrite(TRUE);
				}

				//< fƃeNX`ǂݍ܂ĂΕ`
				if(model->IsLoaded() && texture->IsLoaded()){
					graphics::shader::Program::AutoBegin auto_vs(*vs);
					graphics::shader::Program::AutoBegin auto_ps(*ps);

					//< {͖t[Ŏ擾̂͗ǂȂ(Tvł͉ǐd)
					graphics::shader::Parameter wvp(vs->GetParameter("WorldViewProjection"));
					graphics::shader::Parameter smp(ps->GetParameter("Sampler"));
					if(texture->GetTextureNum()) {
						wvp = Matrix44::Identity() * camera.ViewProjection();
						graphics::shader::Parameter::AutoBeginTexture auto_tex(smp, texture->GetTexture(0));

						model->Draw();
					}
				}
			}

		} graphics::System::EndBackBuffer();
		graphics::System::SwapBuffers();
	}

	delete ps;
	delete vs;

	delete model;
	delete texture;

	System::Finalize();
}
