/*!
$Id: main.cpp 595 2009-12-04 10:17:01Z horino $

̃eNX`f

EbṼgCAOɃeNX`ʂɎw肳ĂꍇȂǂɑΉ
Em[hItZbgĂꍇ(GetTransform())ɑΉ
*/
#include "stdafx.h"

#define MAIN_CPP

#include "indi.h"
#include "graphics/graphics.h"
#include "file/file_manager.h"
#include "input/input.h"
#include "camera/debugcamera.h"
#include "mesh/scenes.h"
#include "mesh/scenes_texture.h"
#include "graphics/shader/shader.h"
#include "primitive/primitive.h"
#include "graphics/rendertarget.h"
#include "graphics/framebuffer.h"
using namespace indi;

#ifdef PS3
//#define ROOT "/dev_bdvd/PS3_GAME/USRDIR/"
#define ROOT "/app_home/samples/"
#else
#define ROOT "game:\\"
#endif

/*!
\brief f̕`@JX^}CY邽߁AepăI[o[Ch܂
*/

//< Geometry : ǂ̃eNX`g̏Ă̂ŃI[o[ChKv܂
class MyGeometry : public mesh::Geometry
{
public:
	MyGeometry(mesh::Node *p) : mesh::Geometry(p), _texture(0), _pixel_shader(0) {}
	virtual ~MyGeometry() {}

	//< Draw()I[o[Ch
	void Draw() const 
	{
		const mesh::Mesh *mesh(GetMesh());
		if(mesh) {
			//< gCAO̕
			u32 ntri(mesh->GetTriangleNum());
			for(u32 i=0;i<ntri;++i){
				const mesh::Triangle *tri(mesh->GetTriangle(i));
				if(tri){
					//< gCAO̕`Ɏgp}eACfbNX  }eA擾
					u32 mate_idx(tri->GetMaterialIndex());
					const mesh::Material *mate(GetMaterial(mate_idx));
					if(mate){
						//< vt@C擾(ProfileCommon̂)
						const mesh::Profile *prof(mate->GetProfile());
						if(prof){
							switch(prof->GetProfileType()){
                            case mesh::ProfileCommon:
								{
									const mesh::Common *cmn(static_cast<const mesh::Common *>(prof));
									//< VF[fBO^Cv擾A(Tv)łPhonĝݑΉ
									switch(cmn->GetShader()->GetShaderType()){
							        case mesh::PhongShader:
										{
											const mesh::Phong *png(static_cast<const mesh::Phong *>(cmn->GetShader()));
											if(png){
												//< iTvjłDiffuseɃeNX`ATCĂP[X݂̂Ώ
												if(png->GetDiffuse().IsTexture()){
													//< eNX`CfbNX擾
													u32 tex_idx(png->GetDiffuse().GetTextureIndex());
													//< VF[_փeNX`n܂
													if(_texture) {
														if(_pixel_shader && _pixel_shader->IsLoaded()){
															graphics::shader::Parameter smp(_pixel_shader->GetParameter("Sampler"));
															graphics::shader::Parameter::AutoBeginTexture auto_tex(smp, _texture->GetTexture(tex_idx));

															tri->Draw();
														}
													}
												}
											}
										}
										break;
									default: ASSERT(0); break; //< (Tv)ł͑ΉȂ
									}
								}
								break;
							default: ASSERT(0); break; //< (Tv)ł͑ΉȂ
							}
						}
					}
				}
			}
		}
	}
	//< ÕeNX`ݒ֐
	void MySetTexture(mesh::ScenesTextureFile *t) { _texture = t; }
	//< ÕsNZVF[_ݒ֐
	void MySetPixelShader(graphics::shader::PixelProgram *p){ _pixel_shader = p; }
private:
	mesh::ScenesTextureFile *_texture;
	graphics::shader::PixelProgram *_pixel_shader;
};

//< Node : m[h̃ItZbgݒA`}gNXݒAʃNXGeometryJX^}CY邽߂ɃI[o[ChKv܂
class MyNode : public mesh::Node
{
public:
	MyNode(mesh::Node *p) : mesh::Node(p), _vertex_shader(0), _view_projection(0) {}
	virtual ~MyNode() {}

	mesh::Geometry *GeometryCreator(mesh::Node *p = 0) const { return new MyGeometry(p); } //< ̃NXg悤ɃI[o[Ch
	mesh::Node *NodeCreator(mesh::Node *p = 0) const { return new MyNode(p); } //< ̃NXg悤ɃI[o[Ch

	//< Draw()I[o[Ch
	void Draw() const
	{
		if(_vertex_shader && _vertex_shader->IsLoaded()){
			//< VF[_̐ݒ܂
			graphics::shader::Parameter wvp(_vertex_shader->GetParameter("WorldViewProjection"));
			if(_view_projection){
				//< ]Ă̂͒PɃf̌␳AGetTransform()̓m[hItZbgĂꍇւ̑Ή
				wvp = GetTransform() * Matrix44::RotationX(INDI_PI * 1.5f) * (*_view_projection);

				//< DrawR[܂
				mesh::Node::Draw();
			}
		}
	}

	//< ÕeNX`ݒ֐
	void MySetTexture(mesh::ScenesTextureFile *t) {
		for(u32 i=0;i<GetNodeNum();++i)
			static_cast<MyNode *>(GetNode(i))->MySetTexture(t);
		for(u32 i=0;i<GetGeometryNum();++i)
			static_cast<MyGeometry *>(GetGeometry(i))->MySetTexture(t);
	}
	//< Õo[ebNXVF[_ݒ֐
	void MySetVertexShader(graphics::shader::VertexProgram *v){
		_vertex_shader = v;
		for(u32 i=0;i<GetNodeNum();++i)
			static_cast<MyNode *>(GetNode(i))->MySetVertexShader(v);
	}
	//< ÕsNZVF[_ݒ֐
	void MySetPixelShader(graphics::shader::PixelProgram *p){
		for(u32 i=0;i<GetNodeNum();++i)
			static_cast<MyNode *>(GetNode(i))->MySetPixelShader(p);
		for(u32 i=0;i<GetGeometryNum();++i)
			static_cast<MyGeometry *>(GetGeometry(i))->MySetPixelShader(p);
	}
	//< OViewProjectionݒ֐
	void MySetViewProjection(Matrix44 *vp){
		_view_projection = vp;
		for(u32 i=0;i<GetNodeNum();++i)
			static_cast<MyNode *>(GetNode(i))->MySetViewProjection(vp);
	}
private:
	graphics::shader::VertexProgram *_vertex_shader;
	Matrix44 *_view_projection;
};

//< Scene : ʃNXNodeGeometryJX^}CY邽߂ɃI[o[ChKv܂
class MyScene : public mesh::Scene
{
public:
	MyScene() : mesh::Scene() {}
	virtual ~MyScene() {}

	mesh::Node *NodeCreator(mesh::Node *p = 0) const { return new MyNode(p); } //< ̃NXg悤ɃI[o[Ch

	//< ÕeNX`ݒ֐
	void MySetTexture(mesh::ScenesTextureFile *t) {
		for(u32 i=0;i<GetNodeNum();++i)
			static_cast<MyNode *>(GetNode(i))->MySetTexture(t);
	}
	//< Õo[ebNXVF[_ݒ֐
	void MySetVertexShader(graphics::shader::VertexProgram *v){
		for(u32 i=0;i<GetNodeNum();++i)
			static_cast<MyNode *>(GetNode(i))->MySetVertexShader(v);
	}
	//< ÕsNZVF[_ݒ֐
	void MySetPixelShader(graphics::shader::PixelProgram *p){
		for(u32 i=0;i<GetNodeNum();++i)
			static_cast<MyNode *>(GetNode(i))->MySetPixelShader(p);
	}
	//< OViewProjectionݒ֐
	void MySetViewProjection(Matrix44 *vp){
		for(u32 i=0;i<GetNodeNum();++i)
			static_cast<MyNode *>(GetNode(i))->MySetViewProjection(vp);
	}
};

//< ScenesFile : ʃNXSceneNodeGeometryJX^}CY邽߂ɃI[o[ChKv܂
class MyScenesFile : public mesh::ScenesFile
{
public:
	MyScenesFile(const char *path) : mesh::ScenesFile(path) {}
	virtual ~MyScenesFile() {}

	mesh::Scene *SceneCreator() const { return new MyScene(); } //< ̃NXg悤ɃI[o[Ch

	//< ÕeNX`ݒ֐
	void MySetTexture(mesh::ScenesTextureFile *t){
		for(u32 i=0;i<GetSceneNum();++i)
			static_cast<MyScene *>(GetScene(i))->MySetTexture(t);
	}
	//< Õo[ebNXVF[_ݒ֐
	void MySetVertexShader(graphics::shader::VertexProgram *v){
		for(u32 i=0;i<GetSceneNum();++i)
			static_cast<MyScene *>(GetScene(i))->MySetVertexShader(v);
	}
	//< ÕsNZVF[_ݒ֐
	void MySetPixelShader(graphics::shader::PixelProgram *p){
		for(u32 i=0;i<GetSceneNum();++i)
			static_cast<MyScene *>(GetScene(i))->MySetPixelShader(p);
	}
	//< OViewProjectionݒ֐
	void MySetViewProjection(Matrix44 *vp){
		for(u32 i=0;i<GetSceneNum();++i)
			static_cast<MyScene *>(GetScene(i))->MySetViewProjection(vp);
	}
};


/////////////////////////////////////////
//< main()
/////////////////////////////////////////
int main(int argc, char *argv[])
{
	//< 
	System::Initialize(ROOT"media"SEPARATOR);

	//< pbh͗p
	Input input;

	//< J
	DebugCamera camera(Vector3(0.0f, 15.0f, 50.0f), Vector3::Zero(), Vector3::Up(), Matrix44::Perspective(INDI_PI * 0.25f, graphics::System::GetAspectRatio(), 10.f, 1000.0f));

	//< eNX`fobO\p̃v[
	primitive::ScreenPlane plane;

	//< f
	mesh::ScenesTextureFile *texture(new mesh::ScenesTextureFile("TNT_B00.tex"));
	MyScenesFile *model(new MyScenesFile("TNT_B00.scn"));

	//< VF[_
	graphics::shader::VertexProgram *vs(new graphics::shader::VertexProgram("textured_vs"SH_EXT));
	graphics::shader::PixelProgram *ps(new graphics::shader::PixelProgram("textured_ps"SH_EXT));

	graphics::System::ClearColor(127, 127, 255);

	//< Q[[v
	while(1){
		//< 񓯊ǂݍ݂̏
		if(file::FileManager::Get())
			file::FileManager::Get()->Update();

		//< pbh
		input.Update();

		//< fobOJ
		if(input.Current(0).IsValid())
			camera.Control(input.Current(0));
		//< J̍XV
		camera.Update();

		graphics::System::BeginBackBuffer();{

			graphics::System::Clear();

			//< VF[_ǂݍ݊ĂȂƂ`͂łȂ
			if(vs->IsLoaded() && ps->IsLoaded()){

				//< ̃fgĂeNX`wiɕ\Ă݂
				if(texture->IsLoaded()){
					f32 sq(math::Sqrt(static_cast<f32>(texture->GetTextureNum())));
					u32 col(static_cast<u32>(sq) + (sq > static_cast<f32>(static_cast<u32>(sq)) ? 1 : 0));
					f32 ratio(1.0f / static_cast<f32>(col));

					graphics::System::DepthWrite(FALSE);{
						graphics::shader::Program::AutoBegin auto_vs(*vs);
						graphics::shader::Program::AutoBegin auto_psinPS(*ps);

						graphics::shader::Parameter wvp(vs->GetParameter("WorldViewProjection"));
						graphics::shader::Parameter smp(ps->GetParameter("Sampler"));
						for(u32 i=0;i<texture->GetTextureNum();++i) {
							wvp = Matrix44::Scale(ratio * 0.9f) * Matrix44::Translation((i % col) * ratio * 2.0f - (1.0f - ratio), -((i / col) * ratio * 2.0f - (1.0f - ratio)), 0);
							graphics::shader::Parameter::AutoBeginTexture auto_tex(smp, texture->GetTexture(i));

							plane.Begin();{
								plane.Draw();
							} plane.End();							
						}	
					} graphics::System::DepthWrite(TRUE);
				}

				{
					//< uhݒ
					graphics::System::Blend::AutoBegin auto_blend;
					graphics::System::Blend::Set(graphics::System::Blend::SRC_ALPHA, graphics::System::Blend::INV_SRC_ALPHA);

					//< f̕`
					if(model->IsLoaded() && texture->IsLoaded()){
						//< f`ɕKvƂœnĂ
						model->MySetViewProjection(&camera.ViewProjection());
						model->MySetTexture(texture);
						model->MySetVertexShader(vs);
						model->MySetPixelShader(ps);

						graphics::shader::Program::AutoBegin auto_vs(*vs);
						graphics::shader::Program::AutoBegin auto_ps(*ps);

						model->Draw();
					}
				}
			}

		} graphics::System::EndBackBuffer();
		graphics::System::SwapBuffers();
	}

	delete ps;
	delete vs;

	delete model;
	delete texture;

	System::Finalize();
}
