/*!
$Id: main.cpp 558 2009-11-26 07:21:40Z horino $

gD[VF[fBOTv
(gD[Kp̃eNX`pӂÃeNX`VF[_ŎQƂȂ`悵܂j
*/
#include "stdafx.h"

#define MAIN_CPP

#include "indi.h"
#include "graphics/graphics.h"
#include "file/file_manager.h"
#include "input/input.h"
#include "camera/debugcamera.h"
#include "mesh/scenes.h"
#include "mesh/scenes_texture.h"
#include "graphics/shader/shader.h"
#include "graphics/texture_file.h"
#include "primitive/primitive.h"
#include "graphics/rendertarget.h"
#include "graphics/framebuffer.h"
#include "timer.h"
using namespace indi;

#ifdef PS3
//#define ROOT "/dev_bdvd/PS3_GAME/USRDIR/"
#define ROOT "/app_home/samples/"
#else
#define ROOT "game:\\"
#endif

int main(int argc, char *argv[])
{
	//< 
	System::Initialize(ROOT"media"SEPARATOR);

	//< pbh͗p
	Input input;

	//< J
	DebugCamera camera(Vector3(0.0f, 15.0f, 200.0f), Vector3::Zero(), Vector3::Up(), Matrix44::Perspective(INDI_PI * 0.25f, graphics::System::GetAspectRatio(), 50.0f, 1000.0f));

	//< f
	mesh::ScenesTextureFile *texture(new mesh::ScenesTextureFile("duck.tex"));
	mesh::ScenesFile *model(new mesh::ScenesFile("duck.scn"));

//	mesh::ScenesTextureFile *texture(new mesh::ScenesTextureFile("dude.tex"));
//	mesh::ScenesFile *model(new mesh::ScenesFile("dude.scn"));

//	mesh::ScenesTextureFile *texture(new mesh::ScenesTextureFile("EnemyBeast.tex"));
//	mesh::ScenesFile *model(new mesh::ScenesFile("EnemyBeast.scn"));

//	mesh::ScenesTextureFile *texture(new mesh::ScenesTextureFile("PlayerMarine.tex"));
//	mesh::ScenesFile *model(new mesh::ScenesFile("PlayerMarine.scn"));

	//< gD[eNX`
	graphics::TextureFile *toon_texture(new graphics::TextureFile("toon.tex"));

	//< VF[_
	graphics::shader::VertexProgram *vs(new graphics::shader::VertexProgram("toon_vs"SH_EXT));
	graphics::shader::PixelProgram *ps(new graphics::shader::PixelProgram("toon_ps"SH_EXT));

	graphics::System::ClearColor(127, 127, 255);

	//< Q[[v
	while(1){
		//< 񓯊ǂݍ݂̏
		if(file::FileManager::Get())
			file::FileManager::Get()->Update();

		//< pbh
		input.Update();

		//< fobOJ
		if(input.Current(0).IsValid())
			camera.Control(input.Current(0));
		//< J̍XV
		camera.Update();

		//< Cg̈ʒu
		f32 radian(math::ToRadian(static_cast<f32>(AnimationTimer::current % 360)));
		Vector3 light_pos(Quaternion::RotationY(radian).Rotate(Vector3(250.0f, 150.0f, 0.0f))); 

		graphics::System::BeginBackBuffer();{

			graphics::System::Clear();

			//< VF[_ǂݍ݊ĂȂƂ`͂łȂ
			if(vs->IsLoaded() && ps->IsLoaded()){

				//< fƃeNX`ǂݍ܂ĂΕ`
				if(model->IsLoaded() && texture->IsLoaded() && toon_texture->IsLoaded()){
					graphics::shader::Program::AutoBegin auto_vs(*vs);
					graphics::shader::Program::AutoBegin auto_ps(*ps);

					//< {͖t[Ŏ擾̂͗ǂȂ(Tvł͉ǐd)
					graphics::shader::Parameter wvp(vs->GetParameter("WorldViewProjection"));
					graphics::shader::Parameter world(vs->GetParameter("World"));
					graphics::shader::Parameter light(vs->GetParameter("LightPosition"));
//					graphics::shader::Parameter cam(vs->GetParameter("CameraPosition"));
					graphics::shader::Parameter smp(ps->GetParameter("Sampler"));
					graphics::shader::Parameter tsmp(ps->GetParameter("ToonSampler"));
					if(texture->GetTextureNum()) {
						wvp = Matrix44::Identity() * camera.ViewProjection();
						world = Matrix44::Identity();
						light = light_pos;
//						cam = camera.Position();
						graphics::shader::Parameter::AutoBeginTexture auto_tex(smp, texture->GetTexture(0));
						graphics::shader::Parameter::AutoBeginTexture auto_toon_tex(tsmp, toon_texture);

						model->Draw();
					}
				}
			}

		} graphics::System::EndBackBuffer();
		graphics::System::SwapBuffers();

		++AnimationTimer::current;
	}

	delete ps;
	delete vs;

	delete toon_texture;

	delete model;
	delete texture;

	System::Finalize();
}
