/*!
$Id: main.cpp 632 2009-12-22 06:51:16Z horino $

XN[W烏[hW߂Tv
*/
#include "stdafx.h"

#define MAIN_CPP

#include "indi.h"
#include "file/file_manager.h"
#include "graphics/graphics.h"
#include "input/input.h"
#include "camera/debugcamera.h"
#include "graphics/shader/shader.h"
#include "primitive/primitive.h"
#include "mesh/scenes.h"
#include "colors.h"
#include "timer.h"
#include "collision/collision.h"
#include "itl/vector.h"
using namespace indi;

#ifdef PS3
//#define ROOT "/dev_bdvd/PS3_GAME/USRDIR/"
#define ROOT "/app_home/samples/"
#else
#define ROOT "game:\\"
#endif

/////////////////////////////////////////
//< main()
/////////////////////////////////////////
int main(int argc, char *argv[])
{
	//< 
	System::Initialize(ROOT"media"SEPARATOR);

	//< pbh͗p
	Input input;

	//< f(AABBt)
	mesh::ScenesAABBFile *model(new mesh::ScenesAABBFile("duck.scn"));
//	mesh::ScenesAABBFile *model(new mesh::ScenesAABBFile("TNT_B00.scn"));

	//< J(jAAt@[̂͗ǂȂ)
	DebugCamera camera(Vector3(0.0f, 0.0f, 50.0f), Vector3::Zero(), Vector3::Up(), Matrix44::Perspective(INDI_PI * 0.25f, graphics::System::GetAspectRatio(), 0.1f, 100.0f));

	//< VF[_
	graphics::shader::VertexProgram *vs(new graphics::shader::VertexProgram("color_vs"SH_EXT));
	graphics::shader::PixelProgram *ps(new graphics::shader::PixelProgram("color_ps"SH_EXT));

	graphics::System::ClearColor(127, 127, 255);

	//< {bNX
	primitive::Box box;
	primitive::WireBox wire_box;

	Vector2 cursor = Vector2(static_cast<f32>(graphics::System::GetScreenWidth()) * 0.5f, static_cast<f32>(graphics::System::GetScreenHeight()) * 0.5f);

	//< Q[[v
	while(1){
		//< 񓯊ǂݍ݂̏
		if(file::FileManager::Get())
			file::FileManager::Get()->Update();

		//< pbh
		input.Update();
		
#if 0
		//< fobOJ
		if(input.Current(0).IsValid())
			camera.Control(input.Current(0));
#else
		//< ]J
		camera.Position() = Quaternion(Vector3::UnitY(), math::ToRadian(static_cast<f32>((AnimationTimer::current >> 1) % 360))).Rotate(Vector3::UnitZ() * 50.0f);
#endif

		//< J̍XV
		camera.Update();

		//< XN[WJ[\̈ړ
		if(input.Current(0).IsValid()) {
			f32 speed(2.0f);
			cursor = Vector2(math::Clamp(cursor.X() + input.Current(0).LeftStick().X() * speed, 0.0f, static_cast<f32>(graphics::System::GetScreenWidth())),
				math::Clamp(cursor.Y() - input.Current(0).LeftStick().Y() * speed, 0.0f, static_cast<f32>(graphics::System::GetScreenHeight())));
		}

		graphics::System::BeginBackBuffer();{
			
			graphics::System::Clear();

			if(vs->IsLoaded() && ps->IsLoaded()){
				graphics::shader::Program::AutoBegin auto_vs(*vs);
				graphics::shader::Program::AutoBegin auto_ps(*ps);

				//< Aƃt@[̃[hW߂				
				Vector3 n(graphics::System::UnProject(Vector3(cursor, 0.0f), Matrix44::Identity(), camera.View(), camera.Projection())); //< Ã[hW߂
				Vector3 f(graphics::System::UnProject(Vector3(cursor, 1.0f), Matrix44::Identity(), camera.View(), camera.Projection())); //< t@[̃[hW߂
				Vector3 dif(f - n);

				//< A  t@[̊Ԃ⊮Ȃ{bNXPO`(J[\\j
				u32 num(10);
				f32 r(1.0f / static_cast<f32>(num));
				for(u32 i=0;i<=num;++i){
					f32 ratio(r * static_cast<f32>(i));
					Vector3 p(f - static_cast<f32>(i) * dif * r);
					f32 invscl(5.0f * math::Pow(1.0f - ratio, 2.0f)); //< ̓sÂ̒傫\悤
					vs->GetParameter("WorldViewProjection") = Matrix44::Scale(invscl, invscl, invscl) * Matrix44::Translation(p) * camera.ViewProjection();
					ps->GetParameter("Color") = Vector4(static_cast<f32>(i) * r, static_cast<f32>(i) * r, static_cast<f32>(i) * r, 1.0f);
					box.Begin();{box.Draw();} box.End();
				}

				if(model->IsLoaded()){
					graphics::shader::Parameter wvp(vs->GetParameter("WorldViewProjection"));
					graphics::shader::Parameter col(ps->GetParameter("Color"));

#define NUM 4
					f32 offset(10.0f);
					f32 scale(0.05f);

					itl::Vector<f32, NUM * NUM> collides;
					f32 best_t(LIM_MAX(f32));
					//< bVAABBƁAÃt@[񂾐Ƃ̃RW
					for(u32 y=0;y<NUM;++y) {
						for(u32 x=0;x<NUM;++x) {
							Vector3 pos(static_cast<f32>(x) - static_cast<f32>(NUM) * 0.5f, static_cast<f32>(y) - static_cast<f32>(NUM) * 0.5f, 0.0f);
							pos *= offset;

							//< AABBƐ̃RWił͈ԋ߂̂o邽߁AՓ˃p[^(t)߂o[Wg܂j
							f32 t;
							if(Collision::Detection::AABBSegment(model->Center() * scale + pos, model->Radius() * scale, n, f, &t)) {
								collides.push_back(t);
								best_t = math::Min(best_t, t); //< ti0.0fɋ߂jAɋ߂
							} else
								collides.push_back(-1.0f); //< Փ˂ĂȂƂ-1.0fɂĂ
						}
					}

					//< `
					for(u32 y=0;y<NUM;++y) {
						for(u32 x=0;x<NUM;++x) {
							Vector3 pos(static_cast<f32>(x) - static_cast<f32>(NUM) * 0.5f, static_cast<f32>(y) - static_cast<f32>(NUM) * 0.5f, 0.0f);
							pos *= offset;

							//< Փ˂Ăꍇ(-1.0fłȂ)͉Fŕ\
							col = color::Green;
							if(collides[y * NUM + x] >= 0.0f) {
								col = color::Yellow;
								//< Ƃ߂(best_tɈv)͐Ԃŕ\
								if(best_t == collides[y * NUM + x])
									col = color::Red;
							}

							//< 3Df`
							Matrix44 tr(Matrix44::Scale(scale) * Matrix44::Translation(pos));
							wvp = tr * camera.ViewProjection();
							model->Draw();

							//< AABB\
							wvp = Matrix44::Scale(model->Radius() * 2.0f) * Matrix44::Translation(model->Center()) * tr * camera.ViewProjection();
							wire_box.Begin(); wire_box.Draw(); wire_box.End();
						}
					}
				}
			}
		} graphics::System::EndBackBuffer();
		graphics::System::SwapBuffers();

		++AnimationTimer::current;
	}

	delete ps;
	delete vs;

	delete model;

	System::Finalize();
}
