/*!
$Id: file.h 623 2009-12-17 04:07:13Z horino $
*/
#ifndef FILE_H
#define FILE_H

#include "typedefs.h"
#include "utilities.h"

namespace indi
{
	namespace file
	{
		/*!
		\brief t@C񓯊ǂݍ݃NX
		\note pĎgĂ
		*/
		class File
		{
		public:
			friend class FileManager;

			File() : _size(0), _data(0), _index(0xffffffff), _file_handle(0), _thread_handle(0), _status(NoRequest) {}
			File(const char *path) : _size(0), _data(0) { Open(path); Load(); }
			virtual ~File();

			void Open(const char *path);
			void Close();
			void Load();
			void Release() { if(_data) { delete [] _data; _data = 0; } }

			/*!
			\brief ǂݍ݂ƂɃR[obN܂
			\note pNXŎRɎĂ
			*/
			virtual void OnLoaded() = 0;

			/*!
			\brief ǂݍ݂̏
			\retval ܂ǂݍ݃NGXgoĂȂ TRUE
			\retval ǂݍ݂Ă鎞 TRUE
			\retval NGXgoāA܂ǂݍ݊ĂȂ FALSE
			*/
			BOOL IsLoaded() const { return _status == Loaded; }

			u32 GetSize() { return _size; }
			const u8 *GetData() const { return _data; }

			HANDLE GetFileHandle() { return _file_handle; }
			u32 &GetIndex() { return _index; }
			u8 &GetStatus() { return _status; }

			enum {
				NoRequest,
				Callbacked,
				Loaded,
			};

#ifdef _DEBUG
			char _file_name[64];
#endif
		protected:
			u32 _size;
			u8 *_data;
			u32 _index;
			HANDLE _file_handle;
			HANDLE _thread_handle;
			u8 _status;
		};
	}
}

#endif // FILE_H