/*!
$Id: texture_file.h 623 2009-12-17 04:07:13Z horino $
*/
#ifndef TEXTURE_FILE_H
#define TEXTURE_FILE_H

#ifdef _DEBUG
#include <iostream>
using namespace std;
#endif

#include "graphics/texture.h"
#include "file/file.h"

namespace indi
{
	namespace graphics
	{
		/*!
		\brief 񓯊eNX`NX
		\note PƂƕĂPeNX`ǂݍޏꍇɎg܂B
		bVɓ\eNX`ȂǁA܂Ƃ܂ĂꍇɂMeshTextureNXȂǂg܂
		*/
		class TextureFile : public Texture, public file::File
		{
		public:
			TextureFile(const char *path) : Texture(), file::File(path) {}
			virtual ~TextureFile() {}

			virtual void OnLoaded() {
				const u8 *p(GetData());
				p += sizeof(u32); //< (u32)ǂݔ΂
				p += Read(p);
				ASSERT(static_cast<u32>(p - GetData()) == GetSize());
				//Release(); // q[v炱ŏĂ悵
			}
		};

		/*!
		\brief 񓯊Aj[VeNX`NX
		*/
		class AnimationTextureFile : public AnimationTexture, public file::File
		{
		public:
			AnimationTextureFile(const char *path) : AnimationTexture(), file::File(path), _texture_data_top(0) {}
			virtual ~AnimationTextureFile() {}

			virtual void OnLoaded() {
				const u8 *p(GetData());
				_texture_data_top = (p += sizeof(u32)); //< (u32)ǂݔ΂
				p += Read(p);
				ASSERT(static_cast<u32>(p - GetData()) == GetSize());
				//Release(); // q[v炱ŏĂ悵
			}

			QuaternionTransform GetTransform(u32 x, u32 y) const { return AnimationTexture::GetTransform(x, y, _texture_data_top); }

		protected:
			const u8 *_texture_data_top;
		};

		/*!
		\brief 񓯊L[ueNX`NX
		*/
		class CubeTextureFile : public CubeTexture, public file::File
		{
		public:
			CubeTextureFile(const char *path) : CubeTexture(), file::File(path) {}
			virtual ~CubeTextureFile() {}

			virtual void OnLoaded() {
				const u8 *p(GetData());
				p += sizeof(u32); //< (u32)ǂݔ΂
				p += Read(p);
				ASSERT(static_cast<u32>(p - GetData()) == GetSize());
				//Release(); // q[v炱ŏĂ悵
			}
		};
	}
}

#endif // TEXTURE_FILE_H