/*!
$Id: tiling.h 513 2009-11-16 08:25:50Z horino $
*/
#ifndef TILING_H
#define TILING_H

#include "indi.h"

namespace indi
{
	typedef struct U32Vector2 U32Vector2;
	struct U32Vector2 {
		U32Vector2(u32 xx, u32 yy) { x = xx; y = yy; }
		u32 x, y;
	};

	namespace graphics
	{
		class Tiling
		{
		public:

			static u32 CreateTilingRects(D3DRECT *dst, u32 w, u32 h);
			static U32Vector2 GetTileMax(D3DRECT *r, u32 n);
			static u32 GetNextMultiple(u32 val, u32 mult) { return ((val + mult - 1) / mult) * mult; }
			static U32Vector2 &AdjustTileSize(U32Vector2 &v, BOOL b);

			static u32 &GetCurrentAddress() { return _current_address; }

		private:
			static u32 _current_address;
		};
	}
}

#endif // TILING_H