/*!
$Id: file_manager.cpp 623 2009-12-17 04:07:13Z horino $
*/
#include "stdafx.h"

#define FILE_MANAGER_CPP

#ifdef _DEBUG
#include <iostream>
using namespace std;
#endif

#include "utilities.h"
#include "file/file_manager.h"
#include "file/file.h"
using namespace indi;

file::FileManager *file::FileManager::_file_manager = 0;

/*!
\brief t@Cǂݍ݃Xbh
*/
u32 file::FileManager::LoadThread(void *file)
{
	File *f(reinterpret_cast<File *>(file));
	if(f){
		//< ǂݍݒx̃G~[g
#ifdef _DEBUG
		delay();
#endif
		u64 read;
		ASSERT(ReadFile(f->GetFileHandle(), const_cast<u8 *>(f->GetData()), f->GetSize(), &read, NULL));
		ASSERT(read == f->GetSize());

		f->GetStatus() = File::Callbacked;
	}
	return 0;
}

/*!
\brief 
*/
file::FileManager::FileManager(const char *mnt, u32 n) : _mount_point(0), _file_num(n), _files(new File *[_file_num])
{
	string::AllocStrcpy(&_mount_point, mnt);
	Memzero(_files, sizeof(*_files) * _file_num);
}

/*!
\brief 
*/
file::FileManager::~FileManager()
{
	if(_files) { delete [] _files; _files = 0; }
	if(_mount_point) { delete [] _mount_point; _mount_point = 0; }
}

/*!
\brief 
*/
u32 file::FileManager::Regist(File *f) 
{		
	for(u32 i=0;i<_file_num;++i){
		if(!_files[i]){
			_files[i]->_thread_handle = CreateThread(NULL, 0, reinterpret_cast<LPTHREAD_START_ROUTINE>(LoadThread), (_files[i] = f), 0, 0);
			return i;
		}
	}

	ASSERT(0); //< WXgłȂ
	return 0xffffffff;
}

/*!
\brief 
*/
void file::FileManager::UnRegist(File *f)
{ 
	if(f && f->GetIndex() != 0xffffffff)
		_files[f->GetIndex()] = 0;
}

/*!
\brief ǂݍݏIĂt@C̃R[obN֐R[܂
*/
void file::FileManager::Update()
{
	//< tO̗Ă̂́AR[obNĂяoăXg
	for(u32 i=0;i<_file_num;++i){
		File *f(_files[i]);
		if(f){
			if(f->GetStatus() == File::Callbacked){
				f->GetStatus() = File::Loaded;
				f->OnLoaded();
				f->Close();
				file::FileManager::Get()->UnRegist(f);
			}
		}
	}
}