/*!
$Id: texture.cpp 623 2009-12-17 04:07:13Z horino $
*/
#include "stdafx.h"

#define TEXTRUE_CPP

#include <xgraphics.h>

#include "graphics/texture.h"
#include "mesh/dds_header.h"
using namespace indi;

/*!
\brief oCif[^쐬܂
*/
u32 graphics::TextureBase::Read(const u8 *data)
{
	const u8 *p(data);

	//< ʎq擾
#ifdef _DEBUG
	char ident[4];
	Strncpy(ident, reinterpret_cast<const char *>(p), sizeof(ident)); p += sizeof(ident);
	ASSERT(!Strncmp(reinterpret_cast<const char *>(ident), "DDS ", strlen("DDS "))); //< DDStH[}bgłȂ
#else
	p += 4;
#endif

	//< wb_ǂݍ݂܂
	mesh::DDSHeader header;
	Memcpy(&header, p, sizeof(header)); p += sizeof(header);
	SwapEndian(reinterpret_cast<u32 *>(&header), sizeof(header) >> 2);

	//< f[^`FbN
#ifdef _DEBUG
	header.Checker();
#endif

	//< 1sNZ̃TCY(oCgłȂărbgȂ̂ŒӁI)
	u32 pixel_byte(header._pixel_format._bitcount >> 3);
	u32 nsur((header.IsCubemap() ? 6 : 1)); //< L[u}bvȂU
	u32 nmip(math::Max(header._mipmapcount, static_cast<u32>(1)));
	for(u32 i=0;i<nsur;++i){
		u32 w(header._width);
		u32 h(header._height);
		for(u32 j=0;j<nmip;++j){
			p += pixel_byte * w * h;
			w >>= 1; w = math::Max(w, static_cast<u32>(1));
			h >>= 1; h = math::Max(h, static_cast<u32>(1));
		}
	}

	return p - data;
}

/*!
\brief ~bv}bv𖾎IɎw肷邽߃I[o[Ch`
*/
u32 graphics::Texture::Read(const u8 *data) 
{
#if 0 
	//< ~bv}bv̑SxIɍ쐬	
	u32 size(TextureBase::Read(data));
	D3DXCreateTextureFromFileInMemory(graphics::System::GetDevice(), data, size, &_texture);
	return size;
#else
	//< 摜Ɋ܂܂~bv}bvɂ̂܂܏]킹ꍇ
	const u8 *p(data);
#ifdef _DEBUG
	char ident[4];
	Strncpy(ident, reinterpret_cast<const char *>(p), sizeof(ident)); p += sizeof(ident);
	ASSERT(!Strncmp(reinterpret_cast<const char *>(ident), "DDS ", strlen("DDS "))); //< DDStH[}bgłȂ
#else
	p += 4;
#endif
	mesh::DDSHeader header;
	Memcpy(&header, p, sizeof(header)); p += sizeof(header);
	SwapEndian(reinterpret_cast<u32 *>(&header), sizeof(header) >> 2);

#ifdef _DEBUG
	header.Checker();
#endif

	//< TextureBase::Read(data)gȂ̂ŁAOŃTCYvZȂĂ͂ȂȂ
	u32 pixel_byte(header._pixel_format._bitcount >> 3);
	u32 nsur((header.IsCubemap() ? 6 : 1));
	u32 nmip(math::Max(header._mipmapcount, static_cast<u32>(1)));
	for(u32 i=0;i<nsur;++i){
		u32 w(header._width);
		u32 h(header._height);
		for(u32 j=0;j<nmip;++j){
#ifdef _DEBUG
			cout << "sur[" << i << "] mip[" << j << "]" << w << " x " << h << endl;
#endif
			p += pixel_byte * w * h;
			w >>= 1; w = math::Max(w, static_cast<u32>(1));
			h >>= 1; h = math::Max(h, static_cast<u32>(1));
		}
	}

	u32 size(p - data);
	D3DXCreateTextureFromFileInMemoryEx(graphics::System::GetDevice(), data, size, D3DX_DEFAULT, D3DX_DEFAULT, nmip, 0, D3DFMT_UNKNOWN, D3DPOOL_DEFAULT, D3DX_DEFAULT, D3DX_DEFAULT, 0, NULL, NULL, &_texture);
	return size;
#endif
}

/*!
\brief eNX`tBp̃R[obN֐
*/
static u32 _fill_width;
static u32 _fill_height;
void _fill(D3DXVECTOR4 *out, const D3DXVECTOR2 *texcoord, const D3DXVECTOR2 *texel_size, void *data)
{
	u32 x = static_cast<u32>(static_cast<f32>(_fill_width) * texcoord->x);
	u32 y = static_cast<u32>(static_cast<f32>(_fill_height) * texcoord->y);
	u32 *p(reinterpret_cast<u32 *>(data) + (x << 2) + (_fill_width << 2) * y);
	*out = D3DXVECTOR4(ToF32(*(p + 0)), ToF32(*(p + 1)), ToF32(*(p + 2)), ToF32(*(p + 3)));
	//*out = D3DXVECTOR4(ToF32(*reinterpret_cast<f16 *>(p + 0)), ToF32(*reinterpret_cast<f16 *>(p + 1)), ToF32(*reinterpret_cast<f16 *>(p + 2)), ToF32(*reinterpret_cast<f16 *>(p + 3)));
}   

/*!
\brief Aj[VeNX`̓ǂݍ
*/
u32 graphics::AnimationTexture::Read(const u8 *data)
{
	const u8 *p(data);
#ifdef _DEBUG
	char ident[4];
	Strncpy(ident, reinterpret_cast<const char *>(p), sizeof(ident)); p += sizeof(ident);
	ASSERT(!Strncmp(reinterpret_cast<const char *>(ident), "DDS ", strlen("DDS "))); //< DDStH[}bgłȂ
#else
	p += 4;
#endif

	mesh::DDSHeader header;
	Memcpy(&header, p, sizeof(header)); p += sizeof(header);
	SwapEndian(reinterpret_cast<u32 *>(&header), sizeof(header) >> 2);

	const u8 *color(p);

	u32 pixel_byte(_format == SINGLE4 ? 16 : 8); //< SINGLE4 ܂ HALF4̂ݑΉ
	u32 nsur(1);
	u32 nmip(1);
	for(u32 i=0;i<nsur;++i){
		u32 w(header._width);
		u32 h(header._height);
		for(u32 j=0;j<nmip;++j){
#ifdef _DEBUG
			cout << "sur[" << i << "] mip[" << j << "]" << w << " x " << h << endl;
#endif
			p += pixel_byte * w * h;
			w >>= 1; w = math::Max(w, static_cast<u32>(1));
			h >>= 1; h = math::Max(h, static_cast<u32>(1));
		}
	}

	ASSERT(D3D_OK == D3DXCreateTexture(graphics::System::GetDevice(), header._width, header._height, 1, 0, static_cast<D3DFORMAT>(_format), D3DPOOL_DEFAULT, &_texture));
	_fill_width = header._width;
	_fill_height = header._height;
	ASSERT(D3D_OK == D3DXFillTexture(_texture, _fill, const_cast<void *>(reinterpret_cast<const void *>(color))));

	return p - data;
}

/*!
\brief wW̃gXtH[擾܂
*/
QuaternionTransform graphics::AnimationTexture::GetTransform(u32 x, u32 y, const u8 *data) const
{
	const u8 *top(data + 4 + sizeof(mesh::DDSHeader)); //< Awb_΂擪
	const u32 *p(reinterpret_cast<const u32 *>(top) + (x << 2) + (GetWidth() << 2) * y);
	return QuaternionTransform(Quaternion(ToF32(*(p + 0)), ToF32(*(p + 1)), ToF32(*(p + 2)), ToF32(*(p + 3))), Vector3(ToF32(*(p + 4)), ToF32(*(p + 5)), ToF32(*(p + 6))));
}