/*!
$Id: vertexbuffer_specialization.cpp 416 2009-10-14 10:36:18Z horino $
*/
#include "stdafx.h"

#define VERTEXBUFFER_SPECIALIZATION_CPP

#ifdef _DEBUG
#include <iostream>
using namespace std;
#endif

#include "graphics/graphics.h"
#include "graphics/vertexbuffer.h"
using namespace indi;

/*!
\brief ev[g(VertexPosition)
*/
template<>
void graphics::VertexBuffer<graphics::VertexPosition>::CreateDeclaration() 
{
	D3DVERTEXELEMENT9 data[] = {
		{ 0,  0, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION, 0 },
		D3DDECL_END()
	};
	graphics::System::GetDevice()->CreateVertexDeclaration(data, &_declaration);
}

/*!
\brief ev[g(VertexPositionColor)
*/
template<>
void graphics::VertexBuffer<graphics::VertexPositionColor>::CreateDeclaration() 
{
	D3DVERTEXELEMENT9 data[] = {
		{ 0,  0, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION, 0 },
		{ 0,  12, D3DDECLTYPE_FLOAT4, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_COLOR, 0 },
		D3DDECL_END()
	};
	graphics::System::GetDevice()->CreateVertexDeclaration(data, &_declaration);
}

/*!
\brief ev[g(VertexPositionTexture)
*/
template<>
void graphics::VertexBuffer<graphics::VertexPositionTexture>::CreateDeclaration() 
{
	D3DVERTEXELEMENT9 data[] = {
		{ 0,  0, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION, 0 },
		{ 0,  12, D3DDECLTYPE_FLOAT2, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TEXCOORD, 0 },
		D3DDECL_END()
	};
	graphics::System::GetDevice()->CreateVertexDeclaration(data, &_declaration);
}

/*!
\brief ev[g(VertexPositionNormal)
*/
template<>
void graphics::VertexBuffer<graphics::VertexPositionNormal>::CreateDeclaration() 
{
	D3DVERTEXELEMENT9 data[] = {
		{ 0,  0, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION, 0 },
		{ 0,  12, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_NORMAL, 0 },
		D3DDECL_END()
	};
	graphics::System::GetDevice()->CreateVertexDeclaration(data, &_declaration);
}

/*!
\brief ev[g(VertexPositionNormalColor)
*/
template<>
void graphics::VertexBuffer<graphics::VertexPositionNormalColor>::CreateDeclaration() 
{
	D3DVERTEXELEMENT9 data[] = {
		{ 0,  0, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION, 0 },
		{ 0,  12, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_NORMAL, 0 },
		{ 0,  12 + 12, D3DDECLTYPE_FLOAT4, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_COLOR, 0 },
		D3DDECL_END()
	};
	graphics::System::GetDevice()->CreateVertexDeclaration(data, &_declaration);
}

/*!
\brief ev[g(VertexPositionNormalTexture)
*/
template<>
void graphics::VertexBuffer<graphics::VertexPositionNormalTexture>::CreateDeclaration() 
{
	D3DVERTEXELEMENT9 data[] = {
		{ 0,  0, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION, 0 },
		{ 0,  12, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_NORMAL, 0 },
		{ 0,  12 + 12, D3DDECLTYPE_FLOAT2, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TEXCOORD, 0 },
		D3DDECL_END()
	};
	graphics::System::GetDevice()->CreateVertexDeclaration(data, &_declaration);
}

/*!
\brief ev[g(VertexPositionNormalColorTexture)
*/
template<>
void graphics::VertexBuffer<graphics::VertexPositionNormalColorTexture>::CreateDeclaration() 
{
	D3DVERTEXELEMENT9 data[] = {
		{ 0,  0, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION, 0 },
		{ 0,  12, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_NORMAL, 0 },
		{ 0,  12 + 12, D3DDECLTYPE_FLOAT4, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_COLOR, 0 },
		{ 0,  12 + 12 + 16, D3DDECLTYPE_FLOAT2, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TEXCOORD, 0 },
		D3DDECL_END()
	};
	graphics::System::GetDevice()->CreateVertexDeclaration(data, &_declaration);
}

/*!
\brief ev[g(VertexPositionNormalIndexWeight)
*/
template<>
void graphics::VertexBuffer<graphics::VertexPositionNormalIndexWeight>::CreateDeclaration() 
{
	D3DVERTEXELEMENT9 data[] = {
		{ 0,  0, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION, 0 },
		{ 0,  12, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_NORMAL, 0 },
		{ 0,  12 + 12, D3DDECLTYPE_FLOAT4, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_BLENDINDICES, 0 },
		{ 0,  12 + 12 + 16, D3DDECLTYPE_FLOAT4, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_BLENDWEIGHT, 0 },
		D3DDECL_END()
	};
	graphics::System::GetDevice()->CreateVertexDeclaration(data, &_declaration);
}

/*!
\brief ev[g(VertexPositionNormalTextureIndexWeight)
*/
template<>
void graphics::VertexBuffer<graphics::VertexPositionNormalTextureIndexWeight>::CreateDeclaration() 
{
	D3DVERTEXELEMENT9 data[] = {
		{ 0,  0, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION, 0 },
		{ 0,  12, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_NORMAL, 0 },
		{ 0,  12 + 12, D3DDECLTYPE_FLOAT2, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TEXCOORD, 0 },
		{ 0,  12 + 12 + 8, D3DDECLTYPE_FLOAT4, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_BLENDINDICES, 0 },
		{ 0,  12 + 12 + 8 + 16, D3DDECLTYPE_FLOAT4, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_BLENDWEIGHT, 0 },
		D3DDECL_END()
	};
	graphics::System::GetDevice()->CreateVertexDeclaration(data, &_declaration);
}
