/*!
$Id: input.cpp 125 2009-07-01 07:12:23Z horino $
*/
#include "stdafx.h"

#define INPUT_CPP

#include "input/input.h"
using namespace indi;

BOOL Input::State::Update(u32 i) 
{ 
	BOOL ret(XInputGetState(i, &_state) == ERROR_SUCCESS);
	ret ? _flag.Set(VALID) : _flag.Reset(VALID);
	IsDeadzone(_state.Gamepad.sThumbLX, _state.Gamepad.sThumbLY, XINPUT_GAMEPAD_LEFT_THUMB_DEADZONE) ? _flag.Set(LS_DEADZONE) : _flag.Reset(LS_DEADZONE);
	IsDeadzone(_state.Gamepad.sThumbRX, _state.Gamepad.sThumbRY, XINPUT_GAMEPAD_RIGHT_THUMB_DEADZONE) ? _flag.Set(RS_DEADZONE) : _flag.Reset(RS_DEADZONE);
	_state.Gamepad.bLeftTrigger < XINPUT_GAMEPAD_TRIGGER_THRESHOLD ? _flag.Set(LT_DEADZONE) : _flag.Reset(LT_DEADZONE);
	_state.Gamepad.bRightTrigger < XINPUT_GAMEPAD_TRIGGER_THRESHOLD ? _flag.Set(RT_DEADZONE) : _flag.Reset(RT_DEADZONE);
	return ret;
}

#ifdef _DEBUG
/*!
\brief {^̎ނ\Ԃ܂i#ifdef _DEBUĜ݁j
\param {^̎
\return {^̎ނ\
*/
char *Input::State::KindString(Kind k) 
{
	static char *tbl[] = {
#define PADASSIGN(id, xinput) #id, 
#include "input/input.h"
#undef PADASSIGN
	};
	return tbl[k];
}
#endif

/*!
\brief {^̎ނ̂ƂXinputlԂ܂
\param {^̎
\return Xinputl
*/
u32 Input::State::Xinput(Kind k)
{
	static u32 tbl[] = {
#define PADASSIGN(id, xinput) xinput, 
#include "input/input.h"
#undef PADASSIGN
	};
	return tbl[k];
}

void Input::Update()
{
	for(u32 i = 0;i < NELEMS(_state);++i){
		indi::Memcpy(reinterpret_cast<void *>(&_state[i][1]), reinterpret_cast<void *>(&_state[i][0]), sizeof(_state[i][1]));
		indi::Memzero(reinterpret_cast<void *>(&_state[i][0]), sizeof(_state[i][0]));
		_state[i][0].Update(i);
	}
}
