/*!
$Id: matrix44.cpp 632 2009-12-22 06:51:16Z horino $
*/
#include "stdafx.h"

#define MATRIX44_CPP

#include "vector2.h"
#include "vector3.h"
#include "vector4.h"
#include "quaternion.h"
#include "matrix44.h"
#include "graphics/graphics.h"

using namespace indi;

Matrix44::Matrix44(const Quaternion &q) { D3DXMATRIX m;  D3DXMatrixRotationQuaternion(&_e, q); }

Matrix44 Matrix44::LookAt(const Vector3 &pos, const Vector3 &tag, const Vector3 &up){ D3DXMATRIX m; return Matrix44(*D3DXMatrixLookAtRH(&m, pos, tag, up)); }
Matrix44 Matrix44::Rotation(const Vector3 &v3, f32 rad) { D3DXMATRIX m; return Matrix44(D3DXMatrixRotationAxis(&m, v3, rad)); }
Matrix44 Matrix44::Scale(const Vector2 &s) { return Scale(s.X(), s.Y(), 1.0f); }
Matrix44 Matrix44::Scale(const Vector3 &s) { return Scale(s.X(), s.Y(), s.Z()); }
Matrix44 Matrix44::Translation(const Vector3 &t) { return Translation(t.X(), t.Y(), t.Z()); }
